/* dsimq.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void dsimq_(doublereal *a, doublereal *b, shortint *n, shortint *ks)
{
    /* System generated locals */
    int s__1, s__2, s__3;
    doublereal d__1;

    /* Local variables */
    doublereal biga, save;
    int imax, i, j, i1, i2, ij, jj, it, ix, jx, jy;
    doublereal tol;

    /* Parameter adjustments */
    --b;
    --a;

    /* Function Body */
    tol = 0.;
    *ks = 0;
    jj = -(*n);
    s__1 = *n;
    for (j = 1; j <= s__1; ++j) {
	jy = j + 1;
	jj = jj + *n + 1;
	biga = 0.;
	it = jj - j;
	s__2 = *n;
	for (i = j; i <= s__2; ++i) {
	    ij = it + i;
	    if (fabs(biga) - (d__1 = a[ij], fabs(d__1)) >= 0.) {
		goto L30;
	    } else {
		goto L20;
	    }
L20:
	    biga = a[ij];
	    imax = i;
L30:
	    ;
	}
	if (fabs(biga) - tol <= 0.) {
	    goto L35;
	} else {
	    goto L40;
	}
L35:
	*ks = 1;
	return;
L40:
	i1 = j + *n * (j - 2);
	it = imax - j;
	s__2 = *n;
	for (i = j; i <= s__2; ++i) {
	    i1 += *n;
	    i2 = i1 + it;
	    save = a[i1];
	    a[i1] = a[i2];
	    a[i2] = save;
/* L50: */
	    a[i1] /= biga;
	}
	save = b[imax];
	b[imax] = b[j];
	b[j] = save / biga;
	if (j - *n != 0) {
	    goto L55;
	} else {
	    goto L70;
	}
L55:
	i = *n * (j - 1);
	s__2 = *n;
	for (ix = jy; ix <= s__2; ++ix) {
	    i1 = i + ix;
	    it = j - ix;
	    s__3 = *n;
	    for (jx = jy; jx <= s__3; ++jx) {
		ij = *n * (jx - 1) + ix;
		i2 = ij + it;
/* L60: */
		a[ij] -= a[i1] * a[i2];
	    }
/* L65: */
	    b[ix] -= b[j] * a[i1];
	}
    }
L70:
    jy = *n - 1;
    it = *n * *n;
    s__2 = jy;
    for (j = 1; j <= s__2; ++j) {
	i = it - j;
	i1 = *n - j;
	i2 = *n;
	s__1 = j;
	for (jj = 1; jj <= s__1; ++jj) {
	    b[i1] -= a[i] * b[i2];
	    i -= *n;
/* L80: */
	    --i2;
	}
    }
    return;
} /* dsimq_ */

