/* ortg2.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void ortg2_(shortint *n, shortint *na, doublereal *z)
{
    /* System generated locals */
    int s__1, s__2;
    integer z_dim1, z_offset;
    doublereal d__1;

    /* Local variables */
    int i, j, l;
    doublereal r;
    int i1, i2;
    doublereal r1, r2, r3, r4;


/*   COMPUTING BASIS IN A SUBSPACE ORTHOGONAL TO TWO GIVEN VECTORS */
/*           23.06.81 */
/*     Rev.  25.07.92 */
/*           17.11.92 */

    /* Parameter adjustments */
    z_dim1 = *na;
    z_offset = z_dim1 + 1;
    z -= z_offset;

    /* Function Body */
    r1 = 0.;
    r2 = 0.;
    r3 = 0.;
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
/* Computing 2nd power */
	d__1 = z[i + z_dim1];
	r1 += d__1 * d__1;
/* Computing 2nd power */
	d__1 = z[i + (z_dim1 << 1)];
	r2 += d__1 * d__1;
	r3 += z[i + z_dim1] * z[i + (z_dim1 << 1)];
/* L10: */
    }
    r1 = 1. / sqrt(r1);
    r2 = 1. / sqrt(r2);
    r3 = r3 * r1 * r2;
    r4 = 1. / (1. - r3 * r3);
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
	z[i + z_dim1] = r1 * z[i + z_dim1];
	z[i + (z_dim1 << 1)] = r2 * z[i + (z_dim1 << 1)];
/* L20: */
    }
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
	s__2 = *n;
	for (j = 3; j <= s__2; ++j) {
/* L30: */
	    z[i + j * z_dim1] = 0.;
	}
/* L40: */
    }
    i1 = 1;
    r1 = (d__1 = z[z_dim1 + 1], fabs(d__1));
    s__1 = *n;
    for (i = 2; i <= s__1; ++i) {
	r = (d__1 = z[i + z_dim1], fabs(d__1));
	if (r <= r1) {
	    goto L43;
	}
	r1 = r;
	i1 = i;
L43:
	;
    }

    r2 = z[i1 + (z_dim1 << 1)] / z[i1 + z_dim1];
    r1 = (d__1 = z[(z_dim1 << 1) + 1] - r2 * z[z_dim1 + 1], fabs(d__1));
    i2 = 1;
    s__1 = *n;
    for (i = 2; i <= s__1; ++i) {
	r = (d__1 = z[i + (z_dim1 << 1)] - r2 * z[i + z_dim1], fabs(d__1));
	if (r <= r1) {
	    goto L44;
	}
	r1 = r;
	i2 = i;
L44:
	;
    }
    l = 3;
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
	if ((i - i1) * (i - i2) == 0) {
	    goto L60;
	}
	z[i + l * z_dim1] = 1.;
	r1 = (z[i + z_dim1] - z[i + (z_dim1 << 1)] * r3) * r4;
	r2 = (z[i + (z_dim1 << 1)] - z[i + z_dim1] * r3) * r4;
	s__2 = *n;
	for (j = 1; j <= s__2; ++j) {
/* L50: */
	    z[j + l * z_dim1] = z[j + l * z_dim1] - r1 * z[j + z_dim1] - r2 * 
		    z[j + (z_dim1 << 1)];
	}
	++l;
L60:
	;
    }
    return;
} /* ortg2_ */

