/* plo.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void plo_(shortint *n, doublereal *a, doublereal *al, doublereal *bet, doublereal *x, doublereal *y, shortint *na, doublereal *eps, shortint *ier)
{
    /* System generated locals */
    int s__1, s__2;
    integer a_dim1, a_offset;
    doublereal d__1;

    /* Local variables */
    shortint icol[NFMAX*2], irow[NFMAX*2];
    int i, j, k;
    doublereal r, s, z[NFMAX*2];
    shortint irank;
    doublereal a1, b1;
    shortint k1, n2, n3, n4;
    doublereal r1, r2, r3, r4, r5;

    static struct {
      doublereal dumm1[NFMAX*NFMAX*2], dumm2[NFMAX*NFMAX*2], b[NFMAX*NFMAX*4];
    } work2_;
#define work2_1 work2_


/*   By~iClEHiE dBuMEPHOj iHBAPiAHTHOj plOCKOCTi */
/*       ABTOPy - P.M.bOPiC`K, A.i.XibHiK      BEPCiq OT 23.06.81 */
/* --------------------------------------------------------------- */
/*     14.11.92 */
/* --------------------------------------------------------------- */


/*   pPOgPAMMA HAXOdiT iHBAPiAHTHu` plOCKOCTx, */
/*   OTBE~A`}u` CObCTBEHHOMu zHA~EHi`  AL+I*BET . */
/*   iCKOMyE BEKTOPA X i Y udOBlETBOPq`T uPABHEHiqM: */
/*     A*X=AL*X+BET*Y */
/*     A*Y=-BET*X+AL*Y */
/*     (X,X)*(Y,Y)=1 */
/*     (X,Y)=0 */

    /* Parameter adjustments */
    --y;
    --x;
    a_dim1 = *na;
    a_offset = a_dim1 + 1;
    a -= a_offset;

    /* Function Body */
    k = 0;
    n2 = *n + *n;
    n3 = n2 - 2;
    s__1 = *n;
    for (j = 1; j <= s__1; ++j) {
	s__2 = *n;
	for (i = 1; i <= s__2; ++i) {
	    ++k;
	    work2_1.b[k - 1] = a[i + j * a_dim1];
	    if (i == j) {
		work2_1.b[k - 1] -= *al;
	    }
/* L1: */
	}
	s__2 = *n;
	for (i = 1; i <= s__2; ++i) {
	    ++k;
	    work2_1.b[k - 1] = 0.;
	    if (i == j) {
		work2_1.b[k - 1] = *bet;
	    }
/* L2: */
	}
/* L3: */
    }
    s__1 = *n;
    for (j = 1; j <= s__1; ++j) {
	s__2 = *n;
	for (i = 1; i <= s__2; ++i) {
	    ++k;
	    work2_1.b[k - 1] = 0.;
	    if (i == j) {
		work2_1.b[k - 1] = -(*bet);
	    }
/* L4: */
	}
	s__2 = *n;
	for (i = 1; i <= s__2; ++i) {
	    ++k;
	    work2_1.b[k - 1] = a[i + j * a_dim1];
	    if (i == j) {
		work2_1.b[k - 1] -= *al;
	    }
/* L5: */
	}
/* L6: */
    }

    n4 = n2 * n2;
    dmfgr_(work2_1.b, &n2, &n2, eps, &irank, irow, icol);
    if (irank != n3) {
	goto L12;
    }
    z[icol[n2 - 1] - 1] = 1.;
    z[icol[n2 - 2] - 1] = 1.;
    s__1 = n3;
    for (i = 1; i <= s__1; ++i) {
	k = n2 * n3 + i;
	k1 = k + n2;
/* L7: */
	z[icol[i - 1] - 1] = work2_1.b[k - 1] + work2_1.b[k1 - 1];
    }
    *ier = 0;

/*   HOPMiPOBKA i OPTOgOHAlizAciq HAjdEHHyX BEKTOPOB */

    r1 = 0.;
    r2 = 0.;
    r3 = 0.;
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
/* Computing 2nd power */
	d__1 = z[i - 1];
	r1 += d__1 * d__1;
/* Computing 2nd power */
	d__1 = z[*n + i - 1];
	r2 += d__1 * d__1;
	r3 += z[*n + i - 1] * z[i - 1];
/* L8: */
    }
    s = 0.;
    if (fabs(r3) < 1e-10) {
	goto L9;
    }
    r = (r1 - r2) / r3;
    s = (-r + sqrt(r * r + 4.)) / 2.;
L9:
    r4 = r1 + r3 * 2. * s + r2 * s * s;
    r5 = r2 - r3 * 2. * s + r1 * s * s;
    a1 = sqrt(sqrt(1. / (r4 * r5)));
    b1 = a1 * s;
    if (r4 >= r5) {
	goto L10;
    }
    r = a1;
    a1 = -b1;
    b1 = r;
L10:
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
	x[i] = a1 * z[i - 1] + b1 * z[*n + i - 1];
	y[i] = -b1 * z[i - 1] + a1 * z[*n + i - 1];
/* L11: */
    }
    return;
L12:
    *ier = 1;
/*     PRINT 101,IRANK */
/* 101  FORMAT(/3X,'iHBAPiAHTHAq plOCKOCTx HE HAjdEHA',/5X,'IRANK=',I3) */
    return;
} /* plo_ */

