/* extr.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>


/* Table of constant values */

static shortint cs__NDIM = NDIM;

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */

void extr_(shortint *istep, shortint *nx, shortint *ndimm, shortint *ng, shortint *ncan, shortint *nue, shortint *ivars, shortint *ipre, doublereal *stx2, doublereal *eps, void (*fun) (doublereal *, doublereal *, shortint *, shortint *), void (*dfdx) (doublereal *, doublereal *, shortint *, shortint *, shortint *, shortint *), void (*out) (shortint *, shortint *, shortint *, shortint *, doublereal *, doublereal *, doublereal *, shortint *), doublereal *dfun, shortint *istop)
{
    /* System generated locals */
    shortint s__1, s__2, s__3;
    doublereal d__1;

    /* Local variables */
    static doublereal xabd[NDIM];
    static shortint ivar, iter, iext, next, iwrt;
    static doublereal xext[NDIM], done1, done2, fext1, fext2, fext3;
    static shortint i, index[NPTYP], itmax;
    static doublereal fnext[NDIM];
    static shortint nfixr;
    static doublereal r1, r2, x1[NDIM], x2[NDIM], dmove1, df, vmove1[NDIM], vmove2[
	    NDIM], vmove3[NDIM], fn;
    static shortint it, indloc, infloc;
    static doublereal rx;
    static doublereal dmover;
    static shortint iprtcl, ier, ipr;
    static doublereal stv1[NDIM], stx1[NDIM];

    static struct out5__ {
      doublereal epsext, epser;
    } out5_;
#define out5_1 out5_


/*     3.05.90. */
/*     5.08.1991 */
/*     13.11.92 */
/*     15.06.94 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* *                                                                     *
 */
/* *    POPAMMA  EXTR  PEHAHAEHA  TOHEH TOEK KCTPEMMA    *
 */
/* *    AAHHX EPEMEHHX HA KPBO. CTAETC, TO EPEMEHHA         *
 */
/* *    OCTA CBOEO KCTPEMAHOO HAEH, EC COOTBETCTBA    *
 */
/* *    KOMOHEHTA KACATEHOO BEKTOPA OPATAC B HO.               *
 */
/* *     A P A M E T P :                                               *
 */
/* *    ==================                                               *
 */
/* *    ISTEP -CO POEAHHX AOB BO KPBO.                     *
 */
/* *    NX    -PAMEPHOCT POCTPAHCTBA EPEMEHHX.                      *
 */
/* *    NDIM  -ABEHHA CTOHA PAMEPHOCT MATP DFUN.              *
 */
/* *    NG    -HOMEP BEEHHO EPEMEHHO.                              *
 */
/* *    NCAN  -HOMEP KAHAA BBOA PETATOB.                          *
 */
/* *    NUE   -CO EPEMEHHX, AHAPEMX HA KCTPEMM.             *
 */
/* *    IVARS -MACCB HOMEPOB AHAPEMX EPEMEHHX.                  *
 */
/* *    STX2  -KOOPHAT TEKE TOK HA KPBO.                       *
 */
/* *    EPS   -TOHOCT METOA HTOHA.                                  *
 */
/* *    IPRE  -PHAK OPOHOCT EAT (CM.OCAHE APAMETPOB BEETLE.*
 */
/* *    FUN   -M POPAMM BCEH BEKTOP-HK.                  *
 */
/* *    DFDX  -M POPAMM BCEH MATP KO O BHM OPMAM. *
 */
/* *    DFUN  -MACCB, COEPA MATP ACTHX POBOHX.           *
 */
/* *    IER   -PHAK OKOHAH POPAMM (OKA H HA TO HE BET).   *
 */
/* *    ISTOP -PEPBAHE PAOT POPAMM OOBATEEM.                *
 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* *    P MEHEH MAKCMAHOO CA EPEMEHHX-NDIM, HEOXOMO    *
 */
/* *    MEHT PAMEPHOCT MACCBOB:                                   *
 */
/* *    XEXT(*) STX1(*) STV1(*) XABD(*) X1(*) X2(*) VMOVE1(*) VMOVE2(*)  *
 */
/* *    VMOVE(*)        STV2(*)                                          *
 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */





    /* Parameter adjustments */
    dfun -= (NDIM+1);
    --ivars;
    --stx2;

    /* Function Body */
    *istop = 0;
    if (*nue == 0) {
	return;
    }
    if (*istep == 0) {
	goto L400;
    }
    for (i = 1; i <= NPTYP; ++i) {
	index[i - 1] = 0;
/* L100: */
    }
    wrto4_1.epsc = *eps;
    out5_1.epsext = add4b_1.epsext;
    itmax = 10;
    done1 = dmove1 / fabs(dmove1);
    done2 = wrto2_1.dmove / fabs(wrto2_1.dmove);

/* .... K POBEPK HA KCTPEMM BCEX EPEMEHHX. */
/*     KOOPHATA  XEXT(NFIX1)  HE POBEPETC. */

    s__1 = *nue;
    for (ivar = 1; ivar <= s__1; ++ivar) {
	out6_1.inde = 0;
	next = ivars[ivar];
	if (next == wrto1_1.nfix1) {
	    goto L380;
	}

/* .... OOTOBKA PAOX MACCBOB. */

	s__2 = *nx;
	for (i = 1; i <= s__2; ++i) {
	    x1[i - 1] = stx1[i - 1];
	    x2[i - 1] = stx2[i];
	    vmove1[i - 1] = stv1[i - 1];
	    vmove2[i - 1] = wrto7_1.vmove[i - 1];
/* L200: */
	}

/* .... POBEPKA COB KCTPEMMA. */

	fext1 = done1 * vmove1[next - 1];
	fext2 = done2 * vmove2[next - 1];
	if (fext1 * fext2 > 0.) {
	    goto L370;
	}
	df = (d__1 = (fext1 - fext2) / (x1[wrto1_1.nfix1 - 1] - x2[
		wrto1_1.nfix1 - 1]), fabs(d__1));
	if (df < out5_1.epsext * .1) {
	    goto L370;
	}
	infloc = 0;

/* .... OPEEEHE XAPAKTEPA KCTPEMMA: */
/*                   IEXT = 1 -OCTAETC MAKCMM; */
/*                   IEXT =-1 -OCTAETC MHMM; */

	iext = 1;
	if (fext1 <= 0. || fext2 >= 0.) {
	    iext = -1;
	}

/* .... K TOHEH KOOPHAT KCTPEMMA  XEXT(NEXT). */

	s__2 = itmax;
	for (iter = 1; iter <= s__2; ++iter) {

/* .... POHO H KOMOHEHT VMOVE(NEXT) KACATEHOO BEKTOPA. 
*/

L205:
	    if (indloc == 0) {
		rx = fext2 / (fext2 - fext1);
	    }
	    if (indloc == 1) {
		rx = .5;
	    }
	    if (indloc == 2) {
		rx = .44444444444444442;
	    }

	    s__3 = *nx;
	    for (i = 1; i <= s__3; ++i) {
		xext[i - 1] = x2[i - 1] - (x2[i - 1] - x1[i - 1]) * rx;
/* L210: */
	    }
	    it = wrto6_1.itc;
	    ipr = 0;
	    ier = 0;
	    newtn_(nx, &cs__NDIM, ng, &wrto1_1.nfix1, ncan, xext, eps, &
		    wrto4_1.epsn, &it, &ipr, fun, dfdx, &dfun[(NDIM+1)], &ier, 
		    istop);
	    if (*istop != 0) {
		return;
	    }
	    if (ier == 0) {
		goto L220;
	    }
	    ++indloc;
	    if (indloc <= 2) {
		goto L205;
	    }

/* .... HE COC HTOHOBCKE TEPA:TOHEHE TOK KCTPEMM
A */
/*     PEKPAAETC. */

L215:
	    iwrt = 1 - ier;
	    goto L230;
L220:
	    r1 = 0.;
	    r2 = 0.;
	    s__3 = *nx;
	    for (i = 1; i <= s__3; ++i) {
		r1 += (xext[i - 1] - stx1[i - 1]) * (stx2[i] - stx1[i - 1]);
		r2 += (xext[i - 1] - stx2[i]) * (stx2[i] - stx1[i - 1]);
/* L225: */
	    }
	    if (r1 * r2 > 0.) {
		goto L215;
	    }

	    ier = 0;
	    tangnt_(nx, &cs__NDIM, &wrto1_1.nfix1, xext, fnext, vmove3, fun, 
		    dfdx, &dfun[(NDIM+1)], &ier, istop);
	    if (*istop != 0) {
		return;
	    }
	    if (ier == 0) {
		goto L290;
	    }
	    ++indloc;
	    if (indloc <= 2) {
		goto L205;
	    }

/* .... HE HAEH KACATEH BEKTOP:TOHEHE TOK KCTPEMMA */
/*     PEKPAAETC. */

	    iwrt = 5 - ier;
L230:
	    s__3 = *nx;
	    for (i = 1; i <= s__3; ++i) {
		xabd[i - 1] = xext[i - 1];
/* L235: */
	    }

/* .... BEPEM TOK HA KPBO, A K TOKE KCTPEMMA. */

	    if (fabs(fext1) > fabs(fext2)) {
		goto L250;
	    }
	    fext3 = fext1;
	    s__3 = *nx;
	    for (i = 1; i <= s__3; ++i) {
		xext[i - 1] = x1[i - 1];
		vmove3[i - 1] = vmove1[i - 1];
/* L240: */
	    }
	    goto L270;
L250:
	    fext3 = fext2;
	    s__3 = *nx;
	    for (i = 1; i <= s__3; ++i) {
		xext[i - 1] = x2[i - 1];
		vmove3[i - 1] = vmove2[i - 1];
/* L260: */
	    }
L270:

/* .... KOHTPO TOHOCT B TOKE, AE K TOKE KCTPEMMA. 
*/

	    out5_1.epser = (d__1 = x2[wrto1_1.nfix1 - 1] - x1[wrto1_1.nfix1 - 
		    1], fabs(d__1));

/* .... OOTOBM AHHE  POPAMM   WRTOUT. */

	    dmover = wrto2_1.dmove;
	    nfixr = wrto1_1.nfix;
	    wrto2_1.dmove = dmove1;
	    wrto1_1.nfix = wrto1_1.nfix1;
	    iprtcl = 3;
	    wrto2_1.dmove = dmover;
	    wrto1_1.nfix = nfixr;
	    out6_1.inde = -1;
	    goto L365;
L290:

/* .... OPABM TOHEM KOMOHEHT KACATEHOO BEKTOPA. */

	    fext3 = done1 * vmove3[next - 1];

/* .... BOP TOEK, AX K TOKE KCTPEMMA. */

	    if (fext1 * fext3 < 0.) {
		goto L310;
	    }
	    fext1 = fext3;
	    s__3 = *nx;
	    for (i = 1; i <= s__3; ++i) {
		x1[i - 1] = xext[i - 1];
		vmove1[i - 1] = vmove3[i - 1];
/* L300: */
	    }
	    goto L330;
L310:
	    fext2 = fext3;
	    s__3 = *nx;
	    for (i = 1; i <= s__3; ++i) {
		x2[i - 1] = xext[i - 1];
		vmove2[i - 1] = vmove3[i - 1];
/* L320: */
	    }
L330:

/* .... KOHTPO OCTHTO TOHOCT. */

	    out5_1.epser = (d__1 = x2[wrto1_1.nfix1 - 1] - x1[wrto1_1.nfix1 - 
		    1], fabs(d__1));
	    df = (d__1 = (fext1 - fext2) / (x1[wrto1_1.nfix1 - 1] - x2[
		    wrto1_1.nfix1 - 1]), fabs(d__1));
	    fn = (d__1 = fext3 / df, fabs(d__1));
	    if (out5_1.epser <= out5_1.epsext || fn <= out5_1.epsext * .1) {
		goto L360;
	    }
/* L350: */
	}

	out6_1.inde = -1;
	iter = itmax;
	iprtcl = 2;
	goto L362;
L360:

	iprtcl = 1;
L362:
L365:

	index[3] = next * iext;
	(*out)(istep, index, nx, &cs__NDIM, xext, vmove3, &dfun[(NDIM+1)], istop);
	if (*istop != 0) {
	    return;
	}
L370:
L380:
/* L390: */
	;
    }
L400:

    dmove1 = wrto2_1.dmove;
    s__1 = *nx;
    for (i = 1; i <= s__1; ++i) {
	stx1[i - 1] = stx2[i];
	stv1[i - 1] = wrto7_1.vmove[i - 1];
/* L410: */
    }
    return;
} /* extr_ */

