/* jacob.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"


/* Table of constant values */

static shortint cs__84 = NDIM;

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
/* Subroutine */ void jacob_(shortint *nx, shortint *ndimm, doublereal *x0, void (*fun) (doublereal*, doublereal*, shortint*, shortint*), void (*dfdx) (/* ??? */), doublereal *dfun, doublereal *bmas, shortint *ier, shortint *istop)
                     
               
/* Subroutine */                           
                        
                      
{
    /* System generated locals */
    shortint s__1, s__2;

    /* Local variables */
    doublereal dmas[NDIM-1];
    shortint nfun, i, j;

/*     3.05.90. */
/*     13.11.92 */
/*     15.06.94 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* *                                                                     *
 */
/* *       POPAMMA JACOB PEHAHAEHA  BCEH MATP ACTHX  *
 */
/* *       POBOHX. POBOHE BCTC CEHHO              *
 */
/* *       AHATECK, B ABCMOCT OT EAH OOBATE.          *
 */
/* *                                                                     *
 */
/* *       APAMETP:                                                    *
 */
/* *       =========                                                     *
 */
/* *                                                                     *
 */
/* *  NX    -PAMEPHOCT POCTPAHCTBA EPEMEHHX (X(1),...,X(NX)).       *
 */
/* *  NDIM  -ABEHHA CTPOHA PAMEPHOCT MATP DFUN.               *
 */
/* *  X0    -KOOPHAT TOK, B KOTOPO BCETC KOAH.            *
 */
/* *  FUN   -M OPOPAMM HK.                                    *
 */
/* *  DFDX  -M POPAMM BCEH MATP ACTHX POBOHX.       *
 */
/* *  DFUN  -MACCB BCEHHX ACTHX POBOHX, DFUN=DFUN(NFUN,NX). *
 */
/* *  BMAS  -HA BXOE -MACCB HAEH HK B TOKE X0: BMAS =F(X0).  *
 */
/* *  IER   -APAMETP OK:  IER = 0- BCEH BCE POBOHE;       *
 */
/* *                           IER < 0- KOAH HE BCEH.             *
 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* *  P MEHEH MAKCMAHOO CA EPEMEHHX (NDIM) HEOXOMO     *
 */
/* *  MEHT PAMEPHOCT MACCBA:  DMAS(NDIM-1).                       *
 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

    /* Parameter adjustments */
    dfun -= (NDIM+1);
    --x0;
    --bmas;

    /* Function Body */
    nfun = *nx - 1;
    *ier = 0;
    *istop = 0;

/* .... OPMPEM MATP EPBX POBOHX - DFUN. */

    if (dern1_1.dx < 0.) {
	goto L130;
    }
    s__1 = *nx;
    for (j = 1; j <= s__1; ++j) {
	*ier = 0;
	dern_(&nfun, nx, &j, &x0[1], &bmas[1], dmas, fun, ier, istop);
	if (*istop != 0) {
	    return;
	}
	if (*ier == 0) {
	    goto L104;
	}
	*ier = -4;
	return;
L104:
	s__2 = nfun;
	for (i = 1; i <= s__2; ++i) {
	    dfun[i + j * NDIM] = dmas[i - 1];
/* L118: */
	}
/* L120: */
    }
    return;
L130:
    *ier = 0;
    (*dfdx)(&x0[1], &dfun[NDIM+1], &cs__84, nx, ier, istop);
    if (*istop != 0) {
	return;
    }
    if (*ier != 0) {
	*ier = -4;
    }
    return;
} /* jacob_ */

