/* leqv.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>


/* Table of constant values */

static shortint cs__84 = NDIM;

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
/* Subroutine */ void leqv_(doublereal *a, doublereal *b, shortint *ndimm, shortint *nx, shortint *ier)
{
    /* System generated locals */
    shortint s__1;

    /* Local variables */
    shortint ipvt[NDIM];
    doublereal work[NDIM];
    shortint i;
    doublereal condp1;

/*     3.05.90. */
/*     13.11.92 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* *                                                                     *
 */
/* *    POPAMMA  LEQV  PEHAHAEHA  CTKOBK POPAMM            *
 */
/* *    BEETLE  C POPAMMAM PEEH HEHHX CCTEM                   *
 */
/* *                                                                     *
 */
/* *                     DECOMP    SOLVE .                              *
 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* *    P MEHEH MAKCMAHOO CA  NDIM EPEMEHHX HEOXOMO    *
 */
/* *    MEHT PAMEPHOCT MACCBOB: IPVT(*) WORK(*).                  *
 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

/* !!!  DIMENSION A(NDIM,NX), B(1), IPVT(25), WORK(25) */

/* ******************* ࠢ塞  ********************* */
/* CCCC COMMON /ALL2/  DETSTP */
/* ******************* ࠢ塞  ********************* */

/*      WRITE (6,*) ' LEQV:  DET=',DET,'  DETL=',DETL */

/* .... OEHM OCOBEHHOCT (COND) MATP A */
/*     BCM OPEETE MATP (DET). */

    /* Parameter adjustments */
    --b;
    a -= (NDIM+1);

    /* Function Body */
    decomp_(&cs__84, nx, &a[NDIM+1], &leqv1_1.condl, ipvt, work);

    if (add1a_1.ipr < 1 && add2a_1.icrs == 0) {
	goto L135;
    }

/* .... BCEHE OPEETE MATP A. */

    leqv1_1.detl = (doublereal) ipvt[*nx - 1];
    s__1 = *nx;
    for (i = 1; i <= s__1; ++i) {
	leqv1_1.detl *= a[i + i * NDIM];
/* L130: */
    }
    corr1_1.det = leqv1_1.detl;
    corr1_1.cond = leqv1_1.condl;
    if (fabs(leqv1_1.detl) <= all4_1.detstp) {
	goto L140;
    }
L135:
    condp1 = leqv1_1.condl + 1.;
    if (condp1 == leqv1_1.condl) {
	goto L140;
    }

/* .... PEM HEH CCTEM  A*X=B */

    solve_(&cs__84, nx, &a[NDIM+1], &b[1], ipvt);
    *ier = 0;
/*      WRITE (6,*) ' LEQV:  DET=',DET,'  DETL=',DETL */
    return;
L140:
    *ier = -1;
} /* leqv_ */

