/* poisk.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"


/* Table of constant values */

static shortint cs__84 = NDIM;

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void poisk_(shortint *nx, shortint *nfix, shortint *ncan, shortint *ipr, doublereal *x0, doublereal *eps, void (*fun) (doublereal*, doublereal*, shortint*, shortint*), void (*dfdx) (doublereal*, doublereal*, shortint*, shortint*, shortint*, shortint*), shortint *ier, shortint *istop)
                                 
                     
/* Subroutine */                           
                      
{
    /* System generated locals */
    shortint s__1, s__2, s__3, s__4;

    /* Local variables */
    shortint iend, mend, nend, iern, ierr;
    doublereal epsn, xold[NDIM];
    shortint nfun;
    doublereal funs[NDIM-1], x0new;
    shortint i, j, k, l;
    doublereal delta;
    shortint ng, ml;
    doublereal xc;
    shortint it, mr;
    doublereal xbound, dx0;
    shortint ind, ndr;

/*     3.05.90. */
/*     13.11.92 */
/*     15.06.94 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* *                                                                     *
 */
/* *    POPAMMA  POISK  PEHAHAEHA  TOHEH EPBO TOK HA    *
 */
/* * KPBO O AAHHOM HAAHOM PEH. CTPATE TOHEH     *
 */
/* * OEH POCTA:OACT MEHEH BEEHHO EPEMEHHO X(NG)          *
 */
/* * OKPBAETC CETKO C HEKOTOPM AOM. CT X0<1>,X0<2>,...,X0<M>-  *
 */
/* *  CETK. HAHA C HEKOTOPOO A X0<K>=X0(NG) EPEPATC     *
 */
/* * BCE  B CEEM OPKE:X0<K>,X0<K-1>,X0<K+1>,X0<K-2>  T..   *
 */
/* * PEM B KAOM "E" POBOTC EPEOP BCEBOMOHX            *
 */
/* * EPOCKOCTE CCKA O TEX OP OKA TOKA HA KPBO HE ET     *
 */
/* * HAEHA, O HE POBEPTC BCE "" CETK O EPEMEHHO X(NG).   *
 */
/* * . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . *
 */
/* *                                                                     *
 */
/* *    CCOK OPMAHX APAMETPOB:                                    *
 */
/* *                                                                     *
 */
/* *    NX   -PAMEPHOCT POCTPAHCTBA EPEMEHHX.                       *
 */
/* *    NFIX -HA BXOE B POPAMM - HOMEP BEEHO EPEMEHHO;         *
 */
/* *          HA BXOE-HOMEP KCPOBAHHO EPEMEHHO TOHEHHO TOK. *
 */
/* *    X0   -HAAHOE PEHHE K EPBO TOKE HA KPBO.           *
 */
/* *          (HA BXOE  POPAMM KOOPHAT TOHEHHO TOK)       *
 */
/* *    EPS  -TOHOCT OPEEEH TOK HA KPBO.                      *
 */
/* *    FUN  -M OPOPAMM HK.                                  *
 */
/* *    DFDX -M POPAMM BCEH MATP ACTHX   PBOHX;     *
 */
/* *    IER  -KO BOBPATA (IER=0 -COOTBETCTBET HOPMAHOM             *
 */
/* *                        ABEPEH PAOT POPAMM).                *
 */
/* *    ISTOP-                                                           *
 */
/* * ................................................................... *
 */
/* *    BBAEME OPOPAMM: NEWTN.                                  *
 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* * P MEHEH MAKCMAHOO CA EPEMEHHX NDIM -HEOXOMO ME- *
 */
/* * HT PAMEPHOCT MACCBOB XOLD(NDIM),DFUN(NDIM,NDIM),FUNS(NDIM-1)  *
 */
/* * HAEHE APAMETPA NDIM.                                            *
 */
/* ***********************************************************************
 */



    /* Parameter adjustments */
    --x0;

    /* Function Body */
    *istop = 0;
    cnwt1_1.ipnt1 = 1;

/* .... OPEEEHE BCOMOATEHX APAMETPOB. */

    ng = *nfix;
    nfun = *nx - 1;
    s__1 = *nx;
    for (i = 1; i <= s__1; ++i) {
	xold[i - 1] = x0[i];
/* L100: */
    }
    delta = (add5a_1.pxgmx - add5a_1.pxgmn) * .1;
    xc = x0[ng];

    if (delta != 0.) {
	goto L105;
    }
    mend = 1;
    ind = -1;
    goto L108;
L105:

    ml = (shortint) ((xc - add5a_1.pxgmn) / delta + 2);
    mr = (shortint) ((add5a_1.pxgmx - xc) / delta + 2);
    mend = max(ml,mr);
    ind = -1;
    if (ml > mr) {
	ind = 1;
    }

L108:

    ndr = 2;
    iend = 0;

/* .... O K  POXOEH HTEPBAA (PXGMN,PXGMX) C AOM DELTA. 
*/

    s__1 = mend;
    for (i = 1; i <= s__1; ++i) {
	nend = ndr;
	if (i == 1) {
	    nend = 1;
	}
	dx0 = (i - 1) * delta;

/* .... K TOHEH TOK HA KPBO P PAHX HAEHX X0(NG) 
*/
/*      HTEPBAA (PXGMN,PXGMX) (O PAHM HAPABEHM CCKA P
 */
/*     KAOM HAEH X0(NG)). */

	s__2 = nend;
	for (j = 1; j <= s__2; ++j) {
	    x0new = xc + dx0 * ind;
	    if (all3_1.ibnd == 0) {
		goto L110;
	    }

/* .... POBEPKA BXOA A PAH. */

	    if (add6a_1.xgmn < x0new && x0new < add6a_1.xgmx) {
		goto L110;
	    }

/* .... OCK TOK B PAH. */

	    xbound = add6a_1.xgmn;
	    if (x0new > add6a_1.xgmx) {
		xbound = add6a_1.xgmx;
	    }
	    ++iend;
	    ndr = 1;
	    ind = -ind;
	    x0new = xbound;
L110:

/* .... TOHEHE TOK B EPOCKOCT X(NG)=CONSTANATA. */

	    *nfix = ng;
	    x0[ng] = x0new;
	    it = 10;

/* .... OPAEHE K POEPE HTOHA. */

	    iern = 0;
	    newtn_(nx, &cs__84, &ng, nfix, ncan, &x0[1], eps, &epsn, &it, ipr,
		     fun, dfdx, workbe_1.dfun, &iern, istop);
	    if (*istop != 0) {
		return;
	    }
	    if (iern == 0) {
		goto L180;
	    }

/* .... TOKA HA KPBO HE HAEHA. */


/* .... BCM HAEH HK B OCEHE HAEHO TOKE. */

	    ierr = 0;
	    (*fun)(&x0[1], funs, &ierr, istop);
	    if (*istop != 0) {
		return;
	    }
	    if (ierr == 0) {
		goto L115;
	    }
L115:
	    s__3 = *nx;
	    for (k = 1; k <= s__3; ++k) {
		x0[k] = xold[k - 1];
/* L120: */
	    }
	    x0[ng] = x0new;
	    if (all2_1.ipoisk == 0) {
		goto L175;
	    }

/* .... K EPEOPA BCEBOMOHX EPOCKOCTE CCKA HA KPB
. */

	    s__3 = *nx;
	    for (l = 1; l <= s__3; ++l) {
		if (l == ng) {
		    goto L140;
		}

/* .... TOHEH TOK B EPOCKOCT X0(NFIX)=CONSTANTA. 
*/

		*nfix = l;
		it = 10;

/* .... OPAEHE K POEPE HTOHA. */

		iern = 0;
		newtn_(nx, &cs__84, &ng, nfix, ncan, &x0[1], eps, &epsn, &it, 
			ipr, fun, dfdx, workbe_1.dfun, &iern, istop);
		if (*istop != 0) {
		    return;
		}
		if (iern == 0) {
		    goto L180;
		}

/* .... TOKA HA KPBO HE HAEHA. */


/* .... BCM HAEH HK B OCEHE HAEHO TOKE. 
*/

		ierr = 0;
		(*fun)(&x0[1], funs, &ierr, istop);
		if (*istop != 0) {
		    return;
		}
		if (ierr == 0) {
		    goto L125;
		}
L125:
		s__4 = *nx;
		for (k = 1; k <= s__4; ++k) {
		    x0[k] = xold[k - 1];
/* L130: */
		}
		x0[ng] = x0new;
L140:
/* L150: */
		;
	    }

/* .... EPBA TOKA HA KPBO HE HAEHA. */

	    *ier = -1;
	    cnwt1_1.ipnt1 = 0;
	    if (iend == 2) {
		return;
	    }
	    if (iend == 0) {
		ind = -ind;
	    }
/* L160: */
	}
/* L170: */
    }
L175:
    *ier = -1;
    cnwt1_1.ipnt1 = 0;
    return;
L180:

/* .... EPBA TOKA HA KPBO CEHO HAEHA. */

    *ier = 0;
    cnwt1_1.ipnt1 = 0;
    return;
} /* poisk_ */

