/* zero.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>


/* Table of constant values */

static shortint cs__84 = NDIM;

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */

void zero_(shortint *istep, shortint *nx, shortint *ndimm, shortint *ng, shortint *ncan, shortint *nuf, shortint *ifuns, shortint *iprz, doublereal *stx2, doublereal *eps, void (*fun) (doublereal*, doublereal*, shortint*, shortint*), void (*dfdx) (doublereal*, doublereal*, shortint*, shortint*, shortint*, shortint*), void (*out) (shortint *, shortint *, shortint *, shortint *, doublereal *, doublereal *, doublereal *, shortint *), doublereal *dfun, shortint *istop)
{
    /* System generated locals */
    shortint s__1, s__2, s__3;
    doublereal d__1;

    /* Local variables */
    static shortint indf, ifun, iter, iwrt;
    static doublereal funs1[IFMAX];
    static shortint i, index[NPTYP], itmax;
    static doublereal f1, f2;
    static shortint nfixr;
    static doublereal r1, r2, xzero[NDIM], x1[NDIM], x2[NDIM], df, fn;
    static shortint it, indloc;
    static doublereal rx;
    static doublereal dmover;
    static shortint iprtcl, ier, ipr;
    static doublereal stx1[NDIM];

/*     3.05.90. */
/*     7.08.1991 */
/*     13.11.92 */
/*     15.06.94 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* *                                                                     *
 */
/* *    POPAMMA  ZERO  PEHAHAEHA  TOHEH KOOPHAT HE     *
 */
/* *    AAHHX HK.                                                *
 */
/* *                                                                     *
 */
/* *     A P A M E T P :                                               *
 */
/* *    =================                                                *
 */
/* *                                                                     *
 */
/* *    ISTEP -CO AOB, POEAHHX BO KPBO.                    *
 */
/* *    NX    -PAMEPHOCT POCTPAHCTBA EPMEHHX.                       *
 */
/* *    NDIM  -ABEHHA CTPOHA PAMEPHOCT MATP DFUN.             *
 */
/* *    NG    -HOMEP ABHO EPEMEHHO.                                 *
 */
/* *    NCAN  -HOMEP KAHAA  BBOA PETATOB.                      *
 */
/* *    IPRZ  -APAMETP, OPEE OHOT POTOKOA.                 *
 */
/* *    NUF   -CO HK, CCEEMX HA KPBO.                     *
 */
/* *    IFUNS -MACCB HOMEPOB CCEEMX HK.                       *
 */
/* *    STX2  -KOOPHAT TEKE TOK HA KPBO.                       *
 */
/* *    EPS   -TOHOCT OPEEEH TOK HA KPBO B METOE HTOHA.    *
 */
/* *    FUN   -M OPOPAMM BCEH OPEEX HK.         *
 */
/* *    DFDX  -M OPOPAMM BCEH KOAHA OPEEX HK.*
 */
/* *    DFUN  -MACCB, COEPA KOAH OPEEX HK.          *
 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* *    P MEHEH MAKCMAHOO CA EPEMEHHX  NDIM -HEOXOMO   *
 */
/* *    MEHT PAMEPHOCT MACCBOB:                                   *
 */
/* *    STX1(*) STX2(*) X1(*) X2(*) XZERO(*) VMOVE(*)                    *
 */
/* * . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . *
 */
/* *    P MEHEH MAKCMAHOO CA HK, CCEEMX HA KPBO.*
 */
/* *    HEOXOMO MEHT PAMEPHOCT MACCBOB:                        *
 */
/* *    FUNS1(*) IFUNS(*) IFUNSA(*) IERF(*) FUNS2(*).                    *
 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */





    /* Parameter adjustments */
    dfun -= (NDIM+1);
    --ifuns;
    --stx2;

    /* Function Body */
    *istop = 0;
    if (*nuf == 0) {
	return;
    }
    for (i = 1; i <= NPTYP; ++i) {
	index[i - 1] = 0;
/* L100: */
    }
    wrto4_1.epsc = *eps;

/* .... BCEHE HAEH BCEX HK B TEKE TOKE HA KPBO. */

    s__1 = *nuf;
    for (ifun = 1; ifun <= s__1; ++ifun) {
	indf = zero2_1.ifunsa[ifun - 1];
	ier = 0;
	out1_1.g[indf - 1] = funall_(&indf, nx, &stx2[1], fun, dfdx, &ier,
		 istop);
	if (*istop != 0) {
	    return;
	}
	if (ier == 0) {
	    goto L170;
	}

/* .... HE BCEHO HAEHE HK B TEKE TOKE HA KPBO. */

	if (*istep == 0) {
	    funs1[indf - 1] = -6.66e35;
	}
	out1_1.g[indf - 1] = -6.66e35;
	out2_1.ierf[indf - 1] = ier;
	goto L190;
L170:
	if (out2_1.ierf[indf - 1] == 0) {
	    goto L180;
	}

/* .... HE BCEH HAEH HK B PEX TOKAX HA KPBO; 
*/
/*     BCEHHOE HAEHE HK B TEKE TOKE HE POBEPETC. */

	funs1[indf - 1] = out1_1.g[indf - 1];
	out2_1.ierf[indf - 1] = 0;
L180:
L190:
/* L200: */
	;
    }

/* .... BBO POTOKOA PACETA HK. */

    iprtcl = 3;

/* .... OPAOTKA OOBATEEM TEKE TOK HA KPBO */
/*     BCEHHX HAEH HK. */

    index[0] = 1;
    (*out)(istep, index, nx, &cs__84, &stx2[1], wrto7_1.vmove, &dfun[NDIM+1], 
	    istop);
    if (*istop != 0) {
	return;
    }
    index[0] = 0;
    if (*istep == 0) {
	goto L390;
    }
    itmax = 10;
    out4_1.epsz = add3b_1.epszer;

/* .... K POBEPK HA CMEH HAKA BCEX BCEHHX HAEH. */

    s__1 = *nuf;
    for (ifun = 1; ifun <= s__1; ++ifun) {
	out2_1.indz = 0;
	indf = zero2_1.ifunsa[ifun - 1];

/* .... POBEPKA COB: */
/*     1). IFUNS(IFUN) < 0 -H HE TOHETC; */
/*     2). IERF (INDF) .NE. 0 -HAEHE HK HE BCEHO; */

	if (ifuns[ifun] < 0) {
	    goto L370;
	}
	if (out2_1.ierf[indf - 1] != 0) {
	    goto L370;
	}

/* .... OOTOBKA PAOX MACCBOB. */

	s__2 = *nx;
	for (i = 1; i <= s__2; ++i) {
	    x1[i - 1] = stx1[i - 1];
	    x2[i - 1] = stx2[i];
/* L210: */
	}

/* .... POBEPKA COB CMEH HAKA. */

	f1 = funs1[indf - 1];
	f2 = out1_1.g[indf - 1];
	if (f1 * f2 > 0.) {
	    goto L370;
	}
	df = (d__1 = (f1 - f2) / (x1[wrto1_1.nfix1 - 1] - x2[wrto1_1.nfix1 - 
		1]), fabs(d__1));
	if (df < out4_1.epsz * .1) {
	    goto L370;
	}
	indloc = 0;

/* .... K TOHEH KOOPHAT H HK. */

	s__2 = itmax;
	for (iter = 1; iter <= s__2; ++iter) {

/* .... POHO KOOPHAT H HK. */

L215:
	    if (indloc == 0) {
		rx = f2 / (f2 - f1);
	    }
	    if (indloc == 1) {
		rx = .5;
	    }
	    if (indloc == 2) {
		rx = .44444444444444442;
	    }

	    s__3 = *nx;
	    for (i = 1; i <= s__3; ++i) {
		xzero[i - 1] = x2[i - 1] - (x2[i - 1] - x1[i - 1]) * rx;
/* L220: */
	    }
	    it = wrto6_1.itc;
	    ipr = 0;
	    ier = 0;
/*          WRITE (TEXT,1001) ITER */
/*          WRITE (6,1001) ITER */
/* 1001     FORMAT( */
/*     *   '  ZERO: Iter=',I2,41X) */
/*         CALL Showte(TEXT) */
	    newtn_(nx, &cs__84, ng, &wrto1_1.nfix1, ncan, xzero, eps, &
		    wrto4_1.epsn, &it, &ipr, fun, dfdx, &dfun[NDIM+1], &ier, 
		    istop);
	    if (*istop != 0) {
		return;
	    }
	    if (ier == 0) {
		goto L230;
	    }
	    ++indloc;
	    if (indloc <= 2) {
		goto L215;
	    }

/* .... HE COC HTOHOBCKE TEPA. */

L225:
	    iprtcl = 2;
	    iwrt = 1 - ier;
	    goto L320;
L230:
	    r1 = 0.;
	    r2 = 0.;
	    s__3 = *nx;
	    for (i = 1; i <= s__3; ++i) {
		r1 += (xzero[i - 1] - stx1[i - 1]) * (stx2[i] - stx1[i - 1]);
		r2 += (xzero[i - 1] - stx2[i]) * (stx2[i] - stx1[i - 1]);
/* L235: */
	    }
	    if (r1 * r2 > 0.) {
		goto L225;
	    }
	    ier = 0;
	    out4_1.fzero = funall_(&indf, nx, xzero, fun, dfdx, &ier, istop);
/*          WRITE (TEXT,1002) FZERO */
/*          WRITE (6,1002) FZERO */
/* 1002     FORMAT( */
/*     *   '  ZERO: Fzero=',G9.2,33X) */
/*         CALL Showte(TEXT) */
	    if (*istop != 0) {
		return;
	    }
	    if (ier == 0) {
		goto L240;
	    }
	    ++indloc;
	    if (indloc <= 2) {
		goto L215;
	    }

/* .... HE BCEH HAEH HK HA KPBO. */

	    iprtcl = 2;
	    iwrt = 0;
	    goto L320;
L240:

/* .... BOP HTEPBAA, COEPAEO H HK. */

	    if (f1 * out4_1.fzero < 0.) {
		goto L260;
	    }
	    f1 = out4_1.fzero;
	    s__3 = *nx;
	    for (i = 1; i <= s__3; ++i) {
		x1[i - 1] = xzero[i - 1];
/* L250: */
	    }
	    goto L280;
L260:
	    s__3 = *nx;
	    for (i = 1; i <= s__3; ++i) {
		x2[i - 1] = xzero[i - 1];
/* L270: */
	    }
	    f2 = out4_1.fzero;
L280:

/* .... KOHTPO OCTHTO TOHOCT. */

	    out4_1.epszr = (d__1 = x2[wrto1_1.nfix1 - 1] - x1[wrto1_1.nfix1 - 
		    1], fabs(d__1));
	    df = (d__1 = (f1 - f2) / (x1[wrto1_1.nfix1 - 1] - x2[
		    wrto1_1.nfix1 - 1]), fabs(d__1));
	    fn = (d__1 = out4_1.fzero / df, fabs(d__1));
	    if (out4_1.epszr <= out4_1.epsz || fn <= out4_1.epsz * .1) {
		goto L310;
	    }
/* L300: */
	}
	iter = itmax;
	out2_1.indz = -1;
L310:

/* .... BAA POTOKOA: HAEHO PEHE K H HK. */

	iprtcl = 1;
/*                     CALL WRTZER (IPRTCL,INDF,IWRT,ISTEP,IPRZ,IT,IDI
V, */
/*     A                            NCAN,NX,NDIM,ITER,NUF,IFUNS, */
/*     B                            EPSR,EPSZ,XZERO,X2,FZERO,DFUN) */
	index[2] = indf;
	(*out)(istep, index, nx, &cs__84, xzero, wrto7_1.vmove, &dfun[NDIM+1], 
		istop);
	if (*istop != 0) {
	    return;
	}
	goto L380;
L320:

/* .... BAA POTOKOA: HE COC HTOHOBCKE TEPA */
/*                       HE BCEHO HAEHE HK. */

	out4_1.epszr = (d__1 = x2[wrto1_1.nfix1 - 1] - x1[wrto1_1.nfix1 - 1], 
		fabs(d__1));

	out4_1.fzero = f1;
	if (fabs(f1) <= fabs(f2)) {
	    goto L340;
	}
	out4_1.fzero = f2;
	s__2 = *nx;
	for (i = 1; i <= s__2; ++i) {
	    x1[i - 1] = x2[i - 1];
/* L330: */
	}
L340:
	dmover = wrto2_1.dmove;
	wrto2_1.dmove = wrto2_1.dmove1;
	nfixr = wrto1_1.nfix;
	wrto1_1.nfix = wrto1_1.nfix1;
	wrto2_1.dmove = dmover;
	wrto1_1.nfix = nfixr;

/* .... OOHTEHA OPAOTKA BCEHHX HAEH HK. */

	out2_1.indz = -1;
	index[2] = indf;
	(*out)(istep, index, nx, &cs__84, x1, wrto7_1.vmove, &dfun[NDIM+1], istop)
		;
	if (*istop != 0) {
	    return;
	}
L370:
L380:
	;
    }
L390:

/* .... OOTOBKA K OEPEHOM A BO KPBO. */

    s__1 = *nx;
    for (i = 1; i <= s__1; ++i) {
	stx1[i - 1] = stx2[i];
/* L400: */
    }
    s__1 = *nuf;
    for (ifun = 1; ifun <= s__1; ++ifun) {
	indf = zero2_1.ifunsa[ifun - 1];
	funs1[indf - 1] = out1_1.g[indf - 1];
/* L410: */
    }
    return;
} /* zero_ */

