/* lbf.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <stdio.h>


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void locbif_(void)
{
    /* Initialized data */

    char *nampar[] =   { "H0crv =","Hmxcrv=","Angcrv=","Dhcrv =",
    "Dhjac =","Maxit =","Modit =","Epscrv=","Epscrs=","Epszer=","Epsext=",
    "Iprsng=","Algcrv=","Itmap =","Tint  =","H0int =","Hmxint=","Dhint =",
    "Epsint=","Epsrel=","Solver=","Isec  =","Irhs  =","Iorbit=","Join  =",
    "Sound =","Flash =","Messag=","Maxnpt=","Init  =","Ivar  =","File  =",
    "","","","","","","","","","","","","","","","","" };
    FILE *ncanf, *ncanb;

    /* System generated locals */
    shortint s__1;

    /* Local variables */
    FILE *ncan;
    shortint idir, ierr, i;
    doublereal w[NRVC];
    shortint pointtype;
    doublereal dumbfl[NBFVL];
    shortint npt;


/*     19.10.94 */


/*      INCLUDE 'FGRAPH.FD' */
/*      INCLUDE 'KEYDEF.DAT' */
/*      INCLUDE 'LETDEF.DAT' */

/* ---        INTEGER*2      hsim,wsim,maxx,maxy,maxcolor */
/* ---        COMMON/VIDEO/  hsim,wsim,maxx,maxy,maxcolor */

/*   Open STORE files */
    ncanf = storeo_(7);
    ncanb = storeo_(8);
/*   Fill in point id array with standard order */
    for (i = 1; i <= NRVC; ++i) {
/* L11: */
	integ_1.id[i - 1] = i;
    }
    initnm_();
    lbdump_();
/*   NP1, NP2 and NP3 must be initialized by now (mrm) */
    parnum_1.ncpar = np123_1.np1 + np123_1.np2 + np123_1.np3;
    s__1 = parnum_1.ncpar;
    for (i = 0; i < parnum_1.ncpar; ++i)
      nampar_1.nampar1[i] = nampar[i];
    for (i = 1; i <= NBFVL; ++i) {
/* L20: */
	dumbfl[i - 1] = 0.;
    }
    numflg_1.numflg = 0;
    keyflg_1.keyflg = 0;
/*  Write Initial Point to STORE Files */
    pointtype = -1;
    ncan = ncanf;
    npt = 1;
    store_(ncan, &pointtype, &npt, &nmlit_1.n, &nmlit_1.m, &nmlit_1.l, 
	    real_1.rvc, &real_1.rvc[nmlit_1.n], &real_1.rvc[nmlit_1.n + 
	    nmlit_1.m], &real_1.rvc[nmlit_1.n + nmlit_1.m + nmlit_1.l], &
	    real_1.rvc[nmlit_1.n + nmlit_1.m + nmlit_1.l + 1], &real_1.rvc[(
	    nmlit_1.n << 1) + nmlit_1.m + nmlit_1.l + 1], dumbfl, &ierr);
    ncan = ncanb;
    npt = -1;
    store_(ncan, &pointtype, &npt, &nmlit_1.n, &nmlit_1.m, &nmlit_1.l, 
	    real_1.rvc, &real_1.rvc[nmlit_1.n], &real_1.rvc[nmlit_1.n + 
	    nmlit_1.m], &real_1.rvc[nmlit_1.n + nmlit_1.m + nmlit_1.l], &
	    real_1.rvc[nmlit_1.n + nmlit_1.m + nmlit_1.l + 1], &real_1.rvc[(
	    nmlit_1.n << 1) + nmlit_1.m + nmlit_1.l + 1], dumbfl, &ierr);
    integ_1.nvar = nmlit_1.n * 3 + nmlit_1.m + nmlit_1.l + 1;
    line0_1.line0 = integ_1.linetype;
/*           CALL LineLo */
    s__1 = integ_1.nvar;
    for (i = 1; i <= s__1; ++i) {
/* L30: */
	w[i - 1] = real_1.rvc[i - 1];
    }
    wrt = 1;
/* L104: */
    if (numflg_1.numflg == 1) {
	pointtype = -1;
	ncan = ncanf;
	npt = 1;
	storer_(ncan);
	store_(ncan, &pointtype, &npt, &nmlit_1.n, &nmlit_1.m, &nmlit_1.l, 
		real_1.rvc, &real_1.rvc[nmlit_1.n], &real_1.rvc[nmlit_1.n + 
		nmlit_1.m], &real_1.rvc[nmlit_1.n + nmlit_1.m + nmlit_1.l], &
		real_1.rvc[nmlit_1.n + nmlit_1.m + nmlit_1.l + 1], &
		real_1.rvc[(nmlit_1.n << 1) + nmlit_1.m + nmlit_1.l + 1], 
		dumbfl, &ierr);
	ncan = ncanb;
	npt = -1;
	storer_(ncan);
	store_(ncan, &pointtype, &npt, &nmlit_1.n, &nmlit_1.m, &nmlit_1.l, 
		real_1.rvc, &real_1.rvc[nmlit_1.n], &real_1.rvc[nmlit_1.n + 
		nmlit_1.m], &real_1.rvc[nmlit_1.n + nmlit_1.m + nmlit_1.l], &
		real_1.rvc[nmlit_1.n + nmlit_1.m + nmlit_1.l + 1], &
		real_1.rvc[(nmlit_1.n << 1) + nmlit_1.m + nmlit_1.l + 1], 
		dumbfl, &ierr);
	numflg_1.numflg = 0;
    }
    wrtcom_();
    s__1 = integ_1.nvar;
    for (i = 1; i <= s__1; ++i) {
/* L40: */
	w[i - 1] = real_1.rvc[i - 1];
    }
    s__1 = nmlit_1.l + (nmlit_1.n << 1) + 1;
    for (i = 1; i <= s__1; ++i) {
/* L50: */
	w[nmlit_1.n + nmlit_1.m + i - 1] = 0.;
    }
    ierfs_1.ierdum = 1;
    if (wrt) {
	proto_(nmlit_1.n, nmlit_1.m, nmlit_1.l, lntp_1.lntp[
		integ_1.linetype - 1], &ierr);
    }
    ncan = ncanf;
    idir = 1;
    storec_(ncan);
    ncan = storeo_(7);
    comput_(idir);
    protc_();
    return;
} /* locbif_ */

