/* message.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include <stdio.h>
#include "../loclbf.h"


/* Table of constant values */

static integer c__1 = 1;

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */

void messag_( char *text, int nnpt, int linetype, int pointtype, int n, int m, int l, doublereal *bifval, shortint *iend, ftnlen text_len)
{

    /* Local variables */
    shortint iext;
    shortint ipt;


/*       19.10.94 */




    /* Parameter adjustments */
    --bifval;

    /* Function Body */
    sprintf( text, "%-55s", " " );

    npt = nnpt;
/*========================================================================*/
/*   First and last points */

    if (nnpt == 1 || nnpt == -1) {
      sprintf( text, "%-55s", " The first point " );
      return;
    }
    /* *** */
    if (abs(nnpt) == maxnpt) {
      *iend = -1;
      sprintf( text, "%-55s", " Last point in buffer " );
      return;
    }
/*===========================================================================*/
/*  Regular point */

    if (pointtype == 0) {
      sprintf( text, " Npt = %-48d", nnpt );
      return;
    }
/*---------------------------------------------------------------------------*/
    ipt = pointtype / 100;
    switch ((int)ipt) {
	case 1:  goto L1000;
	case 2:  goto L2000;
	case 3:  goto L3000;
	case 4:  goto L4000;
    }
    goto L1000;
L2000:
/*==========================================================================*/
/*  Selfcrossing */

    if (pointtype == 201) {
      sprintf( text, "%-55s", " Selfcrossing " );
      return;
    }
    if (pointtype == 211) {
      sprintf( text, "%-55s", " Selfcrossing (?) " );
      return;
    }
L3000:
/*===========================================================================*/
/*  Singular point */

    messng_(linetype, pointtype, &bifval[1], text);
    goto L999;
/* 	RETURN */
/*===========================================================================*/
/*  Extremum */

L4000:
    if (pointtype == 401) {
      iext = (shortint) (bifval[1] + n);
      sprintf( text, " Maximum of parameter  %s is %13.6g", nc[iext-1], bifval[2] );
      return;
    }
    if (pointtype == 402) {
      iext = (shortint) (bifval[1] + n);
      sprintf( text, " Minimum of parameter  %s is %13.6g", nc[iext-1], bifval[2] );
      return;
    }
    if (pointtype == 411) {
      iext = (shortint) (bifval[1] + n);
      sprintf( text, " Maximum (?) of parameter  %s is %13.6g", nc[iext-1], bifval[2] );
      return;
    }
    if (pointtype == 412) {
      iext = (shortint) (bifval[1] + n);
      sprintf( text, " Minimum (?) of parameter  %s is %13.6g", nc[iext-1], bifval[2] );
      return;
    }
/*============================================================================*/
/*  Special points */

L1000:
    if (pointtype == 5) {
      sprintf( text, "%-55s", " Limit of parameter region" );
      return;
    }
    if (pointtype == 4) {
      sprintf( text, "%-55s", " Closed curve" );
      return;
    }
    if (pointtype == 6) {
      sprintf( text, "%-55s", " Cannot continue numerical integration" );
      return;
    }
    if (pointtype == -1) {
      sprintf( text, "%-55s", " Last point in the direction" );
      return;
    }
    if (pointtype == -3) {
      sprintf( text, "%-55s", " Current step size is too small" );
      return;
    }
    if (pointtype == -5) {
      sprintf( text, "%-55s", " Computations terminated" );
      return;
    }

    return;
L999:
    return;

L998:
    *iend = -1;
    return;
} /* messag_ */

