/* output.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */

void outp_(shortint *typ, shortint *n, shortint *m, shortint *l, doublereal *x, doublereal *p, doublereal *g, doublereal *t, doublereal *rr, doublereal *ri, doublereal *bifval, shortint *line, shortlogical *actpar, shortint *pointtype, shortint *npt, shortint *iend)
{

    /* System generated locals */
    shortint s__1;

    /* Local variables */
    FILE  *ncan;
    char text[60];
    shortint i;


/*       19.10.94 */


/* ---	INCLUDE 'KEYDEF.DAT' */

/* ---	INTEGER*2 PIX,PIY,x1,y1 */

    /* Parameter adjustments */
    --actpar;
    --x;
    --p;
    --g;
    --rr;
    --ri;
    --bifval;

    /* Function Body */

/*                                                   Write protocol (modif
ied: mrm)*/
    if (wrt && *pointtype != 0) {
	protoc_(*n, *m, *l, &x[1], &p[1], &g[1], t, &rr[1], &ri[1], &bifval[1], 
		line, &actpar[1], *pointtype, *npt, iend);
    }
/* 						      Modify common /REAL/ */
    *iend = 0;
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
	real_1.rvc[i - 1] = x[i];
/* L10: */
    }
    s__1 = *m;
    for (i = 1; i <= s__1; ++i) {
	real_1.rvc[i + *n - 1] = p[i];
/* L20: */
    }
    if (*l > 0) {
	s__1 = *l;
	for (i = 1; i <= s__1; ++i) {
	    real_1.rvc[i + *n + *m - 1] = g[i];
/* L30: */
	}
    }
    real_1.rvc[*n + *m + *l] = *t;
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
	real_1.rvc[i + 1 + *n + *m + *l - 1] = rr[i];
	real_1.rvc[i + 1 + (*n << 1) + *m + *l - 1] = ri[i];
/* 	      write(*,*) '---------' */
/* 	      write(*,*) RVC(1+I+N+M+L), RVC(1+I+2*N+M+L) */
/* L40: */
    }
    for (i = 1; i <= NBFVL; ++i) {
	bfvl_1.bifval[i - 1] = bifval[i];
/* L50: */
    }
/* 	                    			     Write to files FSTOR */
    if (*typ == 0) {
	if (*npt > 0) {
	    ncan = fp7;
	} else {
	    ncan = fp8;
	}
	store_(ncan, pointtype, npt, n, m, l, &x[1], &p[1], &g[1], t, &rr[1],
		 &ri[1], &bifval[1], iend);
	if (*iend == 1) {
	    return;
	}
    }
/*                                              Output of the curve */
/* ---        CALL CurPlt(TYP,PointType,Npt,RLIM,SOLDOT, */
/* ---     *              RVC(IX),RVC(IY),x1,y1,PIX,PIY) */

/* ---        UPDT=.FALSE. */

/*  Sound */

/* ---      IF (SOS.NE.0) THEN */
/* ---        Stype=0 */
/* ---        IF (PointType .NE. 0) Stype=1 */
/* ---        CALL MSound(Stype) */
/* ---      ENDIF */

/*  Diagnostics */

    if (abs(*npt) == 1 && *pointtype == -1) {
	*iend = 1;
	return;
    }

    messag_(text, *npt, integ_1.linetype, *pointtype, *n, *m, *l, &bifval[1], 
	    iend, 60L);
    strcpy(mesblk_1.textcm, text);
    strcpy(mesblk_1.textcm + 56, "");
    if (*iend == -1) {
	endmes_(text, iend, n, m, l, &x[1], &p[1], &g[1], t, &rr[1], &ri[1], &
		bifval[1] );
	return;
    }

/*    Write message in protocol */

    if (wrt && *pointtype != 0) {
	protte_(text);
    }

/*    Draw marker */

    if (*pointtype != 0) {
/*        IF (PointType.NE.0 .OR. ABS(Npt).EQ.1) THEN */
/* ---           CALL Marker(PIX+x1,PIY+y1) */
    }

/*    Output the message */
/* ---        IF (MESS.EQ.0) THEN */
/* ---           CALL ShowTe (TEXT) */
/* ---        ELSE */
/* ---           IF (ABS(Npt).EQ.1 .OR. PointType. NE. 0) */
/* ---     *     CALL ShowTe (TEXT) */
/* ---        ENDIF */

/*    Symbol output */

/* ---	IF (STATE .OR. STOP .OR. */
/* ---     *      PointType.NE.0 .OR. ABS(Npt).EQ.1) THEN */
/* ---           IF ( .NOT. UPDT) THEN */
/* ---              UPDT=.TRUE. */
/* ---              CALL Trans */
/* ---              CALL UpDate */
/* ---              CALL MVTo (PIX,PIY) */
/* ---           ENDIF */
/* ---	ENDIF */
/* 	IF (IEND.EQ.1) RETURN */

/* 							Key processing */
/* ---      WAIT=.FALSE. */
/* ---      IF (KEYEVE(WAIT,EVNT)) THEN */
/* ---C:Escape or Insert */
/* ---         IF (EVNT.EQ.KEscape.OR.EVNT.EQ.KInsert) GO TO 700 */
/* ---C:Pause */
/* ---         IF (EVNT.EQ.KStop.OR.EVNT.EQ.KComp2) THEN */
/* ---            IF (.NOT.UPDT) THEN */
/* ---               CALL Trans */
/* ---               CALL UpDate */
/* ---            ENDIF */
/* ---            IF (PointType.EQ.0.AND.EVNT.EQ.KStop) THEN */
/* ---               WRITE (TEXT,1003) Npt */
/* --- 1003	       FORMAT (' Npt=',I4,45X) */
/* ---	       CALL ShowTe (TEXT) */
/* ---	       CALL ShowHint (HINT) */
/* ---            ENDIF */
/* ---            WAIT=.TRUE. */
/* ---	    IF (EVNT.EQ.KComp2) GO TO 11 */
/* ---         ENDIF */
/* ---      ENDIF */
/* ---C:Stop */
/* ---      IF ( .NOT. (PointType.EQ.0 .OR. AUTO)) WAIT=.TRUE. */
/* ---      IF ( .NOT. (ABS(Npt).NE.1 .OR. AUTO)) WAIT=.TRUE. */
/* ---      IF (STOP) WAIT=.TRUE. */
/* ---C */
/* ---C  Waiting and key processing */
/* ---C */
/* ---      IF ( .NOT. WAIT) RETURN */
/* --- 10   CONTINUE */
/* ---      CALL MVTo (PIX,PIY) */
/* ---      IF (KEYEVE(WAIT,EVNT)) THEN */
/* ---C */
/* ---C:Escape or Insert */
/* ---         IF (EVNT.EQ.KEscape.OR.EVNT.EQ.KInsert) GO TO 700 */
/* ---	 IF (EVNT.EQ.KContinue) RETURN */
/* ---C */
/* ---         IF (TYP.EQ.0) THEN */
/* ---            IF (Npt.GT.0 .AND. */
/* ---     *         (EVNT.EQ.KComp4 .OR. */
/* ---     *          EVNT.EQ.KContinue)) RETURN */
/* ---            IF (Npt.LT.0 .AND. */
/* ---     *         (EVNT.EQ.KComp_4 .OR. */
/* ---     *          EVNT.EQ.KCtrlContinue .OR. */
/* ---     *          EVNT.EQ.KContinue)) RETURN */
/* ---         ELSE */
/* ---            IF (Npt.GT.0 .AND. */
/* ---     *         (EVNT.EQ.KBrowse1 .OR. */
/* ---     *          EVNT.EQ.KContinue)) RETURN */
/* ---            IF (Npt.LT.0 .AND. */
/* ---     *         (EVNT.EQ.KBrowse_1 .OR. */
/* ---     *          EVNT.EQ.KCtrlContinue .OR. */
/* ---     *          EVNT.EQ.KContinue)) RETURN */
/* ---         ENDIF */
/* --- 11	 CONTINUE */
/* ---	 IF (EVNT.EQ.KComp2) THEN */
/* --- */
/* ---            Data (1) = 3 */
/* ---            IF (AUTO) Data (1) = 1 */
/* ---            IF (STOP) Data (1) = 2 */
/* ---            Data (2) = 1 */
/* ---            IF (SOLDOT .EQ. 1) Data(2) = 2 */
/* ---            Data (3) = 1 */
/* ---            IF (STATE)  Data(3) = 2 */
/* ---            Data (4) = 1 */
/* ---            IF (SOS .EQ. 1) Data(4) = 2 */
/* ---            Data (5) = 1 */
/* ---            IF (WRT) Data(5) = 2 */
/* ---            Set = 1 */
/* --- */
/* ---	    CALL PauseOpt (Data,EVNT,WAIT,PIX,PIY) */
/* --- */
/* ---            STOP = .FALSE. */
/* ---            IF (Data(1) .EQ. 2) STOP = .TRUE. */
/* ---            AUTO = .FALSE. */
/* ---            IF (Data(1) .EQ. 1) AUTO = .TRUE. */
/* ---            SOLDOT = 1 */
/* ---            IF (Data(2) .EQ. 1) SOLDOT = 0 */
/* ---            RPC(NP1+NP2+1) = SOLDOT */
/* ---            SOS = 0 */
/* ---            IF (Data(4) .EQ. 2) SOS = 1 */
/* ---            RPC(NP1+NP2+2) = SOS */
/* ---            WRT = .FALSE. */
/* ---            IF (Data(5) .EQ. 2) WRT = .TRUE. */
/* --- */
/* ---            SELECT CASE (EVNT) */
/* ---	       CASE (KComp4,KComp_4,KBrowse1,KBrowse_1) */
/* ---	          RETURN */
/* ---	       CASE DEFAULT */
/* ---            END SELECT */
/* ---	    CALL ShowHint (HINT) */
/* ---	 ENDIF */
/* ---      ENDIF */
/* ---      GO TO 10 */
/* ---C */
/* ---C                                       Escape or Insert processing 
*/
/* ---C */
/* --- 700  CONTINUE */
/* ---      IF (EVNT.EQ.KInsert) INST=.TRUE. */
/* ---      IF (ABS(Npt).LT.MAXNPT .AND. TYP.EQ.0) THEN */
/* ---         IF (Npt.GT.0) THEN */
/* ---            NCAN=7 */
/* ---         ELSE */
/* ---            NCAN=8 */
/* ---         ENDIF */
/* ---         PointType=-1 */
/* ---         CALL Store (NCAN,PointType,Npt,N,M,L, */
/* ---     *               X,P,G,T,RR,RI,BifVal,IEND) */
/* ---      ENDIF */
/* ---      IEND=1 */

    return;
} /* outp_ */

