/* rdinit.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <stdio.h>


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */


void rdinit_( char *filename )
{
    int iact[NRVC];
    double  hrvc[NHRVC];
    int i, istate, istop;
    FILE *fp;

    for (i = 0; i < NRVC; ++i)
      real_1.rvc[i] = 0;

    fp = fopen( filename, "r" );
    for( i=0; i<NHRVC; i++ )
      fscanf( fp, "%lg", &(hrvc[i]) );

    for (i = 0; i < nmlit_1.n; ++i)
      real_1.rvc[i - 1] = hrvc[i - 1];
    for (i = 0; i < nmlit_1.m; ++i) 
	real_1.rvc[i + nmlit_1.n] = hrvc[i + NFMAX];
    if (nmlit_1.l > 0) {
	for (i = 0; i < nmlit_1.l; ++i)
	  real_1.rvc[i + nmlit_1.n + nmlit_1.m] = hrvc[i + NFMAX+NFMAX];
    }
    real_1.rvc[nmlit_1.n + nmlit_1.m + nmlit_1.l] = hrvc[NHRVC-1];
    
    for( i=0; i<NRPC; i++ )
      fscanf( fp, "%lg", &(real_1.rpc[i]) );
    for( i=0; i<4; i++ )
      fscanf( fp, "%lg", &(real_1.rlim[i]) );
    fscanf( fp, "%hd", &integ_1.linetype );
    for( i=0; i<NRVC; i++ )
      fscanf( fp, "%d", &(iact[i]) );

    for (i = 0; i < NRVC; ++i) {
      logic_1.active[i] = 0;
      if (iact[i] == 1) 
	logic_1.active[i] = 1;
    }
    
    fscanf( fp, "%hd", &integ_1.ix );
    fscanf( fp, "%hd", &integ_1.iy );
    fscanf( fp, "%hd", &integ_1.k );
    for( i=0; i<NRVC; i++ )
      fscanf( fp, "%hd", &(integ_1.id[i]) );
    fscanf( fp, "%hd", &color_1.colortype );
    fscanf( fp, "%hd", &color_1.fillcolor );
    fscanf( fp, "%d", &istate );

    logic_1.state = 0;
    if (istate == 1) 
	logic_1.state = 1;
    fscanf( fp, "%d", &istop );
    comp_1.stop = 0;
    if (istop == 1) 
	comp_1.stop = 1;
    
    fclose( fp );

/*   Write initial values to the COMMON blocks */
    initnm_();
    for( i=0; i<=nmlit_1.n * 3 + nmlit_1.m + nmlit_1.l; i++ )
      sprintf( vc[i], "%13.7g", real_1.rvc[i] );
    for( i=0; i<parnum_1.ncpar; i++ )
      sprintf( pc[i], "%13.7g", real_1.rpc[i] );
    for( i=0; i<4; i++ )
      sprintf( lim[i], "%13.7g", real_1.rlim[i] );
    epsh0_1.h0crv = real_1.rpc[0];
    epsh0_1.epscrv = real_1.rpc[7];
    iorbit_1.iorbit = real_1.rpc[np123_1.np1 + 10];
    soldot_1.soldot = real_1.rpc[np123_1.np1 + np123_1.np2];
    isound = (shortint) real_1.rpc[np123_1.np1 + np123_1.np2 + 1];
    iflash = (shortint) real_1.rpc[np123_1.np1 + np123_1.np2 + 2];
    messag = (shortint) real_1.rpc[np123_1.np1 + np123_1.np2 + 3];
    maxnpt = (shortint) real_1.rpc[np123_1.np1 + np123_1.np2 + 4];
    initv_1.init = real_1.rpc[np123_1.np1 + np123_1.np2 + 5];
} /* rdinit_ */

