/* store.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <stdio.h>



/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
/* 	INCLUDE 'FGRAPH.FI' */

/* ---      INTERFACE TO INTEGER*2 FUNCTION system [C] (STRING[REFERENCE]) */
/* ---       IMPLICIT INTEGER*2 (I-N) */
/* ---      CHARACTER*1 STRING */
/* ---      END */

void store_(FILE *ncan, shortint *pointtype, shortint *npt, shortint *n, shortint *m, shortint *l, doublereal *x, doublereal *p, doublereal *g, doublereal *t, doublereal *rr, doublereal *ri, doublereal *bifval, shortint *ierr)
{
    /* System generated locals */
    shortint s__1;
    integer i__1;

    /* Local variables */
    shortint i;



/*       19.10.94 */

    /* Parameter adjustments */
    --bifval;
    --ri;
    --rr;
    --g;
    --p;
    --x;

    /* Function Body */
    *ierr = 0;
    if( fprintf( ncan, "%d\n", *pointtype ) == EOF )
      goto L10;
    if( fprintf( ncan, "%d\n", *npt ) == EOF )
      goto L10;
    for( i=1; i<= *n; i++ )
      if( fprintf( ncan, "%20.13g\n", x[i] ) == EOF )
	goto L10;
    for( i=1; i<= *m; i++ )
      if( fprintf( ncan, "%20.13g\n", p[i] ) == EOF )
	goto L10;
    if (*l > 0) {
      for( i=1; i<= *l; i++ )
	if( fprintf( ncan, "%20.13g\n", g[i] ) == EOF )
	  goto L10;
    }
    if( fprintf( ncan, "%20.13g\n", *t ) == EOF )
      goto L10;
    for( i=1; i<= *n; i++ )
      if( fprintf( ncan, "%20.13g\n", rr[i] ) == EOF )
	goto L10;
    for( i=1; i<= *n; i++ )
      if( fprintf( ncan, "%20.13g\n", ri[i] ) == EOF )
        goto L10;
    for( i=1; i<=NBFVL; i++ )
      if( fprintf( ncan, "%20.13g\n", bifval[i] ) == EOF )
        goto L10;
/*       report point to the memory object */
    lbmem_(&x[1], n, &p[1], m, t, pointtype, npt);
    return;
L10:
    *ierr = 1;
    return;
} /* store_ */

