/* der23l.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"




/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void der23l_(shortint *n, shortint *nd, doublereal *dh, doublereal *x, doublereal *d, void (*funs) (doublereal*, doublereal*), shortint *ier)
                 
                       
/* Subroutine */                
              
{
    /* System generated locals */
    shortint s__1, s__2;
    doublereal d__1;

    /* Local variables */
    shortint i, j, k, l, m, l1;
    shortint nn;
    doublereal d2h, dh2, d2h3, d4h2;

    static struct {
      doublereal yy[NFMAX*MMAX], gg[NFMAX*MMAX];
    } work4_;
#define work4_1 work4_


/*   COMPUTING THE SECOND AND THIRD DERIVATIVES FOR LYAPUNOV VALUE */
/*        21.02.90 */
/*        15.11.92 */

    /* Parameter adjustments */
    --x;
    --d;

    /* Function Body */
    *ier = 0;
    m = (*n - 2 << 3) + 13;
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
	s__2 = m;
	for (j = 1; j <= s__2; ++j) {
/* L10: */
	    work4_1.yy[i + j * NFMAX - (NFMAX+1)] = 0.;
	}
/* L20: */
    }
    d2h = *dh * 2.;
/* Computing 2nd power */
    d__1 = *dh;
    dh2 = d__1 * d__1;
    d4h2 = dh2 * 4.;
    d2h3 = *dh * 2. * dh2;
    work4_1.yy[NFMAX] = *dh;
    work4_1.yy[2*NFMAX] = -(*dh);
    work4_1.yy[3*NFMAX+1] = *dh;
    work4_1.yy[4*NFMAX+1] = -(*dh);
    work4_1.yy[5*NFMAX] = *dh;
    work4_1.yy[5*NFMAX+1] = *dh;
    work4_1.yy[6*NFMAX] = -(*dh);
    work4_1.yy[6*NFMAX+1] = *dh;
    work4_1.yy[7*NFMAX] = *dh;
    work4_1.yy[7*NFMAX+1] = -(*dh);
    work4_1.yy[8*NFMAX] = -(*dh);
    work4_1.yy[8*NFMAX+1] = -(*dh);
    work4_1.yy[9*NFMAX] = d2h;
    work4_1.yy[10*NFMAX] = -d2h;
    work4_1.yy[11*NFMAX+1] = d2h;
    work4_1.yy[12*NFMAX+1] = -d2h;
    if (*n == 2) {
	goto L50;
    }
    l = 14;
    for (i = 1; i <= 2; ++i) {
	s__1 = *n;
	for (j = 3; j <= s__1; ++j) {
	    work4_1.yy[i + l * NFMAX-(NFMAX+1)] = *dh;
	    work4_1.yy[j + l * NFMAX-(NFMAX+1)] = *dh;
	    work4_1.yy[i + (l + 1) * NFMAX-(NFMAX+1)] = -(*dh);
	    work4_1.yy[j + (l + 1) * NFMAX-(NFMAX+1)] = *dh;
	    work4_1.yy[i + (l + 2) * NFMAX-(NFMAX+1)] = *dh;
	    work4_1.yy[j + (l + 2) * NFMAX-(NFMAX+1)] = -(*dh);
	    work4_1.yy[i + (l + 3) * NFMAX-(NFMAX+1)] = -(*dh);
	    work4_1.yy[j + (l + 3) * NFMAX-(NFMAX+1)] = -(*dh);
/* L30: */
	    l += 4;
	}
/* L40: */
    }
L50:
    funts_(n, &m, &x[1], work4_1.yy, work4_1.gg, funs, ier);
    if (*ier != 0) {
	return;
    }
    nn = *n + *n;
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
	d[i] = (work4_1.gg[i + NFMAX-1] + work4_1.gg[i + 2*NFMAX-1] - work4_1.gg[i - 1] *
		 2.) / dh2;
	d[*n + i] = (work4_1.gg[i + 3*NFMAX-1] + work4_1.gg[i + 4*NFMAX-1] - work4_1.gg[i 
		- 1] * 2.) / dh2;
	d[nn + i] = (work4_1.gg[i + 5*NFMAX-1] - work4_1.gg[i + 6*NFMAX-1] - work4_1.gg[i 
		+ 7*NFMAX-1] + work4_1.gg[i + 8*NFMAX-1]) / d4h2;
/* L60: */
    }
    d[*n * 3 + 1] = (work4_1.gg[9*NFMAX] - work4_1.gg[NFMAX] * 2. + 
	    work4_1.gg[2*NFMAX] * 2. - work4_1.gg[10*NFMAX]) / d2h3;
    d[*n * 3 + 2] = (work4_1.gg[5*NFMAX] + work4_1.gg[6*NFMAX] - work4_1.gg[NFMAX] * (
	    float)2. - (work4_1.gg[6*NFMAX] + work4_1.gg[8*NFMAX] - work4_1.gg[2*NFMAX] * 
	    2.)) / d2h3;
    d[*n * 3 + 3] = (work4_1.gg[5*NFMAX+1] + work4_1.gg[6*NFMAX+1] - work4_1.gg[3*NFMAX+1] * (
	    float)2. - (work4_1.gg[7*NFMAX+1] + work4_1.gg[8*NFMAX+1] - work4_1.gg[4*NFMAX+1] * 
	    2.)) / d2h3;
    d[*n * 3 + 4] = (work4_1.gg[11*NFMAX+1] - work4_1.gg[3*NFMAX+1] * 2. + 
	    work4_1.gg[4*NFMAX+1] * 2. - work4_1.gg[12*NFMAX+1]) / d2h3;
    if (*n == 2) {
	return;
    }
    l1 = *n - 2 << 1;
    k = *n * 3 + 5;
    for (i = 1; i <= 2; ++i) {
	l = 14;
	s__1 = l1;
	for (j = 1; j <= s__1; ++j) {
	    d[k] = (work4_1.gg[i + l * NFMAX-(NFMAX+1)] - work4_1.gg[i + (l + 1) *NFMAX 
		    - (NFMAX+1)] - work4_1.gg[i + (l + 2) * NFMAX-(NFMAX+1)] + work4_1.gg[i 
		    + (l + 3) * NFMAX-(NFMAX+1)]) / d4h2;
	    l += 4;
/* L70: */
	    ++k;
	}
/* L80: */
    }
    return;
} /* der23l_ */

