/* epder1l.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void epder1l_(shortint *n, shortint *nd, doublereal *dh, doublereal *x, doublereal *der, void (*funs) (doublereal*, doublereal*), shortint *ier)
                 
                         
/* Subroutine */                
              
{
    /* Initialized data */

    static doublereal eps0 = 1e-10;

    /* System generated locals */
    shortint s__1, s__2;
    integer der_dim1, der_offset;
    doublereal d__1;

    /* Local variables */
    static doublereal f[NFMAX];
    static shortint i, j;
    static doublereal r, fp[NFMAX], dhx;


/*   CALCULATION OF JACOBIAN MATRIX DFI/DXJ  (I,J=1,N) */
/*          11.04.90 */
/*          15.11.92 */
/*          10.07.94 */

    /* Parameter adjustments */
    der_dim1 = *n;
    der_offset = der_dim1 + 1;
    der -= der_offset;
    --x;

    /* Function Body */
    ++njac_1.njacn;
/*      DH2=DH+DH */

    (*funs)(&x[1], f);
    *ier = ierfs_1.ierfs;
    if (*ier != 0) {
	return;
    }

    s__1 = *n;
    for (j = 1; j <= s__1; ++j) {
	dhx = *dh * ((d__1 = x[j], fabs(d__1)) + 1.);
	r = x[j];
	x[j] = r + dhx;
	(*funs)(&x[1], fp);
	x[j] = r;
	*ier = ierfs_1.ierfs;
	if (*ier != 0) {
	    return;
	}
/*        X(J)=R-DH */
/*        CALL FUNS(X,FM) */
/*        X(J)=R */
/*        IER=IERFS */
/*        IF (IER.NE.0) RETURN */
	s__2 = *n;
	for (i = 1; i <= s__2; ++i) {
/*            DER(I,J)=(FP(I)-FM(I))/DH2 */
	    der[i + j * der_dim1] = (fp[i - 1] - f[i - 1]) / dhx;
	    if ((d__1 = der[i + j * der_dim1], fabs(d__1)) <= eps0) {
		der[i + j * der_dim1] = (float)0.;
	    }
/* L10: */
	}
/* L20: */
    }
    return;
} /* epder1l_ */

