/* epeiglbf.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"



/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void epeiglbf_(shortint *nk, doublereal *x, shortint *ier)
{
    /* System generated locals */
    shortint s__1, s__2;

    /* Local variables */
    static shortint jmin;
    static shortint i, j;
    static doublereal scale[NFMAX], rrmin;
    static doublereal r1, r2;
    static shortint nf1, igh, int_[NFMAX], low;


/*   Compute and output eigenvalues */
/*      07.02.1983 */
/*      15.11.92 */
/*      10.07.94 */

/*         IPR=0  - TOlxKO By~iClEHiE, */
/*         IPR=1  - By~iClEHiE i pE~ATx, */
/*         IPR=2  - TOlxKO pE~ATx. */


    /* Parameter adjustments */
    --x;

    /* Function Body */
    if (linbfe_1.ipr == 2) {
	goto L40;
    }


/*   By~iClEHiE MATPicy liHEAPizAcii */

    der1bf_(nk, &dhf, &x[1], linbf2_1.d, funs_, ier);
    if (*ier != 0) {
	goto L60;
    }

/*   By~iClEHiE CObCTBEHHyX zHA~EHij */

    dbalan_(&linbf_1.nf, &linbf_1.nf, linbf2_1.d, &low, &igh, scale);
    delmhe_(&linbf_1.nf, &linbf_1.nf, &low, &igh, linbf2_1.d, int_);
    dhqr_(&linbf_1.nf, &linbf_1.nf, &low, &igh, linbf2_1.d, linbfe_1.rr, 
	    linbfe_1.ri, ier);
    if (*ier != 0) {
	goto L50;
    }

/*   upOPqdO~iBAHiE CObCTBEHHyX zHA~EHij pO BOzPACTAHi` */
/*      dEjCTBiTElxHOj ~ACTi */

    nf1 = linbf_1.nf - 1;
    s__1 = nf1;
    for (j = 1; j <= s__1; ++j) {
	rrmin = linbfe_1.rr[j - 1];
	jmin = j;
	s__2 = nf1;
	for (i = j; i <= s__2; ++i) {
	    if (linbfe_1.rr[i] >= rrmin) {
		goto L20;
	    }
	    rrmin = linbfe_1.rr[i];
	    jmin = i + 1;
L20:
	    ;
	}
	if (jmin == j) {
	    goto L30;
	}
	r1 = linbfe_1.rr[j - 1];
	r2 = linbfe_1.ri[j - 1];
	linbfe_1.rr[j - 1] = rrmin;
	linbfe_1.ri[j - 1] = linbfe_1.ri[jmin - 1];
	linbfe_1.rr[jmin - 1] = r1;
	linbfe_1.ri[jmin - 1] = r2;
L30:
	;
    }

/*   pE~ATx CObCTBEHHyX zHA~EHij */

    if (linbfe_1.ipr == 0) {
	return;
    }
L40:
    return;

/*   ObPAbOTKA B Clu~AE HEBy~iClEHiq CObCTBEHHyX zHA~EHij */

L50:
    return;
L60:
    return;
} /* epeiglbf_ */

