/* epregpbf.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
/* ----------------------------------------------------------- */
void epregpbf_(shortint *nk, doublereal *x, shortint *iln, shortint *nuf, shortint *ifuns, doublereal *fung, shortint *ierf, shortint *istep)
{
    static doublereal gtkr;
    static shortint jtkr;
    static shortint nt;
    static shortint ier;
    static doublereal glv;
    static shortint jlv;


/*  Processing regular points */
/*     15.11.92 */
/*     10.07.94 */

/* ---- */
    /* Parameter adjustments */
    --x;
    --ifuns;
    --fung;
    --ierf;

    /* Function Body */
    linbfq_1.ipt[1] = 1;
    linbfq_1.inder = 0;
/* ---- */
    nt = *istep + 1;
    prntbf_(nk, &x[1]);
    if (*iln < 0) {
	goto L90;
    }
    eiglbf_(nk, &x[1], &ier);
    if (*iln != 1 && *iln != 11) {
	goto L10;
    }
/* L5: */
    gtkr = fung[4];
    jtkr = ierf[4];
/* ---- */
    linbfr_1.valpt[0] = gtkr;
    linbfq_1.ival[0] = jtkr;
/* ---- */
    goto L90;
L10:
    if (*iln != 2) {
	goto L20;
    }
/* L15: */
    glv = fung[5];
    jlv = ierf[5];
/* ---- */
    linbfr_1.valpt[0] = glv;
    linbfq_1.ival[0] = jlv;
    linbfq_1.ipt[2] = 1;
    if (jlv != 0) {
	linbfq_1.ipt[2] = 2;
    }
    if (jlv == 3) {
	linbfq_1.ipt[2] = -1;
    }

/* 	      IPT(3)=1,2 - Hopf case, IPT(3)=-1 - saddle case */
/* ---- */
    goto L90;
L20:
L90:
    return;
} /* epregpbf_ */

