/* funts.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void funts_(shortint *n, shortint *m, doublereal *x, doublereal *yy, doublereal *gg, void (*funs) (doublereal*, doublereal*), shortint *ier)
                
                        
/* Subroutine */                
              
{
    /* System generated locals */
    shortint s__1, s__2, s__3;

    /* Local variables */
    static shortint i, j, k;
    static doublereal r;


/*   LINEAR TRANSFORMATION OF VARIABLES */
/*   AND INVERSE TRANSFORMATION OF FUNCTIONS */
/*         21.02.90 */
/*         15.11.92 */

    /* Parameter adjustments */
    --x;
    gg -= (NFMAX+1);
    yy -= (NFMAX+1);

    /* Function Body */
    *ier = 0;
    s__1 = *m;
    for (j = 1; j <= s__1; ++j) {
	s__2 = *n;
	for (i = 1; i <= s__2; ++i) {
	    r = 0.;
	    s__3 = *n;
	    for (k = 1; k <= s__3; ++k) {
/* L1: */
		r += pq_1.q[i + k * NFMAX - (NFMAX+1)] * yy[k + j * NFMAX];
	    }
/* L2: */
	    gg[i + j * NFMAX] = r + x[i];
	}
/* L3: */
    }
    s__1 = *m;
    for (j = 1; j <= s__1; ++j) {
/* L4: */
	(*funs)(&gg[j * NFMAX + 1], &yy[j * NFMAX + 1]);
    }
    *ier = ierfs_1.ierfs;
    if (*ier != 0) {
	return;
    }
    s__1 = *m;
    for (j = 1; j <= s__1; ++j) {
	s__2 = *n;
	for (i = 1; i <= s__2; ++i) {
	    r = 0.;
	    s__3 = *n;
	    for (k = 1; k <= s__3; ++k) {
/* L5: */
		r += pq_1.p[i + k * NFMAX - (NFMAX+1)] * yy[k + j * NFMAX];
	    }
/* L6: */
	    gg[i + j * NFMAX] = r;
	}
/* L7: */
    }
    return;
} /* funts_ */

