/* vlp.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"



/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void vlp_(shortint *nk, doublereal *x, doublereal *vl, shortint *ier)
{
    /* Initialized data */

    static doublereal eps0 = .001;

    /* System generated locals */
    shortint s__1;

    /* Local variables */
    static shortint i, k;
    static doublereal al, om;
    static shortint iprint;
    static shortint iel;
    static doublereal eps, vec1[NFMAX], vec2[NFMAX];


/*   Driver for computing first Lyapunov coefficient */
/*     04.05.1981 */
/*     15.11.92 */

    /* Parameter adjustments */
    --x;

    /* Function Body */
    *ier = 0;
    s__1 = linbf_1.nap;
    for (i = 1; i <= s__1; ++i) {
	k = ippar_1.ip[i - 1];
	ppar_1.p[k - 1] = x[linbf_1.nf + i];
/* L10: */
    }
    iprint = 0;
    eps = linbf3_1.eps * 100.;
    if (eps < eps0) {
	eps = eps0;
    }
    if (linbf_1.iln == 3 || linbf_1.iln == 12) {
	eps = 100.;
    }
    lyapun_(&linbf_1.nf, &x[1], funs_, &iprint, &eps, &al, &om, vec1, vec2, 
	    vl, &iel);
    *ier = iel;
    return;
} /* vlp_ */

