/* fpbdata.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <stdio.h>
#include <math.h>

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void fpbdata_(void)
{
    /* System generated locals */
    shortint s__1;

    /* Local variables */
    shortint iprb, i, nk;
    shortint ipoisk;


/*     PARAMETERS' INITIALISATION FOR LINLBF */
/*                    ITERATED MAPS */

/*       20.05.1990 */
/*       02.09.1990 */
/*       16.11.92 */
/*       10.07.94 */

/* !!!  COMMON /ADD4A/ NUE, IPREXT, IVARS(25) */

    nk = linbf_1.nf + linbf_1.nap;
    add6a_1.xgmn = linbfc_1.al[linbf_1.nf];
    add6a_1.xgmx = linbfc_1.ar[linbf_1.nf];
    add1a_1.nstep = 1000;
    add1b_1.dx = -fabs(add1b_1.dx);
    dhf = 1e-5;
    add7a_1.epsnwt = linbf3_1.eps;
    add7b_1.itnwt = 2;
    ipoisk = 1;

    iprb = -1;
    add1a_1.ncan = 6;
/*      HVMN=1.D-10 */
/*      HVMX=10. */
    add2a_1.icrs = 1;
    add2a_1.iprcrs = -1;
    add2b_1.epscrs = linbf3_1.eps;
    add4a_1.nue = linbf_1.nap;
    add4a_1.iprext = -1;
    add4b_1.epsext = linbf3_1.eps;
    s__1 = linbf_1.nap;
    for (i = 1; i <= s__1; ++i) {
	add4a_1.ivars[i - 1] = linbf_1.nf + i;
/* L10: */
    }
    add3a_1.iprzer = -1;
    add3b_1.epszer = linbf3_1.eps;
    add3a_1.nuf = 0;

    if (linbf_1.iln != 0) {
	goto L11;
    }
    add3a_1.nuf = 4;
    add3a_1.ifuns[0] = 1;
    add3a_1.ifuns[1] = 2;
    add3a_1.ifuns[2] = 3;
    add3a_1.ifuns[3] = 4;
    goto L100;

L11:
    if (linbf_1.iln != 1) {
	goto L12;
    }
    add3a_1.nuf = 4;
    add3a_1.ifuns[0] = 2;
    add3a_1.ifuns[1] = 3;
    add3a_1.ifuns[2] = 5;
    add3a_1.ifuns[3] = 4;
    goto L100;

L12:
    if (linbf_1.iln != 2) {
	goto L13;
    }
    add3a_1.nuf = 3;
    add3a_1.ifuns[0] = 1;
    add3a_1.ifuns[1] = 3;
    add3a_1.ifuns[2] = 4;
    goto L100;

L13:
    if (linbf_1.iln != 3) {
	goto L14;
    }
    add3a_1.nuf = 3;
    add3a_1.ifuns[0] = 1;
    add3a_1.ifuns[1] = 2;
    add3a_1.ifuns[2] = 4;
    goto L100;

L14:
    if (linbf_1.iln != 4) {
	goto L21;
    }
    add3a_1.nuf = 3;
    add3a_1.ifuns[0] = 1;
    add3a_1.ifuns[1] = 2;
    add3a_1.ifuns[2] = 3;
    goto L100;

L21:
    if (linbf_1.iln != 11) {
	goto L22;
    }
    add3a_1.nuf = 2;
    add3a_1.ifuns[0] = 5;
    add3a_1.ifuns[1] = 3;
    goto L100;

L22:
    if (linbf_1.iln != 12) {
	goto L23;
    }
    add3a_1.nuf = 1;
    add3a_1.ifuns[0] = 1;
    goto L100;

L23:
    if (linbf_1.iln != 13) {
	goto L24;
    }
    add3a_1.nuf = 2;
    add3a_1.ifuns[0] = 3;
    add3a_1.ifuns[1] = 5;
    goto L100;

L24:
    if (linbf_1.iln != 14) {
	goto L25;
    }
    add3a_1.nuf = 1;
    add3a_1.ifuns[0] = 1;
    goto L100;

L25:
    if (linbf_1.iln != 15) {
	goto L26;
    }
    add3a_1.nuf = 2;
    add3a_1.ifuns[0] = 2;
    add3a_1.ifuns[1] = 5;
    goto L100;

L26:
    if (linbf_1.iln != 16) {
	goto L27;
    }
    add3a_1.nuf = 2;
    add3a_1.ifuns[0] = 2;
    add3a_1.ifuns[1] = 3;
    goto L100;

L27:
    if (linbf_1.iln != 17) {
	goto L28;
    }
    add3a_1.nuf = 4;
    add3a_1.ifuns[0] = 2;
    add3a_1.ifuns[1] = 3;
    add3a_1.ifuns[2] = 5;
    add3a_1.ifuns[3] = 4;
    goto L100;

L28:
    if (linbf_1.iln != 18) {
	goto L29;
    }
    add3a_1.nuf = 3;
    add3a_1.ifuns[0] = 1;
    add3a_1.ifuns[1] = 3;
    add3a_1.ifuns[2] = 4;
    goto L100;

L29:
    if (linbf_1.iln != 19) {
	goto L100;
    }
    add3a_1.nuf = 3;
    add3a_1.ifuns[0] = 1;
    add3a_1.ifuns[1] = 2;
    add3a_1.ifuns[2] = 4;
    goto L100;
L100:
    s__1 = nk;
    for (i = 1; i <= s__1; ++i) {
	scaleb_1.scx[i - 1] = 1.;
/* L145: */
    }

    initbf_();

    return;
} /* fpbdata_ */

