/* cldop5.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>


/* Common Block Declarations */

union {
    struct {
	shortint icont[4];
    } _1;
    struct {
	shortint nn, nn2, nn3, nn4;
    } _2;
    struct {
	shortint n, n2, n3, n4;
    } _3;
} contd_;

#define contd_1 (contd_._1)
#define contd_2 (contd_._2)
#define contd_3 (contd_._3)

union {
    struct {
	doublereal rcont[5*(NFMAX+1)+2];
    } _1;
    struct {
	doublereal xold, hout, cont[1];
    } _2;
    struct {
	doublereal xold, h, cont[1];
    } _3;
} contd1_;

#define contd1_1 (contd1_._1)
#define contd1_2 (contd1_._2)
#define contd1_3 (contd1_._3)

/* Table of constant values */

static shortint cs__411 = 5*(NFMAX+1)+6;
static shortint cs__2 = 2;
static shortint cs__407 = 5*(NFMAX+1)+2;
static doublereal c_b9 = 1.;
static doublereal c_b24 = .2;

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */

void cldop5_(shortint *n, doublereal *t, doublereal *tend, doublereal *x, doublereal *hint, doublereal *hmin, doublereal *hmax, doublereal *epsa, doublereal *epsr, shortint *nmxstp, shortint *mode, shortint *iend, doublereal *work)
{
    shortint idid;
    doublereal atol;
    shortint itol, iout;
    doublereal rtol;
    shortint i;
    shortint iwork[2];

/* * * * * * * * * * * * * * * * * * * * * * * * * * */
/* --- CALL DOPRI5 FOR LOCBIF */
/* * * * * * * * * * * * * * * * * * * * * * * * * * */

/*     14.11.92 */
/* -------------------------------------------------- */

/*      PRINT 101,MODE,NMXSTP,EPSA,EPSR,IWORK(2),IWORK(1),ATOL,RTOL */
/* --- OUTPUT ROUTINE IS USED DURING INTEGRATION */
    /* Parameter adjustments */
    --work;
    --x;

    /* Function Body */
    iout = 1;
/* --- REQUIRED (RELATIVE) TOLERANCE */
    itol = 0;
    atol = *epsa;
    rtol = *epsr;
/* --- DEFAULT VALUES FOR PARAMETERS */
    for (i = 1; i <= 5; ++i) {
/* L10: */
	work[i] = 0.;
    }
    iwork[0] = *nmxstp;
    iwork[1] = *mode;
    work[6] = *hmax;
/*      PRINT 101,MODE,NMXSTP,EPSA,EPSR,IWORK(2),IWORK(1),ATOL,RTOL */
/* 101  FORMAT(/'   MODE,NMXSTP,EPSA,EPSR=',2I8,2G13.4, */
/*     *        '                        =',2I8,2G13.4) */
/* --- CALL OF THE SUBROUTINE DOPRI5 */
    dopri5_(n, funtn_, t, &x[1], tend, hint, &rtol, &atol, &itol, solout_, &
	    iout, &work[1], &cs__411, iwork, &cs__2, &cs__407, &idid);

    *iend = idid;

/* --- PRINT FINAL SOLUTION */
/* --- PRINT STATISTICS */
    return;
} /* cldop5_ */



void solout_(shortint *nr, doublereal *told, doublereal *t, doublereal *x, shortint *n, shortint *irtrn)
{
    static doublereal h;
    static shortint icode, istop;

/* --- CALL FOR OUTDUM (OUTPUT SUBROUTINE) */
/* CC --- PRINTS SOLUTION AT EQUIDISTANT OUTPUT-POINTS */
/* CC --- BY USING "CONTD5", THE CONTINUOUS COLLOCATION SOLUTION */
/*        COMMON /INTERN/XOUT */

    /* Parameter adjustments */
    --x;

    /* Function Body */
    h = *t - *told;
    if (*nr == 1)
      icode = 0;
    else
      icode = 1;
    outdum_(*n, t, &x[1], &h, icode, &istop);
    if (istop != 0)
      *irtrn = -5;
    return;
} /* solout_ */


/*        SUBROUTINE FUNTN(N,T,X,F) */
/* --- CALL FOR FUNT */
/*        IMPLICIT REAL*8 (A-H,O-Z) */
/*        IMPLICIT INTEGER*2(I-N) */
/*        DIMENSION X(N),F(N) */
/*        CALL FUNT(T,X,F) */
/*        RETURN */
/*        END */


void dopri5_(shortint *n, void (*fcn) (shortint *, doublereal *, doublereal *, doublereal *), doublereal *x, doublereal *y, doublereal *xend, doublereal *h, doublereal *rtol, doublereal *atol, shortint *itol, void (*solout) (shortint *, doublereal *, doublereal *, doublereal *, shortint *, shortint *), shortint *iout, doublereal *work, shortint *lwork, shortint *iwork, shortint *liwork, shortint *lrcont, shortint *idid)
{
    static doublereal beta, safe;
    static shortint meth;
    static doublereal hmax;
    static shortint nmax;
    static logical arret;
    static shortint istore;
    static doublereal uround, fac1, fac2;
    static shortint iek1, iek2, iek3, iek4, iek5;

/* ---------------------------------------------------------- */
/*     NUMERICAL SOLUTION OF A SYSTEM OF FIRST 0RDER */
/*     ORDINARY DIFFERENTIAL EQUATIONS  Y'=F(X,Y). */
/*     THIS IS AN EXPLICIT RUNGE-KUTTA METHOD OF ORDER (4)5 */
/*     DUE TO DORMAND & PRINCE (WITH STEPSIZE CONTROL). */
/*     C.F. SECTION II.4 */

/*     AUTHORS: E. HAIRER AND G. WANNER */
/*              UNIVERSITE DE GENEVE, DEPT. DE MATHEMATIQUES */
/*              CH-1211 GENEVE 24, SWITZERLAND */
/*              E-MAIL:  HAIRER@CGEUGE51.BITNET,  WANNER@CGEUGE51.BITNET 
*/

/*     THIS CODE IS AN EXTENSION OF THE CODE DESCRIBED IN: */
/*         E. HAIRER, S.P. NORSETT AND G. WANNER, SOLVING ORDINARY */
/*         DIFFERENTIAL EQUATIONS I. NONSTIFF PROBLEMS. */
/*         SPRINGER SERIES IN COMPUTATIONAL MATHEMATICS 8, */
/*         SPRINGER-VERLAG (1987) */

/*     VERSION OF APRIL 19, 1989 */
/* **** */
/*     ADAPTATION BY A.I.KHIBNIK */
/*                03.01.1991 */
/* **** */

/*     INPUT PARAMETERS */
/*     ---------------- */
/*     N           DIMENSION OF THE SYSTEM */

/*     FCN         NAME (EXTERNAL) OF SUBROUTINE COMPUTING THE */
/*                 VALUE OF F(X,Y): */
/*                    SUBROUTINE FCN(N,X,Y,F) */
/*                    REAL*8 X,Y(N),F(N) */
/*                    F(1)=...   ETC. */

/*     X           INITIAL X-VALUE */

/*     Y(N)        INITIAL VALUES FOR Y */

/*     XEND        FINAL X-VALUE (XEND-X MAY BE POSITIVE OR NEGATIVE) */

/*     H           INITIAL STEP SIZE GUESS; */
/*                 H=1.D0/(NORM OF F'), USUALLY 1.D-1 OR 1.D-3, IS GOOD. 
*/
/*                 THIS CHOICE IS NOT VERY IMPORTANT, THE CODE QUICKLY */
/*                 ADAPTS ITS STEP SIZE. WHEN YOU ARE NOT SURE, THEN */
/*                 STUDY THE CHOSEN VALUES FOR A FEW */
/*                 STEPS IN SUBROUTINE "SOLOUT". */
/*                 (IF H=0.D0, THE CODE PUTS H=1.D-6). */

/*     RTOL,ATOL   RELATIVE AND FABSOLUTE ERROR TOLERANCES. THEY */
/*                 CAN BE BOTH SCALARS OR ELSE BOTH VECTORS OF LENGTH N. 
*/

/*     ITOL        SWITCH FOR RTOL AND ATOL: */
/*                   ITOL=0: BOTH RTOL AND ATOL ARE SCALARS. */
/*                     THE CODE KEEPS, ROUGHLY, THE LOCAL ERROR OF */
/*                     Y(I) BELOW RTOL*FABS(Y(I))+ATOL */
/*                   ITOL=1: BOTH RTOL AND ATOL ARE VECTORS. */
/*                     THE CODE KEEPS THE LOCAL ERROR OF Y(I) BELOW */
/*                     RTOL(I)*FABS(Y(I))+ATOL(I). */

/*     SOLOUT      NAME (EXTERNAL) OF SUBROUTINE PROVIDING THE */
/*                 NUMERICAL SOLUTION DURING INTEGRATION. */
/*                 IF IOUT=1, IT IS CALLED AFTER EVERY SUCCESSFUL STEP. */
/*                 SUPPLY A DUMMY SUBROUTINE IF IOUT=0. */
/*                 IT MUST HAVE THE FORM */
/*                    SUBROUTINE SOLOUT (NR,XOLD,X,Y,N,IRTRN) */
/*                    REAL*8 X,Y(N) */
/*                    .... */
/*                 SOLOUT FURNISHES THE SOLUTION "Y" AT THE NR-TH */
/*                    GRID-POINT "X" (THEREBY THE INITIAL VALUE IS */
/*                    THE FIRST GRID-POINT). */
/*                 "XOLD" IS THE PRECEEDING GRID-POINT. */
/*                 "IRTRN" SERVES TO INTERRUPT THE INTEGRATION. IF IRTRN 
*/
/*                    IS SET <0, DOPRI5 RETURNS TO THE CALLING PROGRAM. */

/*          -----  CONTINUOUS OUTPUT: ----- */
/*                 DURING CALLS TO "SOLOUT", A CONTINUOUS SOLUTION */
/*                 FOR THE INTERVAL [XOLD,X] IS AVAILABLE THROUGH */
/*                 THE FUNCTION */
/*                        >>>   CONTD5(I,S)   <<< */
/*                 WHICH PROVIDES AN APPROXIMATION TO THE I-TH */
/*                 COMPONENT OF THE SOLUTION AT THE POINT S. THE VALUE */
/*                 S SHOULD LIE IN THE INTERVAL [XOLD,X]. */

/*     IOUT        SWITCH FOR CALLING THE SUBROUTINE SOLOUT: */
/*                    IOUT=0: SUBROUTINE IS NEVER CALLED */
/*                    IOUT=1: SUBROUTINE IS AVAILABLE FOR OUTPUT. */

/*     WORK        ARRAY OF WORKING SPACE OF LENGTH "LWORK". */
/*                 "LWORK" MUST BE AT LEAST  5*N+6 */

/*     LWORK       DECLARED LENGHT OF ARRAY "WORK". */

/*     IWORK       INTEGER WORKING SPACE OF LENGHT "LIWORK". */
/*                 IWORK(1) AND IWORK(2) SERVE AS PARAMETERS */
/*                 FOR THE CODE. FOR STANDARD USE, SET IWORK(1) AND */
/*                 IWORK(2) TO ZERO BEFORE CALLING. */
/*                 "LIWORK" MUST BE AT LEAST 2 . */

/*     LIWORK      DECLARED LENGHT OF ARRAY "IWORK". */

/*     LRCONT      DECLARED LENGTH OF COMMON BLOCK */
/*                  >>>  COMMON /CONTD/ICONT(4),RCONT(LRCONT)  <<< */
/*                 WHICH MUST BE DECLARED IN THE CALLING PROGRAM. */
/*                 "LRCONT" MUST BE AT LEAST */
/*                             5*N+2 . */
/*                 THIS IS USED FOR STORING THE COEFFICIENTS OF THE */
/*                 CONTINUOUS SOLUTION AND MAKES THE CALLING LIST FOR THE 
*/
/*                 FUNCTION "CONTD5" AS SIMPLE AS POSSIBLE. */

/* -----------------------------------------------------------------------
 */

/*     SOPHISTICATED SETTING OF PARAMETERS */
/*     ----------------------------------- */
/*              SEVERAL PARAMETERS OF THE CODE ARE TUNED TO MAKE IT WORK 
*/
/*              WELL. THEY MAY BE DEFINED BY SETTING WORK(1),..,WORK(6) */
/*              AS WELL AS IWORK(1) AND IWORK(2) DIFFERENT FROM ZERO. */
/*              FOR ZERO INPUT, THE CODE CHOOSES DEFAULT VALUES: */

/*    IWORK(1)  THIS IS THE MAXIMAL NUMBER OF ALLOWED STEPS. */
/*              THE DEFAULT VALUE (FOR IWORK(2)=0) IS 10000. */

/*    IWORK(2)  SWITCH FOR THE CHOICE OF THE COEFFICIENTS */
/*              IF IWORK(2).EQ.1  METHOD DOPRI5 OF DORMAND AND PRINCE */
/*              (TABLE 4.6 OF SECTION II.4). */
/*              IF IWORK(2).EQ.2  HIGHAM & HALL'S FIRST METHOD */
/*              (TABLE 2.1 OF IV.2). */
/*              IF IWORK(2).EQ.3  THE THIRD METHOD OF HIGHAM & HALL */
/*              THE DEFAULT VALUE (FOR IWORK(2)=0) IS IWORK(2)=1. */

/*    WORK(1)   UROUND, THE ROUNDING UNIT, DEFAULT 1.D-16. */

/*    WORK(2)   THE SAFETY FACTOR IN STEP SIZE PREDICTION, */
/*              DEFAULT 0.9D0. */

/*    WORK(3), WORK(4)   PARAMETERS FOR STEP SIZE SELECTION */
/*              THE NEW STEP SIZE IS CHOSEN SUBJECT TO THE RESTRICTION */
/*                 WORK(3) <= HNEW/HOLD <= WORK(4) */
/*              DEFAULT VALUES: WORK(3)=0.2D0, WORK(4)=10.D0 */

/*    WORK(5)   IS THE "BETA" FOR STABILIZED STEP SIZE CONTROL */
/*              (SEE SECTION IV.2). LARGER VALUES OF BETA MAKE */
/*              THE STEP SIZE CONTROL MORE STABLE. DOPRI5 NEEDS */
/*              A LARGER BETA THAN HIGHAM & HALL. NEGATIVE WORK(5) */
/*              PROVOKE BETA=0. */
/*              DEFAULT 0.13D0. */

/*    WORK(6)   MAXIMAL STEP SIZE, DEFAULT XEND-X. */

/* ----------------------------------------------------------------------C
 */
/*     OUTPUT PARAMETERS */
/*     ----------------- */
/*     X           X-VALUE FOR WHICH THE SOLUTION HAS BEEN COMPUTED */
/*                 (AFTER SUCCESSFUL RETURN X=XEND). */

/*     Y(N)        NUMERICAL SOLUTION AT X */

/*     H           PREDICTED STEP SIZE OF THE LAST ACCEPTED STEP */

/*     IDID        REPORTS ON SUCCESSFULNESS UPON RETURN: */
/*                   IDID=1  COMPUTATION SUCCESSFUL, */
/*                   IDID<0  COMPUTATION UNSUCCESSFUL. */

/* -----------------------------------------------------------------------
 */
/* *** *** *** *** *** *** *** *** *** *** *** *** *** */
/*          DECLARATIONS */
/* *** *** *** *** *** *** *** *** *** *** *** *** *** */
/* --- COMMON STAT CAN BE INSPECTED FOR STATISTICAL PURPOSES: */
/* ---    NFCN      NUMBER OF FUNCTION EVALUATIONS */
/* ---    NSTEP     NUMBER OF COMPUTED STEPS */
/* ---    NACCPT    NUMBER OF ACCEPTED STEPS */
/* ---    NREJCT    NUMBER OF REJECTED STEPS (AFTER AT LEAST ONE STEP */
/*                  HAS BEEN ACCEPTED) */
/* *** *** *** *** *** *** *** */
/*        SETTING THE PARAMETERS */
/* *** *** *** *** *** *** *** */
    /* Parameter adjustments */
    --y;
    --rtol;
    --atol;
    --work;
    --iwork;

    /* Function Body */
    ierfs_1.ierfs = 0;
    iabort_1.iabort = 0;
    stat_1.nfcn = 0;
    stat_1.nstep = 0;
    stat_1.naccpt = 0;
    stat_1.nrejct = 0;
    arret = FALSE_;
/* -------- NMAX , THE MAXIMAL NUMBER OF STEPS ----- */
    if (iwork[1] == 0) {
	nmax = 10000;
    } else {
	nmax = iwork[1];
	if (nmax <= 0) {
	    arret = TRUE_;
	}
    }
/* -------- METH   COEFFICIENTS OF THE METHOD */
    if (iwork[2] == 0) {
	meth = 1;
    } else {
	meth = iwork[2];
	if (meth <= 0 || meth >= 4) {
	    arret = TRUE_;
	}
    }
/* -------- UROUND   SMALLEST NUMBER SATISFYING 1.D0+UROUND>1.D0 */
    if (work[1] == 0.) {
	uround = 1e-16;
    } else {
	uround = work[1];
	if (uround <= 1e-35 || uround >= 1.) {
	    arret = TRUE_;
	}
    }
/* -------  SAFETY FACTOR ------------- */
    if (work[2] == 0.) {
	safe = .9;
    } else {
	safe = work[2];
	if (safe >= 1. || safe <= 1e-4) {
	    arret = TRUE_;
	}
    }
/* -------  FAC1,FAC2     PARAMETERS FOR STEP SIZE SELECTION */
    if (work[3] == 0.) {
	fac1 = .2;
    } else {
	fac1 = work[3];
    }
    if (work[4] == 0.) {
	fac2 = 10.;
    } else {
	fac2 = work[4];
    }
/* --------- BETA FOR STEP CONTROL STABILIZATION ----------- */
    if (work[5] == 0.) {
	beta = .13;
    } else {
	if (work[5] < 0.) {
	    beta = 0.;
	} else {
	    beta = work[5];
	}
    }
/* -------- MAXIMAL STEP SIZE */
    if (work[6] == 0.) {
	hmax = *xend - *x;
    } else {
	hmax = work[6];
    }
/* ------- PREPARE THE ENTRY-POINTS FOR THE ARRAYS IN WORK ----- */
    iek1 = 7;
    iek2 = iek1 + *n;
    iek3 = iek2 + *n;
    iek4 = iek3 + *n;
    iek5 = iek4 + *n;
/* ------ TOTAL STORAGE REQUIREMENT ----------- */
    istore = iek5 + *n - 1;
    if (istore > *lwork) {
	arret = TRUE_;
    }
/* --------- CONTROL OF LENGTH OF COMMON BLOCK "CONT" ------- */
    if (*lrcont < *n * 5 + 2) {
	arret = TRUE_;
    }
/* ------ WHEN A FAIL HAS OCCURED, WE RETURN WITH IDID=-1 */
    if (arret) {
	*idid = -1;
	return;
    }
/* -------- CALL TO CORE INTEGRATOR ------------ */
    dopcor_(n, fcn, x, &y[1], xend, &hmax, h, &rtol[1], &atol[1], itol, 
	    solout, iout, idid, &nmax, &uround, &meth, &safe, &beta, &fac1, &
	    fac2, &work[iek1], &work[iek2], &work[iek3], &work[iek4], &work[
	    iek5]);
/* ----------- RETURN ----------- */
    return;
} /* dopri5_ */




/*  ----- ... AND HERE IS THE CORE INTEGRATOR  ---------- */



void dopcor_(shortint *n, void (*fcn) (shortint *, doublereal *, doublereal *, doublereal *), doublereal *x, doublereal *y, doublereal *xend, doublereal *hmax, doublereal *h, doublereal *rtol, doublereal *atol, shortint *itol, void (*solout) (/* ??? */), shortint *iout, shortint *idid, shortint *nmax, doublereal *uround, shortint *meth, doublereal *safe, doublereal *beta, doublereal *fac1, doublereal *fac2, doublereal *k1, doublereal *k2, doublereal *k3, doublereal *k4, doublereal *k5)
{
    /* System generated locals */
    shortint s__1;
    integer i__1;
    doublereal d__1, d__2, d__3, d__4;

    /* Local variables */
    static doublereal hnew, facc1, facc2, safe1;
    static shortint i;
    static doublereal c2, c3, c4, c5, e1, e3, e4, e5, e6, e7;
    static shortint irtrn;
    static doublereal a21, a31, a32, a41, a42, a43, a51, a52, a53, a54, a61, 
	    a62, a63, a64, a65, a71, a73, a74, a75, a76, d21, d23, d24, d25, 
	    d26, d31, d33, d34, d35, d36, d41, d43, d44, d45, d46;
    static doublereal facold;
    static logical reject;
    static doublereal rr, sk;
    static doublereal posneg, fac, err, xph, fac11;

/* ---------------------------------------------------------- */
/*     CORE INTEGRATOR FOR DOPRI5 */
/*     PARAMETERS SAME AS IN DOPRI5 WITH WORKSPACE ADDED */
/* ---------------------------------------------------------- */
/*         DECLARATIONS */
/* ---------------------------------------------------------- */

/* *** *** *** *** *** *** *** */
/*  INITIALISATIONS */
/* *** *** *** *** *** *** *** */
    /* Parameter adjustments */
    --k5;
    --k4;
    --k3;
    --k2;
    --k1;
    --y;
    --rtol;
    --atol;

    /* Function Body */
    contd_2.nn = *n;
    contd_2.nn2 = *n << 1;
    contd_2.nn3 = *n * 3;
    contd_2.nn4 = *n << 2;
    if (*meth == 1) {
	cdopri_(&c2, &c3, &c4, &c5, &e1, &e3, &e4, &e5, &e6, &e7, &a21, &a31, 
		&a32, &a41, &a42, &a43, &a51, &a52, &a53, &a54, &a61, &a62, &
		a63, &a64, &a65, &a71, &a73, &a74, &a75, &a76, &d21, &d23, &
		d24, &d25, &d26, &d31, &d33, &d34, &d35, &d36, &d41, &d43, &
		d44, &d45, &d46);
    }
    if (*meth == 2) {
	chihaa_(&c2, &c3, &c4, &c5, &e1, &e3, &e4, &e5, &e6, &e7, &a21, &a31, 
		&a32, &a41, &a42, &a43, &a51, &a52, &a53, &a54, &a61, &a62, &
		a63, &a64, &a65, &a71, &a73, &a74, &a75, &a76, &d21, &d23, &
		d24, &d25, &d26, &d31, &d33, &d34, &d35, &d36, &d41, &d43, &
		d44, &d45, &d46);
    }
    if (*meth == 3) {
	chihac_(&c2, &c3, &c4, &c5, &e1, &e3, &e4, &e5, &e6, &e7, &a21, &a31, 
		&a32, &a41, &a42, &a43, &a51, &a52, &a53, &a54, &a61, &a62, &
		a63, &a64, &a65, &a71, &a73, &a74, &a75, &a76, &d21, &d23, &
		d24, &d25, &d26, &d31, &d33, &d34, &d35, &d36, &d41, &d43, &
		d44, &d45, &d46);
    }
    facold = 1e-4;
    facc1 = 1. / *fac1;
    facc2 = 1. / *fac2;
    d__1 = *xend - *x;
    posneg = (d__1>=0.0?fabs(c_b9):-fabs(c_b9));
/* --- INITIAL PREPARATIONS */
    *hmax = fabs(*hmax);
/* Computing MIN */
/* Computing MAX */
    d__2 = 1e-6, d__3 = fabs(*h);
    d__1 = max(d__2,d__3);
    *h = min(d__1,*hmax);
    *h = (posneg>=0.0?fabs(*h):-fabs(*h));
    reject = FALSE_;
    contd1_2.xold = *x;
    if (*iout != 0) {
	irtrn = 1;
	contd1_2.hout = *h;
	i__1 = stat_1.naccpt + 1;
	(*solout)(&i__1, &contd1_2.xold, x, &y[1], n, &irtrn);
	if (irtrn < 0) {
	    goto L79;
	}
    }
    (*fcn)(n, x, &y[1], &k1[1]);
    if (ierfs_1.ierfs != 0) {
	goto L51;
    }
    ++stat_1.nfcn;
/* --- BASIC INTEGRATION STEP */
/* ***   1  IF(NSTEP.GT.NMAX.OR.X+.1D0*H.EQ.X)GOTO 79 */
L1:
    if (stat_1.nstep > *nmax) {
	goto L89;
    }
    rr = *x + *h * .1;
/*      RR=X+H */
    if (rr == *x) {
	goto L89;
    }
    if ((*x - *xend) * posneg + *uround > 0.) {
	*h = hnew;
	*idid = 1;
	return;
    }
/*      RR=X+H-XEND */
    rr = *x + *h * 1.1 - *xend;
    if (rr * posneg > 0.) {
	*h = *xend - *x;
    }
    ++stat_1.nstep;
/* --- THE FIRST 6 STAGES */
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
/* L22: */
	contd1_2.cont[i - 1] = y[i] + *h * a21 * k1[i];
    }
    d__1 = *x + c2 * *h;
    (*fcn)(n, &d__1, contd1_2.cont, &k2[1]);
    if (ierfs_1.ierfs != 0) {
	goto L51;
    }
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
/* L23: */
	contd1_2.cont[i - 1] = y[i] + *h * (a31 * k1[i] + a32 * k2[i]);
    }
    d__1 = *x + c3 * *h;
    (*fcn)(n, &d__1, contd1_2.cont, &k3[1]);
    if (ierfs_1.ierfs != 0) {
	goto L51;
    }
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
/* L24: */
	contd1_2.cont[i - 1] = y[i] + *h * (a41 * k1[i] + a42 * k2[i] + a43 * 
		k3[i]);
    }
    d__1 = *x + c4 * *h;
    (*fcn)(n, &d__1, contd1_2.cont, &k4[1]);
    if (ierfs_1.ierfs != 0) {
	goto L51;
    }
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
/* L25: */
	contd1_2.cont[i - 1] = y[i] + *h * (a51 * k1[i] + a52 * k2[i] + a53 * 
		k3[i] + a54 * k4[i]);
    }
    d__1 = *x + c5 * *h;
    (*fcn)(n, &d__1, contd1_2.cont, &k5[1]);
    if (ierfs_1.ierfs != 0) {
	goto L51;
    }
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
/* L26: */
	contd1_2.cont[i - 1] = y[i] + *h * (a61 * k1[i] + a62 * k2[i] + a63 * 
		k3[i] + a64 * k4[i] + a65 * k5[i]);
    }
    xph = *x + *h;
    (*fcn)(n, &xph, contd1_2.cont, &k2[1]);
    if (ierfs_1.ierfs != 0) {
	goto L51;
    }
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
/* L27: */
	contd1_2.cont[i - 1] = y[i] + *h * (a71 * k1[i] + a73 * k3[i] + a74 * 
		k4[i] + a75 * k5[i] + a76 * k2[i]);
    }
/* --- COMPUTE INTERMEDIATE SUM TO SAVE MEMORY */
    if (*iout != 0) {
	s__1 = *n;
	for (i = 1; i <= s__1; ++i) {
	    contd1_2.cont[i + contd_2.nn - 1] = k1[i];
	    contd1_2.cont[i + contd_2.nn2 - 1] = d21 * k1[i] + d23 * k3[i] + 
		    d24 * k4[i] + d25 * k5[i] + d26 * k2[i];
	    contd1_2.cont[i + contd_2.nn3 - 1] = d31 * k1[i] + d33 * k3[i] + 
		    d34 * k4[i] + d35 * k5[i] + d36 * k2[i];
	    contd1_2.cont[i + contd_2.nn4 - 1] = d41 * k1[i] + d43 * k3[i] + 
		    d44 * k4[i] + d45 * k5[i] + d46 * k2[i];
/* L63: */
	}
    }
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
/* L61: */
	k2[i] = e1 * k1[i] + e3 * k3[i] + e4 * k4[i] + e5 * k5[i] + e6 * k2[i]
		;
    }
/* --- THE LAST STAGE */
    (*fcn)(n, &xph, contd1_2.cont, &k3[1]);
    if (ierfs_1.ierfs != 0) {
	goto L51;
    }
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
/* L28: */
	k4[i] = (k2[i] + e7 * k3[i]) * *h;
    }
    stat_1.nfcn += 6;
/* --- ERROR ESTIMATION */
    err = 0.;
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
	if (*itol == 0) {
/* Computing MAX */
	    d__3 = (d__1 = y[i], fabs(d__1)), d__4 = (d__2 = contd1_2.cont[i - 
		    1], fabs(d__2));
	    sk = atol[1] + rtol[1] * max(d__3,d__4);
	} else {
/* Computing MAX */
	    d__3 = (d__1 = y[i], fabs(d__1)), d__4 = (d__2 = contd1_2.cont[i - 
		    1], fabs(d__2));
	    sk = atol[i] + rtol[i] * max(d__3,d__4);
	}
	rr = k4[i] / sk;
	if (fabs(rr) > 1e20) {
	    goto L51;
	}
/* Computing 2nd power */
	d__1 = rr;
	err += d__1 * d__1;
/* L41: */
    }
/* ***  41  ERR=ERR+(K4(I)/SK)**2 */
    err = sqrt(err / *n);
/* --- COMPUTATION OF HNEW */
    fac11 = pow(err, c_b24);
/* --- LUND-STABILIZATION */
    fac = fac11 / pow(facold, *beta);
/* --- WE REQUIRE  FAC1 <= HNEW/H <= FAC2 */
/* Computing MAX */
/* Computing MIN */
    d__3 = facc1, d__4 = fac / *safe;
    d__1 = facc2, d__2 = min(d__3,d__4);
    fac = max(d__1,d__2);
    hnew = *h / fac;
    if (err <= 1.) {
/* --- STEP IS ACCEPTED */
	facold = max(err,1e-4);
	++stat_1.naccpt;
	s__1 = *n;
	for (i = 1; i <= s__1; ++i) {
	    k1[i] = k3[i];
	    safe1 = y[i];
	    y[i] = contd1_2.cont[i - 1];
/* L44: */
	    contd1_2.cont[i - 1] = safe1;
	}
	contd1_2.xold = *x;
	*x = xph;
	if (*iout != 0) {
	    contd1_2.hout = *h;
	    i__1 = stat_1.naccpt + 1;
	    (*solout)(&i__1, &contd1_2.xold, x, &y[1], n, &irtrn);
	    if (irtrn < 0) {
		goto L79;
	    }
	}
	if (fabs(hnew) > *hmax) {
	    hnew = posneg * *hmax;
	}
	if (reject) {
/* Computing MIN */
	    d__1 = fabs(hnew), d__2 = fabs(*h);
	    hnew = posneg * min(d__1,d__2);
	}
	reject = FALSE_;
    } else {
/* --- STEP IS REJECTED */
/* Computing MIN */
	d__1 = facc1, d__2 = fac11 / *safe;
	hnew = *h / min(d__1,d__2);
	reject = TRUE_;
	if (stat_1.naccpt >= 1) {
	    ++stat_1.nrejct;
	}
    }
    *h = hnew;
    goto L1;
/* **** RHS FAIL PROCESSING */
L51:
    if (ierfs_1.ierfs < 0 || iabort_1.iabort != 0 || stat_1.nfcn == 0) {
/* **** COMPUTATION INTERRUPTED */
	goto L79;
    } else {
/* **** STEP IS REJECTED */
	hnew = *h / 2.;
	reject = TRUE_;
	if (stat_1.naccpt >= 1) {
	    ++stat_1.nrejct;
	}
    }
    *h = hnew;
    goto L1;
/* --- FAIL EXIT */
L79:
    *idid = -5;
    goto L200;
L89:
    *idid = -3;
L200:
    return;
} /* dopcor_ */


doublereal contd5_(shortint *i, doublereal *x)
{
    /* System generated locals */
    doublereal ret_val;

    /* Local variables */
    static doublereal s;

/* ---------------------------------------------------------- */
/*     THIS FUNCTION CAN BE USED FOR CONINUOUS OUTPUT IN CONECTION */
/*     WITH THE OUTPUT-SUBROUTINE FOR DOPRI5. IT PROVIDES AN */
/*     APPROXIMATION TO THE I-TH COMPONENT OF THE SOLUTION AT X. */
/* ---------------------------------------------------------- */
/*      COMMON /CONTD/N,N2,N3,N4,XOLD,H,CONT(1) */
    s = (*x - contd1_3.xold) / contd1_3.h;
    ret_val = contd1_3.cont[*i - 1] + contd1_3.h * s * (contd1_3.cont[*i + 
	    contd_3.n - 1] + s * (contd1_3.cont[*i + contd_3.n2 - 1] + s * (
	    contd1_3.cont[*i + contd_3.n3 - 1] + s * contd1_3.cont[*i + 
	    contd_3.n4 - 1])));
    return ret_val;
} /* contd5_ */


void cdopri_(doublereal *c2, doublereal *c3, doublereal *c4, doublereal *c5, doublereal *e1, doublereal *e3, doublereal *e4, doublereal *e5, doublereal *e6, doublereal *e7, doublereal *a21, doublereal *a31, doublereal *a32, doublereal *a41, doublereal *a42, doublereal *a43, doublereal *a51, doublereal *a52, doublereal *a53, doublereal *a54, doublereal *a61, doublereal *a62, doublereal *a63, doublereal *a64, doublereal *a65, doublereal *a71, doublereal *a73, doublereal *a74, doublereal *a75, doublereal *a76, doublereal *d21, doublereal *d23, doublereal *d24, doublereal *d25, doublereal *d26, doublereal *d31, doublereal *d33, doublereal *d34, doublereal *d35, doublereal *d36, doublereal *d41, doublereal *d43, doublereal *d44, doublereal *d45, doublereal *d46)
{
/* ---------------------------------------------------------- */
/*     THESE ARE THE COEFFICIENTS OF THE RK=METHOD DOPRI5 */
/*     (IN THE BOOK ON PAGE 171) */
/* ---------------------------------------------------------- */
    *c2 = .2;
    *c3 = .3;
    *c4 = .8;
    *c5 = .88888888888888884;
    *a21 = .2;
    *a31 = .074999999999999997;
    *a32 = .22500000000000001;
    *a41 = .97777777777777775;
    *a42 = -3.7333333333333334;
    *a43 = 3.5555555555555554;
    *a51 = 2.9525986892242035;
    *a52 = -11.595793324188385;
    *a53 = 9.8228928516994358;
    *a54 = -.29080932784636487;
    *a61 = 2.8462752525252526;
    *a62 = -10.757575757575758;
    *a63 = 8.9064227177434727;
    *a64 = .27840909090909088;
    *a65 = -.2735313036020583;
    *a71 = .091145833333333329;
    *a73 = .44923629829290207;
    *a74 = .65104166666666663;
    *a75 = -.322376179245283;
    *a76 = .13095238095238096;
    *e1 = .0012326388888888888;
    *e3 = -.0042527702905061394;
    *e4 = .036979166666666667;
    *e5 = -.05086379716981132;
    *e6 = .041904761904761903;
    *e7 = -.025000000000000001;
    *d21 = -2.7854166666666669;
    *d23 = 3.7879604672057501;
    *d24 = -1.6875000000005215;
    *d25 = -.25790094339622643;
    *d26 = .94285714285714284;
    *d31 = 2.8861111111111111;
    *d33 = -5.6088649296196467;
    *d34 = 4.5000000002980232;
    *d35 = 1.2608490566037736;
    *d36 = -3.038095238095238;
    *d41 = -1.0095486111111112;
    *d43 = 2.2701407607067985;
    *d44 = -2.1614583333333335;
    *d45 = -1.3253242924528301;
    *d46 = 2.2261904761904763;
    return;
} /* cdopri_ */


void chihaa_(doublereal *c2, doublereal *c3, doublereal *c4, doublereal *c5, doublereal *e1, doublereal *e3, doublereal *e4, doublereal *e5, doublereal *e6, doublereal *e7, doublereal *a21, doublereal *a31, doublereal *a32, doublereal *a41, doublereal *a42, doublereal *a43, doublereal *a51, doublereal *a52, doublereal *a53, doublereal *a54, doublereal *a61, doublereal *a62, doublereal *a63, doublereal *a64, doublereal *a65, doublereal *a71, doublereal *a73, doublereal *a74, doublereal *a75, doublereal *a76, doublereal *d21, doublereal *d23, doublereal *d24, doublereal *d25, doublereal *d26, doublereal *d31, doublereal *d33, doublereal *d34, doublereal *d35, doublereal *d36, doublereal *d41, doublereal *d43, doublereal *d44, doublereal *d45, doublereal *d46)
{
/* ---------------------------------------------------------- */
/*     HIGHAM & HALL'S FIRST METHOD (TABLE 2.1 OF IV.2) */
/* ---------------------------------------------------------- */
    *c2 = .22222222222222221;
    *c3 = .33333333333333331;
    *c4 = .50000000067055225;
    *c5 = .59999999999999998;
    *a21 = .22222222222222221;
    *a31 = .083333333333333329;
    *a32 = .25000000006705523;
    *a41 = .12500000000670552;
    *a42 = 0.;
    *a43 = .37500000000670552;
    *a51 = .182;
    *a52 = -.27000000000000002;
    *a53 = .624;
    *a54 = .064000000000000001;
    *a61 = -.55000000000000004;
    *a62 = 1.3500000000000001;
    *a63 = 2.3999999999999999;
    *a64 = -7.2000000000000002;
    *a65 = 5.;
    *a71 = .083333333333333329;
    *a73 = .84375000000002235;
    *a74 = -1.3333333333333333;
    *a75 = 1.3020833333333333;
    *a76 = .10416666666666667;
    *e1 = .050000000000000003;
    *e3 = -.50624999999999998;
    *e4 = 1.2;
    *e5 = -.7812500000000149;
    *e6 = -.062500000000670552;
    *e7 = .10000000000000001;
    *d21 = -3.7500000000298023;
    *d23 = 14.343750000000024;
    *d24 = -22.;
    *d25 = 11.718750000000042;
    *d26 = -.31250000000052154;
    *d31 = 5.333333333333333;
    *d33 = -30.375000000002384;
    *d34 = 50.666666666666664;
    *d35 = -26.041666666666668;
    *d36 = .41666666666666669;
    *d41 = -2.5000000004470348;
    *d43 = 16.875000000001192;
    *d44 = -30.;
    *d45 = 15.625000000004172;
    *d46 = 0.;
    return;
} /* chihaa_ */


void chihac_(doublereal *c2, doublereal *c3, doublereal *c4, doublereal *c5, doublereal *e1, doublereal *e3, doublereal *e4, doublereal *e5, doublereal *e6, doublereal *e7, doublereal *a21, doublereal *a31, doublereal *a32, doublereal *a41, doublereal *a42, doublereal *a43, doublereal *a51, doublereal *a52, doublereal *a53, doublereal *a54, doublereal *a61, doublereal *a62, doublereal *a63, doublereal *a64, doublereal *a65, doublereal *a71, doublereal *a73, doublereal *a74, doublereal *a75, doublereal *a76, doublereal *d21, doublereal *d23, doublereal *d24, doublereal *d25, doublereal *d26, doublereal *d31, doublereal *d33, doublereal *d34, doublereal *d35, doublereal *d36, doublereal *d41, doublereal *d43, doublereal *d44, doublereal *d45, doublereal *d46)
{
/* ---------------------------------------------------------- */
/*     THE THIRD METHOD OF HIGHAM & HALL */
/* ---------------------------------------------------------- */
    *c2 = .24444444444444444;
    *c3 = .36666666666666664;
    *c4 = .9821428571428571;
    *c5 = .90000000000000002;
    *a21 = .24444444444444444;
    *a31 = .09166666666666666;
    *a32 = .27500000000000002;
    *a41 = 1.2170303389212829;
    *a42 = -4.6507721392128278;
    *a43 = 4.4158846574344022;
    *a51 = .65704958677685954;
    *a52 = -2.3931818181818181;
    *a53 = 2.5980833479866363;
    *a54 = .038048883418322493;
    *a61 = 1.1442501121148057;
    *a62 = -4.2811839323467229;
    *a63 = 4.0674160979140508;
    *a64 = -.090576649101075435;
    *a65 = .1600943714189417;
    *a71 = .1145087235996327;
    *a73 = .53098942185779197;
    *a74 = -.6265558622130819;
    *a75 = .60386473429951693;
    *a76 = .37719298245614036;
    *e1 = .0015556635877491491;
    *e3 = -.0066144011027268208;
    *e4 = -.56863893377321728;
    *e5 = .12787723785166241;
    *e6 = .54582043343653253;
    *e7 = -.10000000000000001;
    *d21 = -2.4155080213903743;
    *d23 = 3.6177099364636418;
    *d24 = -1.3465685862268548;
    *d25 = -3.5166240409207159;
    *d26 = 3.6609907120743035;
    *d31 = 2.2734943013017879;
    *d33 = -5.0453181744688473;
    *d34 = 5.8733030613335542;
    *d35 = 8.1699346405228752;
    *d36 = -11.27141382868937;
    *d41 = -.74347755631178092;
    *d43 = 1.9585976598629975;
    *d44 = -5.1532903373197811;
    *d45 = -4.0494458653026424;
    *d46 = 7.9876160990712073;
    return;
} /* chihac_ */

