/* lcmessng.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <strings.h>

/* Table of constant values */

static integer c__1 = 1;

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */

void lcmessng_( int linetype, int pointtype, double *bifval, char *text)
{


  /*  Singular point messages */
  /*       case: Fixed points, Periodic solutions, Limit cycles */
  
  /*     10.07.94 */


  /* Parameter adjustments */
  --bifval;
  
  /* Function Body */
  strcpy( text, " Undefined point type " );
  
  /*  Singular point */
  
  switch (linetype) {
  case 1:  goto L3015;
  case 2:  goto L3016;
  case 3:  goto L3001;
  case 4:  goto L3002;
  case 5:  goto L3003;
  case 6:  goto L3004;
  case 7:  goto L3005;
  case 8:  goto L3006;
  case 9:  goto L3007;
  case 10:  goto L3008;
  case 11:  goto L3009;
  case 12:  goto L3010;
  case 13:  goto L3011;
  case 14:  goto L3012;
  case 15:  goto L3013;
  case 16:  goto L3014;
  }
  /*-------------------------------------------------------------------------*/
  /*    Orbit */
  
 L3015:
  /*  Period point */
  if (pointtype == 300) 
    sprintf( text, " Pause: t=%13.6g\n", bifval[1] );
  return;
  /*-------------------------------------------------------------------------*/
  /*    Curve */
  
 L3016:
  return;
  /*-------------------------------------------------------------------------*/
  /*   Equilibrium curve */
  
 L3001:
  /*   Multiplier = 1 */
  if (pointtype == 311) 
    sprintf( text, " Multiplier = 1 :  a=%13.6g\n", bifval[1] );
  if (pointtype == 312) 
    sprintf( text, " Multiplier = 1(?) a=%13.6g\n", bifval[1] );
  if (pointtype == 313) 
    strcpy( text, " Multiplier = 1 :  a=? " );
  if (pointtype == 314) 
    strcpy( text, " Multiplier = 1(?) a=? " );
  /*  Hopf */
  if (pointtype == 321) 
    strcpy( text, " Hopf   " );
  if (pointtype == 322) 
    strcpy( text, " Hopf (?)" );
  if (pointtype == 323) 
    strcpy( text, " Hopf   " );
  if (pointtype == 324) 
    strcpy( text, " Hopf (?)" );
  if (pointtype == 325) 
    strcpy( text, " Neutral saddle " );
  if (pointtype == 326) 
    strcpy( text, " Neutral saddle (?) " );
  /*  Multiplier = -1 */
  if (pointtype == 331) 
    strcpy( text, " Multiplier = -1 " );
  if (pointtype == 332) 
    strcpy( text, " Multiplier = -1 (?) " );
  /*  Double multiplier */
  if (pointtype == 341) 
    strcpy( text, " Double multiplier " );
  if (pointtype == 342) 
    strcpy( text, " Double multiplier (?) " );
  return;
  /*-------------------------------------------------------------------------*/
  /*   Fold curve */
  
 L3002:
  /*   Neutrality */
  if (pointtype == 311) 
    sprintf( text, " Neutrality : a=%13.6g\n", bifval[1] );
  if (pointtype == 312) 
    sprintf( text, " Neutrality(?) a=%13.6g\n", bifval[1] );
  if (pointtype == 313) 
    strcpy( text, " Neutrality  : a=? " );
  if (pointtype == 314) 
    strcpy( text, " Neutrality(?) a=? " );
  /*   Multiplier = -1 */
  if (pointtype == 321) 
    sprintf( text, " Multiplier = -1 :  a=%13.6g\n", bifval[1] );
  if (pointtype == 322) 
    sprintf( text, " Multiplier = -1(?) a=%13.6g\n", bifval[1] );
  if (pointtype == 323) 
    strcpy( text, " Multiplier = -1 : a=? " );
  if (pointtype == 324) 
    strcpy( text, " Multiplier = -1(?) a=? " );
  /*   Cusp */
  if (pointtype == 331) 
    strcpy( text, " Cusp " );
  if (pointtype == 332) 
    strcpy( text, " Cusp(?) " );
  /*  Double multiplier */
  if (pointtype == 341) 
    sprintf( text, " Double multiplier : a=%13.6g\n", bifval[1] );
  if (pointtype == 342) 
    sprintf( text, " Double multiplier(?) a=%13.6g\n", bifval[1] );
  if (pointtype == 343) 
    strcpy( text, " Double multiplier : a=? " );
  if (pointtype == 344) 
    strcpy( text, " Double multiplier(?) a=? " );
  return;
  /*-------------------------------------------------------------------------*/
  /*   Hopf curve */
  
 L3003:
  /*   Multiplier = 1 */
  if (pointtype == 311) 
    sprintf( text, " Multiplier = 1 :  a=%13.6g\n", bifval[1] );
  if (pointtype == 312) 
    sprintf( text, " Multiplier = 1(?) a=%13.6g\n", bifval[1] );
  if (pointtype == 313) 
    strcpy( text, " Multiplier = 1 :  a=? " );
  if (pointtype == 314) 
    strcpy( text, " Multiplier = 1(?) a=? " );
  /*  Multiplier = -1 */
  if (pointtype == 321) 
    strcpy( text, " Multiplier = -1 " );
  if (pointtype == 322) 
    strcpy( text, " Multiplier = -1 (?) " );
  /*  Double multiplier */
  if (pointtype == 331) 
    strcpy( text, " Double multiplier " );
  if (pointtype == 332) 
    strcpy( text, " Double multiplier (?) " );
  return;
  /*-------------------------------------------------------------------------*/
  /*   Flip curve */
  
 L3004:
  /*  Multiplier = 1 */
  if (pointtype == 311) 
    sprintf( text, " Multiplier = 1 :  a=%13.6g\n", bifval[1] );
  if (pointtype == 312) 
    sprintf( text, " Multiplier = 1(?) a=%13.6g\n", bifval[1] );
  if (pointtype == 313) 
    strcpy( text, " Multiplier = 1 :  a=? " );
  if (pointtype == 314) 
    strcpy( text, " Multiplier = 1(?) a=? " );
  /*  Neutrality */
  if (pointtype == 321) 
    strcpy( text, " Neutrality " );
  if (pointtype == 322) 
    strcpy( text, " Neutrality(?) " );
  /*  Double multiplier */
  if (pointtype == 331) 
    strcpy( text, " Double multiplier " );
  if (pointtype == 332) 
    strcpy( text, " Double multiplier (?) " );
  return;
  /*-------------------------------------------------------------------------*/
  /*  Double Multiplier curve */
  
 L3005:
  /*  Multiplier = 1 */
  if (pointtype == 311) 
    sprintf( text, " Multiplier = 1 :  a=%13.6g\n", bifval[1] );
  if (pointtype == 312) 
    sprintf( text, " Multiplier = 1(?) a=%13.6g\n", bifval[1] );
  if (pointtype == 313) 
    strcpy( text, " Multiplier = 1 :  a=? " );
  if (pointtype == 314) 
    strcpy( text, " Multiplier = 1(?) a=? " );
  /*  Neutrality */
  if (pointtype == 321) 
    strcpy( text, " Neutrality " );
  if (pointtype == 322) 
    strcpy( text, " Neutrality(?) " );
  /*  Multiplier = -1 */
  if (pointtype == 331) 
    strcpy( text, " Multiplier = -1 " );
  if (pointtype == 332) 
    strcpy( text, " Multiplier = -1 (?) " );
  return;
  /*-------------------------------------------------------------------------*/
  /*   Double (+1) curve */
  
 L3006:
  /*   Cusp */
  if (pointtype == 311) 
    strcpy( text, " Cusp " );
  if (pointtype == 312) 
    strcpy( text, " Cusp(?) " );
  /*  Multiplier = -1 */
  if (pointtype == 321) 
    strcpy( text, " Multiplier = -1 " );
  if (pointtype == 322) 
    strcpy( text, " Multiplier = -1 (?) " );
  return;
  /*-------------------------------------------------------------------------*/
  /*   Double (-1) curve */
  
 L3007:
  /*   Multiplier = 1 */
  if (pointtype == 311) 
    sprintf( text, " Multiplier = 1 :  a=%13.6g\n", bifval[1] );
  if (pointtype == 312) 
    sprintf( text, " Multiplier = 1(?) a=%13.6g\n", bifval[1] );
  if (pointtype == 313) 
    strcpy( text, " Multiplier = 1 :  a=? " );
  if (pointtype == 314) 
    strcpy( text, " Multiplier = 1(?) a=? " );
  return;
  /*-------------------------------------------------------------------------*/
  /*  Fold + Hopf curve */
  
 L3008:
  /*   Multiplier = -1 */
  if (pointtype == 311) 
    sprintf( text, " Multiplier = -1 :  a=%13.6g\n", bifval[1] );
  if (pointtype == 312) 
    sprintf( text, " Multiplier = -1(?) a=%13.6g\n", bifval[1] );
  if (pointtype == 313) 
    strcpy(text, " Multiplier = -1 : a=? " );
  if (pointtype == 314) 
    strcpy( text, " Multiplier = -1(?) a=? " );
  /*  Cusp */
  if (pointtype == 321) 
    strcpy( text, " Cusp " );
  if (pointtype == 322) 
    strcpy( text, " Cusp(?) " );
  return;
  /*-------------------------------------------------------------------------*/
  /*   Flip + Hopf curve */
  
 L3009:
  /*  Multiplier = 1 */
  if (pointtype == 311) 
    sprintf( text, " Multiplier = 1 :  a=%13.6g\n", bifval[1] );
  if (pointtype == 312) 
    sprintf( text, " Multiplier = 1(?) a=%13.6g\n", bifval[1] );
  if (pointtype == 313) 
    strcpy( text, " Multiplier = 1 :  a=? " );
  if (pointtype == 314) 
    strcpy( text, " Multiplier = 1(?) a=? " );
  return;
  /*-------------------------------------------------------------------------*/
  /*   Fold + Flip curve */
  
 L3010:
  /*   Neutrality */
  if (pointtype == 311) 
    sprintf( text, " Neutrality : a=%13.6g\n", bifval[1] );
  if (pointtype == 312) 
    sprintf( text, " Neutrality(?) a=%13.6g\n", bifval[1] );
  if (pointtype == 313) 
    strcpy( text, " Neutrality  : a=? " );
  if (pointtype == 314) 
    strcpy( text, " Neutrality(?) a=? " );
  /*  Cusp */
  if (pointtype == 321) 
    strcpy( text, " Cusp " );
  if (pointtype == 322) 
    strcpy( text, " Cusp(?) " );
  return;
  /*-------------------------------------------------------------------------*/
  /*   Cusp curve */
  
 L3011:
  /*   Nutrality */
  if (pointtype == 311) 
    strcpy( text, " Neutrality " );
  if (pointtype == 312) 
    strcpy( text, " Neutrality(?) " );
  /*  Multiplier = -1 */
  if (pointtype == 321) 
    strcpy( text, " Multiplier = -1 " );
  if (pointtype == 322) 
    strcpy( text, " Multiplier = -1 (?) " );
  return;
  /*-------------------------------------------------------------------------*/
  /*   Fold + Extr  curve */
  
 L3012:
  /*   Neutrality */
  if (pointtype == 311) 
    sprintf( text, " Neutrality : a=%13.6g\n", bifval[1] );
  if (pointtype == 312) 
    sprintf( text, " Neutrality(?) a=%13.6g\n", bifval[1] );
  if (pointtype == 313) 
    strcpy(text, " Neutrality  : a=? " );
  if (pointtype == 314) 
    strcpy( text, " Neutrality(?) a=? " );
  /*   Multiplier = -1 */
  if (pointtype == 321) 
    sprintf( text, " Multiplier = -1 :  a=%13.6g\n", bifval[1] );
  if (pointtype == 322) 
    sprintf( text, " Multiplier = -1(?) a=%13.6g\n", bifval[1] );
  if (pointtype == 323) 
    strcpy( text, " Multiplier = -1 : a=? " );
  if (pointtype == 324) 
    strcpy( text, " Multiplier = -1(?) a=? " );
  /*   Cusp */
  if (pointtype == 331) 
    strcpy( text, " Cusp " );
  if (pointtype == 332) 
    strcpy( text, " Cusp(?) " );
  /*  Double multiplier */
  if (pointtype == 341) 
    sprintf( text, " Double multiplier : a=%13.6g\n", bifval[1] );
  if (pointtype == 342) 
    sprintf( text, " Double multiplier(?) a=%13.6g\n", bifval[1] );
  if (pointtype == 343) 
    strcpy( text, " Double multiplier : a=? " );
  if (pointtype == 344) 
    strcpy( text, " Double multiplier(?) a=? " );
  return;
  /*-------------------------------------------------------------------------*/
  /*   Hopf + Extr  curve */
  
 L3013:
  /*   Multiplier = 1 */
  if (pointtype == 311) 
    sprintf( text, " Multiplier = 1 :  a=%13.6g\n", bifval[1] );
  if (pointtype == 312) 
    sprintf( text, " Multiplier = 1(?) a=%13.6g\n", bifval[1] );
  if (pointtype == 313) 
    strcpy( text, " Multiplier = 1 :  a=? " );
  if (pointtype == 314) 
    strcpy( text, " Multiplier = 1(?) a=? " );
  /*  Multiplier = -1 */
  if (pointtype == 321) 
    strcpy( text, " Multiplier = -1 " );
  if (pointtype == 322) 
    strcpy( text, " Multiplier = -1 (?) " );
  /*  Double multiplier */
  if (pointtype == 331) 
    strcpy( text, " Double multiplier " );
  if (pointtype == 332) 
    strcpy( text, " Double multiplier (?) " );
  return;
  /*-------------------------------------------------------------------------*/
  /*   Flip + Extr curve */
  
 L3014:
  /*  Multiplier = 1 */
  if (pointtype == 311) 
    sprintf( text, " Multiplier = 1 :  a=%13.6g\n", bifval[1] );
  if (pointtype == 312) 
    sprintf( text, " Multiplier = 1(?) a=%13.6g\n", bifval[1] );
  if (pointtype == 313) 
    strcpy( text, " Multiplier = 1 :  a=? " );
  if (pointtype == 314) 
    strcpy( text, " Multiplier = 1(?) a=? " );
  /*  Neutrality */
  if (pointtype == 321) 
    strcpy( text, " Neutrality " );
  if (pointtype == 322) 
    strcpy( text, " Neutrality(?) " );
  /*  Double multiplier */
  if (pointtype == 331) 
    strcpy( text, " Double multiplier " );
  if (pointtype == 332) 
    strcpy( text, " Double multiplier (?) " );
  return;
} /* lcmessng_ */

