/* outlbf.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"


/* Table of constant values */

static shortint cs__84 = NDIM;

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void outlbf_(shortint *istep, shortint *index, shortint *nk, shortint *ndimm, doublereal *x, doublereal *vmove, doublereal *dfun, shortint *istop)
{
    /* System generated locals */
    shortint s__1;

    /* Local variables */
    shortint mode, i, k;
    shortint jsign;
    shortint ifzero, iex, jex;
    doublereal pex;

/* 		 6.06.1989 */
/*                14.11.92 */

/* ---- */
/* ---- */
/* ---- */

    /* Parameter adjustments */
    dfun -= (NDIM+1);
    --vmove;
    --x;
    --index;

    /* Function Body */
    linbfe_1.ipr = 1;
    *istop = 0;
    if (out8_1.indout != 0) {
	goto L500;
    }
/* ---- */
    linbfq_1.ipt[0] = linbf_1.iln;
    linbfq_1.ipt[1] = 0;
    linbfq_1.ipt[2] = 0;
    linbfq_1.ipt[3] = 0;
    linbfq_1.inder = 0;
    for (i = 1; i <= 10; ++i) {
	linbfq_1.ival[i - 1] = 0;
/* L210: */
    }
/* ---- */
    if (*istep != 0) {
	goto L220;
    }
    linbfv_1.npc = 0;
    linbfv_1.nbf = 0;
    linbfu_1.arcl = 0.;
    s__1 = *nk;
    for (i = 1; i <= s__1; ++i) {
	linbfu_1.prp[i - 1] = x[i];
/* L215: */
    }
L220:
    if (index[1] != 0) {
	goto L10;
    }
    if (index[2] != 0) {
	goto L20;
    }
    if (index[3] != 0) {
	goto L30;
    }
    if (index[4] != 0) {
	goto L40;
    }
    goto L99;
L10:
    regpbf_(nk, &x[1], &linbf_1.iln, &add3a_1.nuf, add3a_1.ifuns, out1_1.g,
	     out2_1.ierf, istep);
    goto L99;
L20:
    crsbf_(nk, &x[1], &out7_1.indc);
    goto L99;
L30:
    ifzero = index[3];
    zerobf_(nk, &x[1], &ifzero, &out4_1.fzero, &out2_1.indz);
    goto L99;
L40:
    iex = abs(index[4]);
    pex = x[iex];
    jex = ippar_1.ip[iex - linbf_1.nf - 1];
    jsign = 1;
    if (index[4] < 0) {
	jsign = -1;
    }
    extrbf_(nk, &x[1], &jex, &pex, &jsign, &out6_1.inde);
    goto L99;
L99:
    mode = 1;
    ordbf_(istep, nk, &x[1], &mode, istop);
    wline_(istep, &index[1], nk, &cs__84, &x[1], &vmove[1], &dfun[NDIM+1], istop);
    goto L199;
L500:
    mode = 2;
    ordbf_(istep, nk, &x[1], &mode, istop);
    if (*istop != 0) {
	goto L199;
    }
    s__1 = linbf_1.nap;
    for (i = 1; i <= s__1; ++i) {
	k = ippar_1.ip[i - 1];
	if (x[linbf_1.nf + i] <= linbfc_1.al[k - 1] || x[linbf_1.nf + i] >= 
		linbfc_1.ar[k - 1]) {
	    goto L520;
	}
/* L510: */
    }
    goto L199;
L520:
    *istop = 100;
    linbfp_1.igran = 1;
L199:
    return;
} /* outlbf_ */

