/* trflp.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void trflp_(shortint *nk, doublereal *x, doublereal *dtran, shortint *ier)
{
    /* System generated locals */
    shortint s__1;
    doublereal d__1;

    /* Local variables */
    shortint i, k, l;
    doublereal r1;
    shortint nfp, nfp2;


/*   COMPUTING THE FUNCTION CORRESPONDING NONTRANSVERSAL CASE */
/*   FOR FLIP CURVE (NONTRANSVERSALITY OVER PARAMETER P(IP(1))  ) */
/*         ITERATED MAPS */
/*        22.02.1990 */
/*        31.08.1990 */
/*        03.12.1991 */
/*        16.11.92 */

    /* Parameter adjustments */
    --x;

    /* Function Body */
    *ier = 0;
    s__1 = linbf_1.nap;
    for (i = 1; i <= s__1; ++i) {
	k = ippar_1.ip[i - 1];
	ppar_1.p[k - 1] = x[linbf_1.nf + i];
/* L10: */
    }
    nfp = linbf_1.nf + 1;
/* Computing 2nd power */
    s__1 = nfp;
    nfp2 = s__1 * s__1;
    d__1 = -dhf;
    dp1flp_(&nfp, &nfp2, &d__1, &x[1], work_1.dxp, funm_, ier);
    if (*ier != 0) {
	return;
    }
    l = 1;
    s__1 = linbf_1.nf;
    for (i = 1; i <= s__1; ++i) {
	work_1.dxp[l - 1] += -1.;
	l = l + nfp + 1;
/* L15: */
    }
    r1 = 0.;
    s__1 = nfp;
    for (i = 1; i <= s__1; ++i) {
/* Computing 2nd power */
	d__1 = work_1.dxp[nfp * i - 1];
	r1 += d__1 * d__1;
/* L20: */
    }
    r1 = sqrt(r1);
    if (r1 == 0.) {
	goto L40;
    }
    s__1 = nfp;
    for (i = 1; i <= s__1; ++i) {
	work_1.dxp[nfp * i - 1] /= r1;
/* L30: */
    }
L40:
    detbf_(work_1.dxp, &nfp, dtran);
    return;
} /* trflp_ */

