/* solve.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void solve_(shortint *ndim, shortint *n, doublereal *a, doublereal *b, shortint *ipvt)
{
    /* System generated locals */
    int s__1, s__2;
    integer a_dim1, a_offset;

    /* Local variables */
    int i, k, m;
    doublereal t;
    int kb, km1, nm1, kp1;

/*     3.05.90. */

/*     PEEHE HEHO CCTEM A*X=B */
/*     OPOPAMM HE CEET COOBAT, */
/*     EC DECOMP OHAPA BPOEHHOCT. */

/*     (POPAMMA OCAHA B KHE: */

/*           .OPCAT, M.MAKOM, K.MOEP */
/*           "MAHHE METO MATEMATECKX BCEH" */
/*            M.:MP,1980) */

/*     BXOHA HOPMA.. */

/*       NDIM=ABEHHA CTPOHA PAMEPHOCT MAC- */
/*       CBA, COEPAEO A. */

/*       N=OPOK MATP. */

/*       A=AKTOPOBAHHA MATPA, OEHHA */
/*       DECOMP. */

/*       B=BEKTOP PABX ACTE. */

/*       IPVT=BEKTOP BEX EMEHTOB, OEHH */
/*        DECOMP. */

/*     BXOHA HOPMA.. */

/*       B=BEKTOP PEEH. */


/*     PMO XO. */

    /* Parameter adjustments */
    --ipvt;
    --b;
    a_dim1 = *ndim;
    a_offset = a_dim1 + 1;
    a -= a_offset;

    /* Function Body */
    if (*n == 1) {
	goto L50;
    }
    nm1 = *n - 1;
    s__1 = nm1;
    for (k = 1; k <= s__1; ++k) {
	kp1 = k + 1;
	m = ipvt[k];
	t = b[m];
	b[m] = b[k];
	b[k] = t;
	s__2 = *n;
	for (i = kp1; i <= s__2; ++i) {
	    b[i] += a[i + k * a_dim1] * t;
/* L10: */
	}
/* L20: */
    }

/*     OPATHA OCTAHOBKA */

    s__1 = nm1;
    for (kb = 1; kb <= s__1; ++kb) {
	km1 = *n - kb;
	k = km1 + 1;
	b[k] /= a[k + k * a_dim1];
	t = -b[k];
	s__2 = km1;
	for (i = 1; i <= s__2; ++i) {
	    b[i] += a[i + k * a_dim1] * t;
/* L30: */
	}
/* L40: */
    }
L50:
    b[1] /= a[a_dim1 + 1];
    return;
} /* solve_ */

