/* beetle.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>


/* Table of constant values */

static shortint cs__84 = NDIM;
static doublereal c_b37 = 1.;

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */

void beetle_(shortint *nx, shortint *ng, shortint *iadd, doublereal *x0, doublereal *hv0, doublereal *eps, void (*fun) (doublereal*, doublereal*, shortint*, shortint*), void (*dfdx) (doublereal *, doublereal *, shortint *, shortint *, shortint *, shortint *), void (*out) (shortint *, shortint *, shortint *, shortint *, doublereal *, doublereal *, doublereal *, shortint *), shortint *iend)
                         
                           
/* Subroutine */                                      
               
{
    /* System generated locals */
    shortint s__1, s__2;
    doublereal d__1, d__2;

    /* Local variables */
    doublereal diff, fact, habs;
    shortint mode, idiv;
    doublereal epsl, xold[NDIM];
    shortint iprr;
    doublereal dist, xnew[NDIM];
    shortint iwrt;
    doublereal fact1, sini0, sini2, dist3, sini3, vtng0[NDIM], f[NDIM1];
    shortint i;
    doublereal sfact;
    shortint nfixc;
    doublereal cosil, sidiv;
    shortint icorr;
    doublereal vlock, dmovn;
    shortint istep;
    shortint nfixr, iprnt[NPTYP], istop;
    doublereal dmove0, vlock0, vk, dmovec, ddmove, dencrv;
    shortint ibound;
    doublereal dimove, dvlock;
    doublereal hcontr, xbound;
    shortint indstp;
    doublereal fdm;
    shortint ier;
    doublereal wrk, rad0, ang3, rad3;
    shortint itc1;

    static struct wrto3__ {
      doublereal cosi1, cosi2, cosi0, cosi3;
    } wrto3_;
#define wrto3_1 wrto3_

/*     3.05.90. */
/*     31.07.1991 */
/*     19.11.92 */
/*     09.06.94 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*/
/* *                                                                   * 
*/
/* *   CCOK OPMAHX  A P A M E T P O B :                         * 
*/
/* *                                                                   * 
*/
/* *   NX    -PAMEPHOCT POCTPAHCTBA EPEMEHHX.                     * 
*/
/* *   NG    -HOMEP BEEHHO EPEMEHHO.                             * 
*/
/* *   IADD  -EOCEHH MACCB H 7, PEHAHAEHH         * 
*/
/* *          HAA APAMETPOB OOHTEHX BOMOHOCTE     * 
*/
/* *          (OCAHE COOBAH TOO APAMETPA CM. B OCAH   * 
*/
/* *           POPAMM);                                             * 
*/
/* *          P EPBOHAAHOM HAKOMCTBE C POPAMMO PEKOMEHEM   * 
*/
/* *          AAT MACCB IADD(1)=IADD(2)= ...  =IADD(7)= 0;         * 
*/
/* *   X0    -MACCB KOOPHAT HAAHOO PEH K EPBO TOKE   * 
*/
/* *          HA KPBO;                                               * 
*/
/* *   HV0   -HAAH A BEH O KPBO;                        * 
*/
/* *          HV0 > 0 -BEHE HAHAETC B HAPABEH BPPACTAH   * 
*/
/* *                   EPEMEHHO X0(NG);                              * 
*/
/* *          HV0 < 0 -BEHE HAHAETC B HAPABEH BAH      * 
*/
/* *                   EPEMEHHO X0(NG);                              * 
*/
/* *   EPS   -TOHOCT TOHEH TOEK HA KPBO B METOE HTOHA;     * 
*/
/* *   FUN   -M OPOPAMM BCEH PABX ACTE;               * 
*/
/* *   DFDX  -M OPOPAMM BCEH MATP ACTHX              * 
*/
/* *          POBOHX O AAHHM OPMAM;                        * 
*/
/* *   OUT   -M OPOPAMM OOHTEHO OPAOTK TOEK HA       * 
*/
/* *          KPBO;                                                  * 
*/
/* *   IEND  -KO ABEPEH PAOT POPAMM BEETLE:                  * 
*/
/* *          1-COBEPEHO AAHHOE KOECTBO AOB BO KPBO;      * 
*/
/* *          2-BEEHHA EPEMEHHA OCTA CBOEO PAHHOO       * 
*/
/* *            HAEH (OCTHTA TOHOCT EPS);                    * 
*/
/* *          3-KPBA AMKHAC C AAHHO TOHOCT;                * 
*/
/* *          4-BEEHHA EPEMEHHA OCTA CBOEO PAHHOO       * 
*/
/* *            HAEH (C TOHOCT O BEH TEKEO AA);      * 
*/
/* *         -1-P AAH BXOHX APAMETPOB OEHA OKA;        * 
*/
/* *         -2-EPBA TOKA HA KPBO HE HAEHA;                     * 
*/
/* *         -3-A BEH O KPBO CTA MEHE MHMAHOO;        * 
*/
/* *         -4-HE HAEHA KACATEHA B EPBO TOKE;                 * 
*/
/* *         -5-CET PEPBAH OOBATEEM;                            * 
*/
/* * . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . * 
*/
/* *                                                                   * 
*/
/* *   BBAEME OPOPAMM:                                        * 
*/
/* *    TANGNT, NEWTN, CORR, SERVCE, WRTEND, WRTOUT, POISK             * 
*/
/* *                   CURNTP        WRTDT                             * 
*/
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*/
/* *   P MEHEH MAKCMAHOO CA EPEMEHHX  NDIM -HEOXOMO  * 
*/
/* *   MEHT PAMEPHOCT MACCBOB:                                  * 
*/
/* *   XOLD(*) XNEW(*) VTNG0(*) F(*) DFUN(*,*) IVARS(*) VMOVE(*)       * 
*/
/* *                                                                   * 
*/
/* *   HEOXOMO MEHT TAKE HAEHE APAMETPA NDIM.              * 
*/
/* * . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . * 
*/
/* *   P MEHEH MAKCMAHOO CA CCEEMX HK HA KPBO * 
*/
/* *   HEOXOMO MEHT PAMEPHOCT MACCBOB:                       * 
*/
/* *   IFUNS(*) IERF(*) IFUNSA(*)  HAEHE APAMETPA IFMAX.          * 
*/
/* *   FUNS2(*)                                                        * 
*/
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*/

/*      Parameter (NDIM=14, NDIM1=13, IFMAX=20, NPTYP=4) */








/* ***B */
/*      Parameters for the adaptive step control. */

    /* Parameter adjustments */
    --x0;
    --iadd;

    /* Function Body */
    contrh_1.cdemp = .1;
    contrh_1.rmode = 1.;
    contrh_1.angmax = 16.;
    contrh_1.angmin = 7.;
    contrh_1.angcrv = 10.;
/* ***E */

/* .... Setting of the main parameters. */

    all4_1.detstp = 1e-40;
    wrto6_1.itc = 5;
    wrto3_1.cosi1 = cos(contrh_1.angmax * 3.14 / 180.);
    wrto3_1.cosi2 = cos(contrh_1.angmin * 3.14 / 180.);
    dencrv = sin(contrh_1.angcrv * 6.2800000000000002 / 180.);
    vk = .707107;
    corr1_1.det = 1.;
    leqv1_1.detl = 1.;
    corr1_1.cond = 1.;
    leqv1_1.condl = 1.;
    corr1_1.sgndet = 1.;

    iprr = 0;

/* .... The initialization and printing of input parameters. */

    istop = 0;
    ier = 0;
    wrtdt_(nx, ng, &iadd[1], &x0[1], hv0, eps, fun, &ier, &istop);
    if (istop != 0) {
	goto L123;
    }

    all1_1.xgmn = add6a_1.xgmn;
    all1_1.xgmx = add6a_1.xgmx;

    iprnt[0] = add1a_1.ipr;
    iprnt[1] = add2a_1.iprcrs;
    iprnt[2] = add3a_1.iprzer;
    iprnt[3] = add4a_1.iprext;

    all2_1.ipoisk = iadd[5];
    all3_1.ibnd = iadd[6];
/* ***B */
    wrto3_1.cosi1 = cos(contrh_1.angmax * 3.14 / 180.);
    wrto3_1.cosi2 = cos(contrh_1.angmin * 3.14 / 180.);
    dencrv = sin(contrh_1.angcrv * 6.2800000000000002 / 180.);
/* ***E */
    if (ier == 0) {
	goto L102;
    }

/* .... Failure in input parameters. */

    *iend = -1;
    wrtend_(iend, &add1a_1.ipr, &istep, ng, &wrto1_1.nfix, &add1a_1.ncan, eps,
	     &wrto2_1.dmove);
    return;
L102:

/* .... The tuning of working parameters. */

    dern1_1.dx = add1b_1.dx;
    wrto2_1.dmove = *hv0;
    wrto1_1.nfix = *ng;
    hcontr = add1b_1.hvmx / 2.;
    wrto4_1.epsc = *eps;
    itc1 = wrto6_1.itc - 1;
    wrte1_1.hmin = fabs(wrto2_1.dmove);
    wrte1_1.hmax = wrte1_1.hmin;
    epsl = *eps * 5.;
    sidiv = 0.;
    sfact = 3.;
    if (add3a_1.nuf == 0) {
	goto L106;
    }
    for (i = 1; i <= IFMAX; ++i) {
	zero2_1.ifunsa[i - 1] = (s__1 = add3a_1.ifuns[i - 1], abs(s__1));
	out2_1.ierf[i - 1] = 0;
	out1_1.g[i - 1] = -6.66e35;
/* L105: */
    }
L106:
/* ***B */
/* ***E */

/* .... Computing the first point on a curve. */

    ier = 0;
/* ***B */
/* ***E */
    poisk_(nx, &wrto1_1.nfix, &add1a_1.ncan, &add1a_1.ipr, &x0[1], eps, fun, 
	    dfdx, &ier, &istop);
/* ***B */
/* ***E */
    if (istop != 0) {
	goto L123;
    }
    if (ier == 0) {
	goto L110;
    }

/* .... Failure in the search of the first point. */

    *iend = -2;
    wrtend_(iend, &add1a_1.ipr, &istep, ng, &wrto1_1.nfix, &add1a_1.ncan, eps,
	     &wrto2_1.dmove);
    return;
L110:
    s__1 = *nx;
    for (i = 1; i <= s__1; ++i) {
	xold[i - 1] = x0[i];
/* L120: */
    }

/* .... Output at the first point. */

    istep = 0;
    wrto6_1.it2 = 0;
    iwrt = 1;
    idiv = 0;
    if (add1a_1.ipr >= 0) {
	wrtout_(&iwrt, &istep, &iprr, &wrto6_1.it2, &idiv, &add1a_1.ncan, nx, &
		cs__84, &x0[1], workbe_1.dfun);
    }

/* .... Preliminary processing of the current point by the user. */

    ier = 0;
    curntp_(nx, &x0[1], &ier, &istop);
    if (istop == 0) {
	goto L124;
    }
L123:
    *iend = -5;
    wrtend_(iend, &add1a_1.ipr, &istep, ng, &wrto1_1.nfix, &add1a_1.ncan, eps,
	     &wrto2_1.dmove);
    return;
L124:

/* .... Setting of the initial direction along the curve. */

/* ***B */
/* ***E */
    tangnt_(nx, &cs__84, &wrto1_1.nfix, &x0[1], f, wrto7_1.vmove, fun, dfdx, 
	    workbe_1.dfun, &ier, &istop);
/* ***B */
/* ***E */
    if (istop != 0) {
	goto L550;
    }
    if (ier == 0) {
	goto L130;
    }

/* .... No tangent vector at the first point found. */

    iwrt = 5 - ier;
    wrtout_(&iwrt, &istep, &add1a_1.ipr, &wrto6_1.it2, &idiv, &add1a_1.ncan, 
	    nx, &cs__84, &x0[1], workbe_1.dfun);
    *iend = -4;
    wrtend_(iend, &add1a_1.ipr, &istep, ng, &wrto1_1.nfix, &add1a_1.ncan, eps,
	     &wrto2_1.dmove);
    return;
L130:

/* .... The selection of the optimal fixed variable. */

    wrto1_1.nfix1 = wrto1_1.nfix;
    if ((d__1 = wrto7_1.vmove[wrto1_1.nfix - 1], fabs(d__1)) > vk) {
	goto L210;
    }
    wrto1_1.nfix = 1;
    s__1 = *nx;
    for (i = 1; i <= s__1; ++i) {
	if ((d__1 = wrto7_1.vmove[i - 1], fabs(d__1)) > (d__2 = wrto7_1.vmove[
		wrto1_1.nfix - 1], fabs(d__2))) {
	    wrto1_1.nfix = i;
	}
/* L190: */
    }
    if (wrto1_1.nfix == wrto1_1.nfix1) {
	goto L210;
    }

/* .... Updating of the direction along the curve, computing */
/*     the determinant (DET) and the condition number (COND) */
/*     for the matrix DFUN after choosing a new fixed variable. */

    corr_(nx, &cs__84, &wrto1_1.nfix1, &wrto1_1.nfix, wrto7_1.vmove, &
	    wrto2_1.dmove, workbe_1.dfun);
L210:
    dimove = 1.;
    if (wrto7_1.vmove[*ng - 1] < 0.) {
	dimove = -1.;
    }
    wrto2_1.dmove = *hv0 * dimove;

/* .... Storing the tangent vector at the first point. */

    s__1 = *nx;
    for (i = 1; i <= s__1; ++i) {
	vtng0[i - 1] = wrto7_1.vmove[i - 1];
/* L220: */
    }
    dmove0 = wrto2_1.dmove;
    wrto2_1.dmove1 = wrto2_1.dmove;
/* ***B */
/* ***E */
    servce_(&istep, nx, &cs__84, ng, &add1a_1.ncan, &add2a_1.icrs, &
	    add3a_1.nuf, add3a_1.ifuns, &add4a_1.nue, add4a_1.ivars, iprnt, &
	    x0[1], eps, fun, dfdx, out, workbe_1.dfun, &istop);
    if (istop == 0) {
	goto L222;
    }
    *iend = -5;
    wrtend_(iend, &add1a_1.ipr, &istep, ng, &wrto1_1.nfix, &add1a_1.ncan, eps,
	     &wrto2_1.dmove);
    return;
L222:

/* .... Loop for computing NSTEP points in one direction along the curve. 
*/

    s__1 = add1a_1.nstep;
    for (istep = 1; istep <= s__1; ++istep) {
	idiv = 0;
	icorr = 1;

/* .... Tangent predictor. */

L230:
	s__2 = *nx;
	for (i = 1; i <= s__2; ++i) {
	    xnew[i - 1] = xold[i - 1] + wrto2_1.dmove * wrto7_1.vmove[i - 1] /
		     wrto7_1.vmove[wrto1_1.nfix - 1];
/* L240: */
	}
	if (all3_1.ibnd == 0) {
	    goto L301;
	}

/* .... Does the predicted point lie within the bounds? */

	ibound = 0;
	if (xnew[*ng - 1] > add6a_1.xgmn && xnew[*ng - 1] < add6a_1.xgmx) {
	    goto L300;
	}
	ibound = 1;

/* .... The predicted point put on a bound. */

	xbound = add6a_1.xgmx;
	if (xnew[*ng - 1] <= add6a_1.xgmn) {
	    xbound = add6a_1.xgmn;
	}

/* .... POHO O KACATEHO O EPECEEH C EPOCKOCT */
/*     XNEW(NG) = XBOUND */

	wrto2_1.dmove1 = wrto2_1.dmove;
	wrto2_1.dmove = (xbound - xold[*ng - 1]) / wrto7_1.vmove[*ng - 1];
	s__2 = *nx;
	for (i = 1; i <= s__2; ++i) {
	    xnew[i - 1] = xold[i - 1] + wrto2_1.dmove * wrto7_1.vmove[i - 1];
/* L250: */
	}
	iwrt = 10;
	wrtout_(&iwrt, &istep, &add1a_1.ipr, &wrto6_1.it2, &idiv, &
		add1a_1.ncan, nx, &cs__84, xnew, workbe_1.dfun);

/* .... TOHEHE TOK, KO K PAHE. */

	nfixr = *ng;
	wrto6_1.it2 = wrto6_1.itc;
	ier = 0;
	newtn_(nx, &cs__84, ng, &nfixr, &add1a_1.ncan, xnew, eps, &
		wrto4_1.epsn, &wrto6_1.it2, &add1a_1.ipr, fun, dfdx, 
		workbe_1.dfun, &ier, &istop);
	if (istop != 0) {
	    goto L550;
	}
	if (ier == 0) {
	    goto L310;
	}
	iwrt = 1 - ier;
	nfixr = wrto1_1.nfix;
	wrto1_1.nfix = *ng;
	wrtout_(&iwrt, &istep, &add1a_1.ipr, &wrto6_1.it2, &idiv, &
		add1a_1.ncan, nx, &cs__84, xnew, workbe_1.dfun);
	wrto1_1.nfix = nfixr;
	icorr = -1;
	goto L309;
L260:

/* .... BBO PAHHO TOK, TOHEHHO C TOHOCT O BEH */
/*     MHMAHOO AA. */

	wrto2_1.dmove = add1b_1.hvmn;
	iwrt = 1;
	if (add1a_1.ipr >= 0) {
	    wrtout_(&iwrt, &istep, &iprr, &wrto6_1.it2, &idiv, &add1a_1.ncan, 
		    nx, &cs__84, xold, workbe_1.dfun);
	}
	*iend = 4;
	wrtend_(iend, &add1a_1.ipr, &istep, ng, &wrto1_1.nfix, &add1a_1.ncan, 
		eps, &wrto2_1.dmove);
	return;
L300:
L301:

/* .... TOHEHE KOOPHAT OEPEHO TOK HA KPBO. */

	wrto6_1.it2 = wrto6_1.itc;
	ier = 0;
/* ***B */
/* ***E */
	newtn_(nx, &cs__84, ng, &wrto1_1.nfix, &add1a_1.ncan, xnew, eps, &
		wrto4_1.epsn, &wrto6_1.it2, &add1a_1.ipr, fun, dfdx, 
		workbe_1.dfun, &ier, &istop);
/* ***B */
/* ***E */
	if (istop != 0) {
	    goto L550;
	}
	if (ier == 0) {
	    goto L310;
	}

/* .... HE COC HTOHOBCKE TEPA. */

L306:
/*  ---     STEP IS REJECTED */
/* ***B */
/* ***E */
	iwrt = 1 - ier;
	wrtout_(&iwrt, &istep, &add1a_1.ipr, &wrto6_1.it2, &idiv, &
		add1a_1.ncan, nx, &cs__84, xnew, workbe_1.dfun);
L309:
	indstp = -1;
	d__1 = wrto2_1.dmove / 2.;
	showbe_(indstp, wrto2_1.dmove, d__1);
	wrto2_1.dmove /= 2.;
	++idiv;
/* ***B */
/* ***E */
	icorr = -1;
	if (fabs(wrto2_1.dmove) >= add1b_1.hvmn && xold[wrto1_1.nfix - 1] + 
		wrto2_1.dmove * wrto7_1.vmove[wrto1_1.nfix - 1] != xold[
		wrto1_1.nfix - 1]) {
	    goto L230;
	}
	if (ibound == 1) {
	    goto L260;
	}
	*iend = -3;
	wrtend_(iend, &add1a_1.ipr, &istep, ng, &wrto1_1.nfix, &add1a_1.ncan, 
		eps, &wrto2_1.dmove);
	return;
L310:
	if (itc1 == wrto6_1.it2) {
	    icorr = -1;
	}

/* .... POBEPKA TOHEHHO TOK. */

	wrto3_1.cosi0 = 0.;
	dist = 0.;
	s__2 = *nx;
	for (i = 1; i <= s__2; ++i) {
	    diff = xnew[i - 1] - xold[i - 1];
	    dist += diff * diff;
	    wrto3_1.cosi0 += diff * wrto7_1.vmove[i - 1];
/* L320: */
	}
	dist = sqrt(dist);
	wrto3_1.cosi0 = wrto3_1.cosi0 / dist * (wrto2_1.dmove>=0 ? 1.0 : -1.0);
/* ***B */
	wrk = 1. - wrto3_1.cosi0 * wrto3_1.cosi0;
	sini0 = sqrt((fabs(wrk)));
	sini0 = max(1e-10,sini0);
	rad0 = dist / 2. / sini0;
/* ***B */
/* ***E */

/* ***E */

/* ***B */
	ddmove = fabs(wrto2_1.dmove);
	fdm = .01;
	if (wrto3_1.cosi0 < wrto3_1.cosi1 * fdm * ddmove / (fdm * ddmove + *
		eps) && contrh_1.rmode >= 0.) {
/*  ---     STEP IS REJECTED */
/* ***B */
/* ***E */
	    goto L325;
	} else {
/* ***E */
/*  ---     STEP IS ACCEPTED */
/* ***B */
/* ***E */
	    goto L321;
	}
L321:

/* .... BCEHE KACATEHOO BEKTOPA B TEKE TOKE. */

	ier = 0;
/* ***B */
/* ***E */
	tangnt_(nx, &cs__84, &wrto1_1.nfix, xnew, f, wrto7_1.vmovn, fun, dfdx,
		 workbe_1.dfun, &ier, &istop);
/* ***B */
/* ***E */
	if (istop != 0) {
	    goto L550;
	}
	if (ier == 0) {
	    goto L322;
	}

/* .... HE BCEH KACATEH BEKTOP. */

	iwrt = 5 - ier;
	wrtout_(&iwrt, &istep, &add1a_1.ipr, &wrto6_1.it2, &idiv, &
		add1a_1.ncan, nx, &cs__84, xnew, workbe_1.dfun);
	goto L309;

/* ....  POBEPK TOHEHHO TOK. */

L322:
	wrto3_1.cosi3 = 0.;
	dist3 = 0.;
	s__2 = *nx;
	for (i = 1; i <= s__2; ++i) {
	    diff = xnew[i - 1] - xold[i - 1];
	    dist3 += diff * diff;
	    wrto3_1.cosi3 += diff * wrto7_1.vmovn[i - 1];
/* L323: */
	}
	dist3 = sqrt(dist3);
	wrto3_1.cosi3 = wrto3_1.cosi3 / dist3 * (wrto2_1.dmove>=0.0?1.0:-1.0)
		;
	sini3 = sqrt((d__1 = 1. - wrto3_1.cosi3 * wrto3_1.cosi3, fabs(d__1)));
	sini3 = max(1e-10,sini3);
	rad3 = dist3 / 2. / sini3;
/* ***B */
/* ***E */

/*        IF (RMODE.LT.0.) GOTO 330 */
	if (wrto3_1.cosi3 < wrto3_1.cosi1 * fdm * ddmove / (fdm * ddmove + *
		eps) && contrh_1.rmode >= 0.) {
/*  ---     STEP IS REJECTED */
/* ***B */
/* ***E */
	    goto L325;
	} else {
/* ***E */
/*  ---     STEP IS ACCEPTED */
/* ***B */
/* ***E */
	    goto L324;
	}
L324:
/* ***B */
/* ***E */

	cnewtn_(nx, &cs__84, &wrto1_1.nfix, &nfixc, xnew, f, wrto7_1.vmovn, 
		eps, workbe_1.dfun, &ier, &istop);
/* ***B */
/* ***E */
	if (ier != 0 && contrh_1.rmode >= 0.) {
/*  ---     STEP IS REJECTED */
/* ***B */
/* ***E */
	    goto L325;
	} else {
/* ***E */
/*  ---     STEP IS ACCEPTED */
/* ***B */
/* ***E */
	    goto L330;
	}


/* .... TOHEHHA TOKA HA KPBO HE KA K TOKE-POHO. */

L325:
	iwrt = 9;
	wrtout_(&iwrt, &istep, &add1a_1.ipr, &wrto6_1.it2, &idiv, &
		add1a_1.ncan, nx, &cs__84, xnew, workbe_1.dfun);
	goto L309;
L330:

/* .... PEBAPTEHA OPAOTKA TEKE TOK KPBO OOBATEEM. 
*/

	ier = 0;
	curntp_(nx, xnew, &ier, &istop);
	if (istop == 0) {
	    goto L334;
	}
	*iend = -5;
	wrtend_(iend, &add1a_1.ipr, &istep, ng, &wrto1_1.nfix, &add1a_1.ncan, 
		eps, &wrto2_1.dmove);
	return;
L334:
	if (ier == 0) {
	    goto L336;
	}

/* .... PHTO PEEHE EPECTAT TOK C OOBHHM AOM. */

	iwrt = 15;
	wrtout_(&iwrt, &istep, &add1a_1.ipr, &wrto6_1.it2, &idiv, &
		add1a_1.ncan, nx, &cs__84, xnew, workbe_1.dfun);
	goto L309;
L336:

/* .... POBEPKA KPBO HA AMKHTOCT. */

	if (istep == 1) {
	    goto L380;
	}
	if ((xnew[wrto1_1.nfix - 1] - x0[wrto1_1.nfix]) * (x0[wrto1_1.nfix] - 
		xold[wrto1_1.nfix - 1]) < 0.) {
	    goto L380;
	}

/* .... KOHTPO COACOBAHHOCT HAPABEH BEH B POBEPEMO */
/*      EPBO TOKAX. */

	vlock0 = vtng0[wrto1_1.nfix - 1] * dmove0;
	vlock = wrto7_1.vmove[wrto1_1.nfix - 1] * wrto2_1.dmove;
	if (vlock0 * vlock < 0.) {
	    goto L380;
	}

/* .... POBEPKA OCT POBEPEMO  EPBO TOEK HA KPBO. */

	cosil = 0.;
	dist = 0.;
	s__2 = *nx;
	for (i = 1; i <= s__2; ++i) {
	    diff = x0[i] - xold[i - 1];
	    dist += diff * diff;
	    cosil += diff * wrto7_1.vmove[i - 1];
/* L340: */
	}
	dist = sqrt(dist);
	cosil = fabs(cosil) / dist;
	if (cosil < wrto3_1.cosi1) {
	    goto L380;
	}

/* .... POHO  TOHEHE TOK C AAHHO KCPOBAHHO KOOPHATO 
*/
/*     XNEW(NFIX)=X0(NFIX). */

	dvlock = (x0[wrto1_1.nfix] - xold[wrto1_1.nfix - 1]) / wrto7_1.vmove[
		wrto1_1.nfix - 1];
	s__2 = *nx;
	for (i = 1; i <= s__2; ++i) {
	    xnew[i - 1] = xold[i - 1] + dvlock * wrto7_1.vmove[i - 1];
/* L350: */
	}
	iwrt = 12;
	wrtout_(&iwrt, &istep, &add1a_1.ipr, &wrto6_1.it2, &idiv, &
		add1a_1.ncan, nx, &cs__84, xnew, workbe_1.dfun);
	wrto6_1.it2 = wrto6_1.itc;
	ier = 0;
	newtn_(nx, &cs__84, ng, &wrto1_1.nfix, &add1a_1.ncan, xnew, eps, &
		wrto4_1.epsn, &wrto6_1.it2, &add1a_1.ipr, fun, dfdx, 
		workbe_1.dfun, &ier, &istop);
	if (istop != 0) {
	    goto L550;
	}
	if (ier == 0) {
	    goto L360;
	}

/* .... HE COC HTOHOBCKE TEPA. */

	wrto2_1.dmove = dvlock;
	goto L306;
L360:
	iwrt = 13;
	wrtout_(&iwrt, &istep, &add1a_1.ipr, &wrto6_1.it2, &idiv, &
		add1a_1.ncan, nx, &cs__84, xnew, workbe_1.dfun);
	iwrt = 14;
	wrtout_(&iwrt, &istep, &add1a_1.ipr, &wrto6_1.it2, &idiv, &
		add1a_1.ncan, nx, &cs__84, &x0[1], workbe_1.dfun);
	s__2 = *nx;
	for (i = 1; i <= s__2; ++i) {
	    if ((d__1 = xnew[i - 1] - x0[i], fabs(d__1)) > epsl) {
		goto L380;
	    }
/* L370: */
	}

/* .... BBO TOK AMKAH. */

	wrto2_1.dmove = dvlock;
	wrto2_1.dmove1 = dvlock;
	ier = 3;
	iwrt = 1;
	if (add1a_1.ipr >= 0) {
	    wrtout_(&iwrt, &istep, &iprr, &wrto6_1.it2, &idiv, &add1a_1.ncan, 
		    nx, &cs__84, xnew, workbe_1.dfun);
	}
	s__2 = *nx;
	for (i = 1; i <= s__2; ++i) {
	    wrto7_1.vmove[i - 1] = vtng0[i - 1];
/* L372: */
	}
	servce_(&istep, nx, &cs__84, ng, &add1a_1.ncan, &add2a_1.icrs, &
		add3a_1.nuf, add3a_1.ifuns, &add4a_1.nue, add4a_1.ivars, 
		iprnt, xnew, eps, fun, dfdx, out, workbe_1.dfun, &istop);
	*iend = 3;
	wrtend_(iend, &add1a_1.ipr, &istep, ng, &wrto1_1.nfix, &add1a_1.ncan, 
		eps, &wrto2_1.dmove);
	return;
L380:
	s__2 = *nx;
	for (i = 1; i <= s__2; ++i) {
	    wrto7_1.vmove[i - 1] = wrto7_1.vmovn[i - 1];
/* L400: */
	}

/* .... BOP OTMAHO KCPOBAHHO EPEMEHHO. */

	wrto1_1.nfix1 = wrto1_1.nfix;
/*        IF (DABS(VMOVE(NFIX)) .GT. VK) GOTO 430 */
/*            NFIX  = 1 */
/*            DO 410 I=1,NX */
/*               IF (DABS(VMOVE(I)) .GT. DABS(VMOVE(NFIX))) NFIX = I 
*/
/* 410        CONTINUE */
	wrto1_1.nfix = nfixc;
	if (wrto1_1.nfix == wrto1_1.nfix1) {
	    goto L430;
	}

/* .... KOPPEK HAPABEH BEH, BCEHE OPEETE (DET) 
*/
/*      OEHK OCOBEHHOCT (COND)  MATP (DFUN) C ETOM BHO
B */
/*     BPAHHO KCPOBAHHO EPEMEHHO. */

	corr_(nx, &cs__84, &wrto1_1.nfix1, &wrto1_1.nfix, wrto7_1.vmove, &
		wrto2_1.dmove, workbe_1.dfun);
	if (corr1_1.det * leqv1_1.detl < 0.) {
	    corr1_1.sgndet = -corr1_1.sgndet;
	}
L430:

/* .... KOPPEK BEH TEKEO AA. */

	wrto2_1.dmove1 = wrto2_1.dmove;
	if (idiv > 0) {
	    sfact = 1.125;
	}
	if (sfact < 3.) {
	    sfact = sfact * 2. - 1.;
	}
/* ***B */
/* ***E */

/* ***B */
	mode = fabs(contrh_1.rmode);

/*        MODE=1     - 㢥祭 蠣  p */
/*            =2     - ᫥ 蠣 p p p */
/*            =3     - pp 蠣  ⫨  p */

	if (mode < 1 || mode > 3) {
	    mode = 1;
	}
	if (mode == 1) {
	    goto L437;
	}
	if (mode > 2) {
	    goto L433;
	}
	dmovn = fabs(wrto2_1.dmove);
	if (mode == 2) {
	    dmovn = rad3 * dencrv;
	}
/*        ⠭ 3  0.3 p稢 ᢥp */
/* Computing MIN */
	d__1 = sfact * fabs(wrto2_1.dmove);
	dmovn = min(d__1,dmovn);
/* Computing MAX */
	d__1 = fabs(wrto2_1.dmove) * .3;
	dmovn = max(d__1,dmovn);
	dmovn = min(add1b_1.hvmx,dmovn);
	dmovn = max(add1b_1.hvmn,dmovn);
	if (icorr == -1 && wrto6_1.it2 > 1) {
/* Computing MIN */
	    d__1 = dmovn, d__2 = fabs(wrto2_1.dmove);
	    dmovn = min(d__1,d__2);
	}
	wrto2_1.dmove = (wrto2_1.dmove>=0?fabs(dmovn):-fabs(dmovn));
	goto L440;

L433:
	ang3 = atan2(sini3, wrto3_1.cosi3) * 180. / 3.14;
	sini2 = sqrt(1. - wrto3_1.cosi2 * wrto3_1.cosi2);
	fact = contrh_1.cdemp * (ang3 - contrh_1.angcrv);
/*       FACT = ANG3/ANGCRV-1.0D0 */
	fact1 = 1. - fact;
/*        ⠭ 3  0.3 p稢 ᢥp */
	fact1 = max(fact1,.3);
	fact1 = min(fact1,sfact);
	dmovn = fabs(wrto2_1.dmove) * fact1;
	dmovn = min(add1b_1.hvmx,dmovn);
	dmovn = max(add1b_1.hvmn,dmovn);
	if (icorr == -1 && wrto6_1.it2 > 1) {
/* Computing MIN */
	    d__1 = dmovn, d__2 = fabs(wrto2_1.dmove);
	    dmovn = min(d__1,d__2);
	}
	wrto2_1.dmove = (wrto2_1.dmove>=0.0?fabs(dmovn):-fabs(dmovn));
	goto L440;

L437:
/* ***E */
	if (icorr == -1 && wrto6_1.it2 > 1) {
	    goto L440;
	}
	dmovec = fabs(wrto2_1.dmove);
	if (wrto3_1.cosi0 > wrto3_1.cosi2 && dmovec <= hcontr) {
	    wrto2_1.dmove *= min(2.,sfact);
	}
	if (wrto3_1.cosi0 > wrto3_1.cosi2 && dmovec > hcontr) {
	    wrto2_1.dmove = (wrto2_1.dmove>=0?fabs(add1b_1.hvmx):-fabs(add1b_1.hvmx));
	}
L440:
	if ((d__1 = wrto2_1.dmove * wrto7_1.vmove[wrto1_1.nfix - 1], fabs(d__1)
		) > add1b_1.hvmx) {
	    d__2 = add1b_1.hvmx / wrto7_1.vmove[wrto1_1.nfix - 1];
	    wrto2_1.dmove = (wrto2_1.dmove>=0.0?fabs(d__2):-fabs(d__2));
	}
	indstp = 1;
	showbe_(indstp, wrto2_1.dmove1, wrto2_1.dmove);

/* .... BCEHE ACOTHX HAEH MAKCMAHOO  MHMAHOO */
/*     AOB BO KPBO. */

/* ***B */
/* ***E */
	habs = fabs(wrto2_1.dmove1);
	if (habs < wrte1_1.hmin) {
	    wrte1_1.hmin = habs;
	}
	if (habs > wrte1_1.hmax) {
	    wrte1_1.hmax = habs;
	}

/* .... BBO OEPEHO TOK HA KPBO. */

	ier = 0;
	iwrt = 1;
	wrtout_(&iwrt, &istep, &add1a_1.ipr, &wrto6_1.it2, &idiv, &
		add1a_1.ncan, nx, &cs__84, xnew, workbe_1.dfun);
	servce_(&istep, nx, &cs__84, ng, &add1a_1.ncan, &add2a_1.icrs, &
		add3a_1.nuf, add3a_1.ifuns, &add4a_1.nue, add4a_1.ivars, 
		iprnt, xnew, eps, fun, dfdx, out, workbe_1.dfun, &istop);
	if (ibound == 1) {
	    goto L480;
	}
	if (istop == 0) {
	    goto L454;
	}
	goto L550;
L454:
	s__2 = *nx;
	for (i = 1; i <= s__2; ++i) {
	    xold[i - 1] = xnew[i - 1];
/* L460: */
	}
/* L470: */
    }
    *iend = 1;
    wrtend_(iend, &add1a_1.ipr, &istep, ng, &wrto1_1.nfix, &add1a_1.ncan, eps,
	     &wrto2_1.dmove);
    return;
L480:

/* .... TOHEHA PAHHA TOKA. */

    *iend = 2;
    wrtend_(iend, &add1a_1.ipr, &istep, ng, &wrto1_1.nfix, &add1a_1.ncan, eps,
	     &wrto2_1.dmove);
    return;

L550:
    *iend = -5;
    wrtend_(iend, &add1a_1.ipr, &istep, ng, &wrto1_1.nfix, &add1a_1.ncan, eps,
	     &wrto2_1.dmove);
    return;
} /* beetle_ */

