/* cnewtn.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
/* Subroutine */ void cnewtn_(shortint *nx, shortint *ndimm, shortint *nfix, shortint *nfixc, doublereal *x, doublereal *f, doublereal *vtng, doublereal *eps, doublereal *dfun, shortint *ier, shortint *istop)
{
    /* System generated locals */
    shortint s__1, s__2;
    doublereal d__1;

    /* Local variables */
    doublereal bmas[NDIM], detr;
    shortint nfun;
    shortint i, j;
    doublereal condr, detlr, dvmax;
    shortint nfixn;
    doublereal rnfix, condad, rr, condnf, condlr, dvmaxn, rnfixn, rr1;

/*     3.08.1991 */
/* Rev.26.07.92 */
/*     18.11.92 */
/*     15.06.94 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* *        							       * */
/* *    CHECKING CURRENT POINT AGAINST ADDITIONAL                        *
 */
/* *         NEWTON ITERATION, USING VARIOUS DIRECTIONS		       * */
/* *. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .*
 */
/* *    APAMETP:                                                       *
 */
/* *    =========                                                        *
 */
/* *    NX   - CO EPEMEHHX;                                         *
 */
/* *    NDIM - ABEHHA CTPOHA PAMEPHOCT MATP DFUN;             *
 */
/* *    NFIX - NUMBER OF FIXED VARIABLE                                  *
 */
/* *    NFIXC- NUMBER OF NEW FIXED VARIABLE                              *
 */
/* *    X    - CURRENT POINT                                             *
 */
/* *    F    - FUNCTION VALUES AT CURRENT POINT			       * */
/* *    VTNG - TANGENT VECTOR AT CURRENT POINT			       * */
/* *    EPS  - TOHOCT METOA;                                          *
 */
/* *    DFUN - BMEPH MACCB PAMEPHOCT NDIM*NX, COEPA MATP  *
 */
/* *           EPBX ACTHX POBOHX.                               *
 */
/* *    IER  - APAMETP OK:                                          *
 */
/* *             0-TEPA CEHO COC C TOHOCT EPS;             *
 */
/* *            -1-TPEEMA TOHOCT HE OCTHTA A ITC TEPA.     *
 */
/* *            -2-HA OEPEHO TEPA OPEETE HEHO CCTEM =0;
 */
/* *            -3-HE BCEH HAEH HK B HTOHOBCKOM POHOE;*
 */
/* *            -4-HE BCEHA MATPA ACTHX POBOHX;             *
 */
/* *. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .*
 */
/* *           BMAS - BCOMOATEH PAO MACCB.                    *
 */
/* *                                                                     *
 */
/* *           BBAEME OPOPAMM:                                  *
 */
/* *              LEQV.                                                  *
 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* *    P MEHEH MAKCMAHOO CA (NDIM) EPEMEHHX HEOXOMO   *
 */
/* *    MEHT PAMEPHOCT MACCBOB:   A(NDIM,NDIM), BMAS(NDIM)        *
 */
/* *                                     ARR1(NDIM,NDIM)                 *
 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */




    /* Parameter adjustments */
    dfun -= (NDIM+1);
    --x;
    --f;
    --vtng;

    /* Function Body */
    *istop = 0;
    *ier = 0;
    nfun = *nx - 1;
    checkn_1.epsnad = 0.;
    checkn_1.epsnnf = 0.;
    detlr = leqv1_1.detl;
    condlr = leqv1_1.condl;
    detr = corr1_1.det;
    condr = corr1_1.cond;

    s__1 = *nx;
    for (i = 1; i <= s__1; ++i) {
	workbe_1.a[*nx + i * NDIM - (NDIM+1)] = 0.;
	if (i == *nfix) {
	    workbe_1.a[*nx + i * NDIM - (NDIM+1)] = 1.;
	}
	if (i == *nx) {
	    goto L20;
	}
	bmas[i - 1] = -f[i];
	s__2 = *nx;
	for (j = 1; j <= s__2; ++j) {
	    workbe_1.a[i + j * NDIM - (NDIM+1)] = dfun[i + j * NDIM];
/* L10: */
	}
L20:
	;
    }
    bmas[*nx - 1] = 0.;

/* .... SOLVING LINEAR SYSTEM  A*Y = BMAS; */
/*     SOLUTION VECTOR WILL BE IN ARRAY BMAS. */

    *ier = 0;
    leqv_(workbe_1.a, bmas, ndimm, nx, ier);
    condad = leqv1_1.condl;


/* .... TESTING ACCURACY */

    checkn_1.epsnad = 0.;
    s__1 = *nx;
    for (i = 1; i <= s__1; ++i) {
	rr = x[i];
	rr1 = bmas[i - 1] / (fabs(rr) + 1.);
	if (checkn_1.epsnad < fabs(rr1)) {
	    checkn_1.epsnad = fabs(rr1);
	}
/* L30: */
    }


    if (checkn_1.epsnad > *eps) {
	goto L180;
    }
    dvmax = (d__1 = vtng[*nfix], fabs(d__1));
    dvmaxn = 0.;
    nfixn = 0;
    s__1 = *nx;
    for (i = 1; i <= s__1; ++i) {
	if (i == *nfix) {
	    goto L40;
	}
	if ((d__1 = vtng[i], fabs(d__1)) <= dvmaxn) {
	    goto L40;
	}
	dvmaxn = (d__1 = vtng[i], fabs(d__1));
	nfixn = i;
L40:
	;
    }

    if (dvmaxn < dvmax * .1) {
	goto L80;
    }

    s__1 = *nx;
    for (i = 1; i <= s__1; ++i) {
	workbe_1.a[*nx + i * NDIM - (NDIM+1)] = 0.;
	if (i == nfixn) {
	    workbe_1.a[*nx + i * NDIM - (NDIM+1)] = 1.;
	}
	if (i == *nx) {
	    goto L60;
	}
	bmas[i - 1] = -f[i];
	s__2 = *nx;
	for (j = 1; j <= s__2; ++j) {
	    workbe_1.a[i + j * NDIM - (NDIM+1)] = dfun[i + j * NDIM];
/* L50: */
	}
L60:
	;
    }
    bmas[*nx - 1] = 0.;

/* .... SOLVING LINEAR SYSTEM  A*Y = BMAS; */
/*     SOLUTION VECTOR WILL BE IN ARRAY BMAS. */

    *ier = 0;

    leqv_(workbe_1.a, bmas, ndimm, nx, ier);
    condnf = leqv1_1.condl;


/* .... TESTING ACCURACY */

    checkn_1.epsnnf = 0.;
    s__1 = *nx;
    for (i = 1; i <= s__1; ++i) {
	rr = x[i];
	rr1 = bmas[i - 1] / (fabs(rr) + 1.);
	if (checkn_1.epsnnf < fabs(rr1)) {
	    checkn_1.epsnnf = fabs(rr1);
	}
/* L70: */
    }

L80:


/*     CHOOSING LEADING VARIABLE */

    *nfixc = *nfix;
    rnfix = dvmax;
    rnfixn = dvmaxn;

    if (rnfix < rnfixn) {
	*nfixc = nfixn;
    }


    if (checkn_1.epsnnf > *eps && *nfixc != *nfix) {
	goto L180;
    }
    goto L200;


/* .... BAD ACCURACY. */

L180:
    *ier = -1;

/*     RESTORING AND RETURN */

L200:

    leqv1_1.detl = detlr;
    leqv1_1.condl = condlr;
    corr1_1.det = detr;
    corr1_1.cond = condr;

} /* cnewtn_ */

