/* dern.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void dern_(shortint *nfun, shortint *nx, shortint *ndx, doublereal *x0, doublereal *fx0, doublereal *df, void (*fun) (doublereal*, doublereal*, shortint*, shortint*), shortint *ier, shortint *istop)
                          
                          
/* Subroutine */               
                      
{
    /* System generated locals */
    shortint s__1;
    doublereal d__1;

    /* Local variables */
    doublereal dxsc;
    shortint i;
    doublereal r, fx1[NDIM1];

/*       3.05.90. */
/*       01.09.90 */
/*       13.11.92 */
/*       15.06.94 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* *                                                                     *
 */
/* *    POPAMMA DERN PEHAHAEHA  CEHHOO EPEHPOBAH    *
 */
/* *    BEKTOP-HK F(X) O AAHHOM APMEHT.                      *
 */
/* *                                                                     *
 */
/* *    APAMETP:                                                       *
 */
/* *    =========                                                        *
 */
/* *    NFUN - CO KOMOHEHT BEKTOP-HK F=(F(1),...,F(NFUN)).      *
 */
/* *    NX   - CO APMEHTOB BEKTOP-HK:(X(1),...,X(NX)).         *
 */
/* *    NDX  - HOMEP APMEHTA, O KOTOPOM BCTC POBOHE.     *
 */
/* *    X0   - KOOPHAT TOK, B KOTOPO BCTC POBOHE       *
 */
/* *           (X0: X0(1),...,X0(NX)).                                   *
 */
/* *    FX0  - BEKTOP HAEH KOMOHEHT BEKTOP-HK B TOKE X0.      *
 */
/* *    DF   - BEKTOP-POBOHA OT BEKTOP-HK.                     *
 */
/* *    FUN  - M POPAMM BCEH BEKTOP-HK.                  *
 */
/* * . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . *
 */
/* *                                                                     *
 */
/* *    BBAEME POPAMM: FUN.                                       *
 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* *    P MEHEH MAKCMAHOO CA EPEMEHHX NDIM HEOXOMO     *
 */
/* *    MEHT PAMEPHOCT MACCBA FX1(NDIM-1).                        *
 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */


    /* Parameter adjustments */
    --df;
    --fx0;
    --x0;

    /* Function Body */
    *istop = 0;
    *ier = 0;
    r = x0[*ndx];
    dxsc = dern1_1.dx * ((d__1 = x0[*ndx], fabs(d__1)) + 1.);
    x0[*ndx] += dxsc;

    (*fun)(&x0[1], fx1, ier, istop);
    if (*istop != 0) {
	return;
    }
    if (*ier != 0) {
	return;
    }

    s__1 = *nfun;
    for (i = 1; i <= s__1; ++i) {
	df[i] = (fx1[i - 1] - fx0[i]) / dxsc;
/* L100: */
    }
    x0[*ndx] = r;
} /* dern_ */

