/* newtn.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void newtn_(shortint *nx, shortint *ndimm, shortint *ng, shortint *nfix, shortint *ncan, doublereal *x0, doublereal *eps, doublereal *epsn, shortint *it, shortint *ipr, void (*fun) (doublereal*, doublereal*, shortint*, shortint*), void (*dfdx) (doublereal*, doublereal*, shortint*, shortint*, shortint*, shortint*), doublereal *dfun, shortint *ier, shortint *istop)
                                        
                            
                   
/* Subroutine */                           
                 
                      
{
    /* System generated locals */
    shortint s__1, s__2, s__3;
    integer dfun_dim1, dfun_offset;
    doublereal d__1, d__2;

    /* Local variables */
    doublereal bmas[NDIM];
    shortint idiv, nfun;
    doublereal xrem;
    shortint iwrt, i, j;
    shortint itmax, istep;
    doublereal r1, anrmf1, rr, anormf, dfnorm[NDIM], epsnol;
    doublereal rr1;

/*     3.05.90. */
/* Rev.29.07.92 */
/*     18.11.92 */
/*     15.06.94 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* *                                                                     *
 */
/* *    POPAMMA NEWTN PEHAHAEHA   TOHEH PEEH CCTEM     *
 */
/* *    HEHEHX YPABHEH  F(X) = 0  METOOM HTOHA, P KCPOBAH- *
 */
/* *    HOM HAEH EPEMEHHO  X(NFIX) = X0(NFIX).                     *
 */
/* *. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .*
 */
/* *    APAMETP:                                                       *
 */
/* *    =========                                                        *
 */
/* *    NX   - CO EPEMEHHX;                                         *
 */
/* *    NDIM - ABEHHA CTPOHA PAMEPHOCT MATP DFUN;             *
 */
/* *    NG   - HOMEP BEEHHO EPEMEHHO;                              *
 */
/* *    NFIX - HOMEP KCPOBAHHO EPEMEHHO;                           *
 */
/* *    X0   - HA BXOE POPAMM - HAAHOE PEHE K PEEH;     *
 */
/* *           HA BXOE - TOHEHHOE PEHE K PEEH C AAHHO   *
 */
/* *           TOHOCT.                                                *
 */
/* *    EPS  - TOHOCT METOA;                                          *
 */
/* *    EPSN - HA BXOE PEAHO OCTHTA TOHOCT.                   *
 */
/* *    IT   - HA BXOE POPAMM - MAKCMAHO OCTMOE CO TEPA;
 */
/* *           HA BXOE - CO CEAHHX TEPA;                     *
 */
/* *    IPR  - APAMETP PABEH EAT COOEH-POHO O HTOH  *
 */
/* *           BE A PAH;                                         *
 */
/* *    FUN  - M OPOPAMM BCEH PABX ACTE;                *
 */
/* *    DFDX - M POPAMM BCEH MATP ACTHX POBOHX;     *
 */
/* *    DFUN - BMEPH MACCB PAMEPHOCT NDIM*NX, COEPA MATP  *
 */
/* *           EPBX ACTHX POBOHX.                               *
 */
/* *    IER  - APAMETP OK:                                          *
 */
/* *             0-TEPA CEHO COC C TOHOCT EPS;             *
 */
/* *            -1-TPEEMA TOHOCT HE OCTHTA A ITC TEPA.     *
 */
/* *            -2-HA OEPEHO TEPA OPEETE HEHO CCTEM =0;
 */
/* *            -3-HE BCEH HAEH HK B HTOHOBCKOM POHOE;*
 */
/* *            -4-HE BCEHA MATPA ACTHX POBOHX;             *
 */
/* *. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .*
 */
/* *           BMAS - BCOMOATEH PAO MACCB.                    *
 */
/* *                                                                     *
 */
/* *           BBAEME OPOPAMM:                                  *
 */
/* *              DERN, FUN, JACOB.                                      *
 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* *    P MEHEH MAKCMAHOO CA (NDIM) EPEMEHHX HEOXOMO   *
 */
/* *    MEHT PAMEPHOCT MACCBOB:   A(NDIM,NDIM), BMAS(NDIM),       *
 */
/* *                                     ARR1(NDIM,NDIM)                 *
 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */







    /* Parameter adjustments */
    dfun_dim1 = *ndimm;
    dfun_offset = dfun_dim1 + 1;
    dfun -= dfun_offset;
    --x0;

    /* Function Body */
    *istop = 0;
    itmax = *it;
    *it = 0;
    nfun = *nx - 1;
    *epsn = add7a_1.epsnwt * 100.;
    s__1 = *nx;
    for (j = 1; j <= s__1; ++j) {
	dfun[*nx + j * dfun_dim1] = 0.;
/* L99: */
    }
    dfun[*nx + *nfix * dfun_dim1] = 1.;
    xrem = x0[*nfix];
/* .... OPABM KCPOBAHH EPMEHH. */

/*         X0(NFIX) = XREM */

/* .... BCEM HAEH HK FUN B TOKE X0; */
/*     BCEHHE HAEH PAMEAEM B MACCBE BMAS. */

    *ier = 0;
/* ***B */
/* ***E */
    (*fun)(&x0[1], bmas, ier, istop);
/* ***B */
/* ***E */
    if (*istop != 0) {
	return;
    }
    if (*ier != 0) {
	*ier = -3;
	return;
    }
    anormf = 0.;
    s__1 = *nx - 1;
    for (i = 1; i <= s__1; ++i) {
	if (anormf < (d__1 = bmas[i - 1], fabs(d__1))) {
	    anormf = (d__2 = bmas[i - 1], fabs(d__2));
	}
    }
    showit_(*it, *epsn, anormf);
    if (cnwt1_1.ipnt1 == 0 && anormf > 100.) {
	*ier = -7;
/* ***B */
/* ***E */
	return;
    }

/* .... OPAHEM K O MAKCMAHOM C OCTMX TEPA. */

    s__1 = itmax;
    for (*it = 1; *it <= s__1; ++(*it)) {
/* ***B */
/* ***E */

	if (cnwt1_1.ipnt1 == 1) {
	    goto L101;
	}
	if (*it > add7b_1.itnwt) {
	    goto L105;
	}
L101:

/* .... BCEM MATP POBOHX DFUN. */

	*ier = 0;
/* ***B */
/* ***E */
	jacob_(nx, ndimm, &x0[1], fun, dfdx, &dfun[dfun_offset], bmas, ier, 
		istop);
/* ***B */
/* ***E */
	if (*istop != 0) {
	    return;
	}
	if (*ier == 0) {
	    goto L105;
	}
	*ier = -4;
	return;
L105:

/* .... OPMPEM BEKTOP-CTOE (BMAS)  MATP (A). */

	bmas[*nx - 1] = 0.;
	s__2 = *nx;
	for (i = 1; i <= s__2; ++i) {
	    bmas[i - 1] = -bmas[i - 1];
	    dfnorm[i - 1] = 0.;
	    s__3 = *nx;
	    for (j = 1; j <= s__3; ++j) {
		workbe_1.a[i + j * NDIM- (NDIM+1)] = dfun[i + j * dfun_dim1];
		dfnorm[i - 1] += (d__1 = dfun[i + j * dfun_dim1], fabs(d__1));
/* L110: */
	    }
/* L120: */
	}

/* .... PEAEM CCTEM HEHX PABHEH  A*Y = BMAS; */
/*     PEEHE Y PAMEAETC B MACCBE BMAS. */

	*ier = 0;
/* ***B */
/* ***E */
	leqv_(workbe_1.a, bmas, ndimm, nx, ier);
/* ***B */
/* ***E */
	if (*ier == 0) {
	    goto L260;
	}

/* .... MATPA A - BPOEHA. */

	*ier = -2;
	return;
L260:

/* .... HAXOM OEPEHOE PEHE. */

	*epsn = 0.;
	s__2 = *nx;
	for (i = 1; i <= s__2; ++i) {
	    rr = x0[i];
	    x0[i] = rr + bmas[i - 1];
	    rr1 = (d__1 = bmas[i - 1], fabs(d__1)) / (fabs(rr) + 1.);
	    if ((d__1 = x0[i], fabs(d__1)) < rr1 * 1e-5) {
		x0[i] = 0.;
	    }
	    if (*epsn < rr1) {
		*epsn = rr1;
	    }
/* L320: */
	}
/* ***B */
/* ***E */
	if (all3_1.ibnd == 0) {
	    goto L400;
	}

/* .... COOEHE:POHO O HTOH BE A OCTME PAH. */

	iwrt = 11;
	if (x0[*ng] < add6a_1.xgmn || x0[*ng] > add6a_1.xgmx) {
	    wrtout_(&iwrt, &istep, ipr, it, &idiv, ncan, nx, ndimm, &x0[1], &
		    dfun[dfun_offset]);
	}

/* .... CEEHE HTOHOBCKOO POHOA O EPOCKOCT */
/*     X(NG) = XGMN ( X(NG) = XGMX) */

	if (x0[*ng] < add6a_1.xgmn) {
	    x0[*ng] = add6a_1.xgmn;
	}
	if (x0[*ng] > add6a_1.xgmx) {
	    x0[*ng] = add6a_1.xgmx;
	}

/* .... POBEPEM OEPEHOE PEHE HA TOHOCT. */

L400:

/* .... OPABM KCPOBAHH EPMEHH. */

	x0[*nfix] = xrem;

/* .... BCEM HAEH HK FUN B TOKE X0; */
/*     BCEHHE HAEH PAMEAEM B MACCBE BMAS. */

	*ier = 0;
/* ***B */
/* ***E */
	(*fun)(&x0[1], bmas, ier, istop);
/* ***B */
/* ***E */
	if (*istop != 0) {
	    return;
	}
	if (*ier != 0) {
	    *ier = -3;
	    return;
	}
	anormf = 0.;
	anrmf1 = 0.;
	s__2 = *nx - 1;
	for (i = 1; i <= s__2; ++i) {
	    r1 = (d__1 = bmas[i - 1] / (dfnorm[i - 1] + 1.), fabs(d__1));
	    if (anormf < (d__1 = bmas[i - 1], fabs(d__1))) {
		anormf = (d__2 = bmas[i - 1], fabs(d__2));
	    }
	    if (anrmf1 < r1) {
		anrmf1 = r1;
	    }
	}
/* ***B */
/* ***E */
	showit_(*it, *epsn, anormf);
	if (cnwt1_1.ipnt1 == 0 && anormf > 100.) {
	    *ier = -7;
/* ***B */
/* ***E */
	    return;
	}

	if (*epsn > *eps || anormf > *eps) {
	    goto L420;
	}
	*ier = 0;
	return;
L420:
	if (cnwt1_1.ipnt1 == 0 && *epsn > 10.) {
	    *ier = -5;
/* ***B */
/* ***E */
	    return;
	}
	if (*it > 2 && *epsn > epsnol * 10.) {
	    *ier = -6;
/* ***B */
/* ***E */
	    return;
	}
	epsnol = *epsn;
/* L440: */
    }
    *it = itmax;
    *ier = -1;
    return;
} /* newtn_ */

