/* slfcrs.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>


/* Table of constant values */

static shortint cs__84 = NDIM;

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void slfcrs_(shortint *istep, shortint *nx, shortint *ndimm, shortint *ng, shortint *ncan, shortint *icrs, shortint *iprcrs, doublereal *stx2, doublereal *eps, void (*fun) (doublereal*, doublereal*, shortint*, shortint*), void (*dfdx) (doublereal*, doublereal*, shortint*, shortint*, shortint*, shortint*), void (*out) (shortint*,shortint*,shortint*,shortint*,doublereal*,doublereal*,doublereal*,shortint*), doublereal *dfun, shortint *istop)
{
    /* System generated locals */
    shortint s__1, s__2;
    doublereal d__1;

    /* Local variables */
    static doublereal xabd[NDIM];
    static shortint iter;
    static doublereal xcrs[NDIM];
    static shortint iwrt;
    static doublereal cond1, cond2;
    static shortint i, itend, index[NPTYP];
    static doublereal fncrs[NDIM];
    static shortint itmax, nfixr;
    static doublereal r1, r2, x1[NDIM], x2[NDIM], df, vmove3[NDIM], fn;
    static shortint indloc;
    static doublereal rx, detold;
    static shortint itcrem;
    static doublereal condst;
    static shortint iprtcl;
    static doublereal dmover;
    static doublereal detstp;
    static shortint itnwtz[10], ier, ipr;
    static doublereal det1, det2, stx1[NDIM];

    static struct out3__ {
      doublereal epscrz, epscr, detc, condc;
    } out3_;
#define out3_1 out3_


/*     3.05.90 */
/*     6.08.1991 */
/*     26.08.1991 */
/*     13.11.92 */
/*     15.06.94 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* *                                                                     *
 */
/* *    POPAMMA  SLFCRS  PEHAHAEHA  TOHEH TOEK             *
 */
/* *    CAMOEPECEEH KPBO B NX-MEPHOM POCTAHCTBE.                  *
 */
/* *    TOKA CAMOEPECEEH POEHA, EC OPEETE MATP        *
 */
/* *    ACTHX POBOHX COOTBETCTB KCPOBAHHO EPEMEHHO     *
 */
/* *    MEHET HAK. HO OEPEETE TOHETC METOOM CEKX.      *
 */
/* *                                                                     *
 */
/* *    BXOHE  A P A M E T P :                                       *
 */
/* *    --------------------------                                       *
 */
/* *    ISTEP -CO AOB, POEHX BO KPBO.                      *
 */
/* *    NX    -CO EPEMEHHX (X(1),...,X(NX)).                        *
 */
/* *    NDIM  -ABEHHA CTOPHA PAMEPHOCT MATP DFUN(NDIM,NX).    *
 */
/* *    NG    -HOMEP BEEHHO EPEMEHHO.                              *
 */
/* *    NCAN  -HOMEP KAHAA  BBOA POTOKOA TOHEH TOK CAMOEP.*
 */
/* *    ICRS  -APAMETP, KABA HA HEOXOMOCT TOHEH TOK    *
 */
/* *           CAMOEPECEEH:                                          *
 */
/* *             0 - TOKA CAMOEPECEEH HE TOHETC;                *
 */
/* *             1 - TOKA CAMOEPECEEH TOHETC.                   *
 */
/* *    IPRCRS-APAMETP, KABA CTEEH OPOHOCT POTOKOA:      *
 */
/* *            -1 - POTOKO OTCCTBET;                                *
 */
/* *             0 - BATC KOOPHAT TOK CAMOEPECEEH;          *
 */
/* *             1 - BAETC HEKOTOPA HOPMA O TEPAX.         *
 */
/* *    STX2  -KOOPHAT OCEHE TOK HA KPBO;                     *
 */
/* *    EPS   -TOHOCT OPEEEH TOK HA KPBO B METOE HTOHA.    *
 */
/* *    FUN   -M OPOPAMM BCEH PABX ACTE.                *
 */
/* *    DFDX  -M OPOPAMM BCEH MATP ACTHX POBOHX   *
 */
/* *           AAHHO BHM OPAOM.                                   *
 */
/* *    DFUN  -BMEPH MACCB PAMEPHOCT DFUN(NDIM,NX),               *
 */
/* *           COEPA MATP ACTHX POBOHX.                   *
 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* *   P MEHEH MAKCMAHOO CA  NDIM EPEMEHHXHEOXOMO*     *
 */
/* *   CPABT PAMEPHOCT MACCBOB:                                   *
 */
/* *   STX1(*) STX2(*) X1(*) X2(*) XCRS(*) XABD(*) VMOVE(*) 	       * */
/* *   FNCRS(*) VMOVE3(*)                                                *
 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */





    /* Parameter adjustments */
    dfun -= (NDIM+1);
    --stx2;

    /* Function Body */
    *istop = 0;
    if (*icrs == 0) {
	return;
    }
    det2 = leqv1_1.detl;
    det1 = detold;
    detold = corr1_1.det;
    cond2 = leqv1_1.condl;
    cond1 = condst;
    condst = corr1_1.cond;

/* .... KOHTPO  TOHEHE TOK CAMOEPECEEH. */

/*      WRITE (6,*) ' DET=',DET,'  DETL=',DETL,'  DETOLD=',DETOLD */
    if (*istep == 0) {
	goto L370;
    }
    s__1 = *nx;
    for (i = 1; i <= s__1; ++i) {
	x1[i - 1] = stx1[i - 1];
	x2[i - 1] = stx2[i];
/*              STX1(I) = STX2(I) */
/* L200: */
    }
    if (det1 * det2 > 0.) {
	goto L360;
    }
/*                IF (DFABS(DET2).LT.0.01*EPSCRS */
/*     A              .AND.DFABS(DET1).LT.0.01*EPSCRS) GOTO 360 */
    df = (d__1 = (det2 - det1) / (x1[wrto1_1.nfix1 - 1] - x2[wrto1_1.nfix1 - 
	    1]), fabs(d__1));
    if (df < add2b_1.epscrs * .1) {
	goto L360;
    }


/* .... OOTOBKA K TEPAM TOHEH TOK CAMOEPECEEH. */

    detstp = 5e-6;
    for (i = 1; i <= 4; ++i) {
	index[i - 1] = 0;
/* L100: */
    }
    out7_1.indc = 0;
    itcrem = wrto6_1.itc;
    wrto6_1.itc *= 5;
    itmax = 10;
    wrto4_1.epsc = *eps;
    wrto4_1.epsn = 0.;
    out3_1.epscrz = add2b_1.epscrs;
    indloc = 0;

/* .... HAEH DETL,CONDL,DET,COND-OPTTC B POECCE TEPA */
/*     O HTOH, OTOM X HEOXOMO AOMHT. */

    itnwtz[0] = 0;

/* .... K TOHEH TOK CAMOEPECEEH. */

    s__1 = itmax;
    for (iter = 1; iter <= s__1; ++iter) {

/* .... POHO TOK CAMOEPECEEH. */

L205:
	if (indloc == 0) {
	    rx = det2 / (det2 - det1);
	}
	if (indloc == 1) {
	    rx = .5;
	}
	if (indloc == 2) {
	    rx = .44444444444444442;
	}

	s__2 = *nx;
	for (i = 1; i <= s__2; ++i) {
	    xcrs[i - 1] = x2[i - 1] - (x2[i - 1] - x1[i - 1]) * rx;
/* L210: */
	}
	itend = wrto6_1.itc;
	ipr = 0;
/*      PRINT *,' SLFCRS:' */
/*      PRINT *,'  ITER=',ITER,'  INDLOC=',INDLOC */
/*      PRINT *,'   DET1=',DET1,'  DET2=',DET2 */
/*      PRINT *,'   X1=',(X1(J), J=1,NX) */
/*      PRINT *,'   X2=',(X2(J), J=1,NX) */
/*      PRINT *,'   XC=',(XCRS(J), J=1,NX) */

/* .... TOHEHE TOK HA KPBO METOOM HTOHA. */

	ier = 0;
	newtn_(nx, &cs__84, ng, &wrto1_1.nfix1, ncan, xcrs, &wrto4_1.epsc, &
		wrto4_1.epsn, &itend, &ipr, fun, dfdx, &dfun[NDIM+1], &ier, istop)
		;
	if (*istop != 0) {
	    return;
	}
	itnwtz[iter - 1] = itend;
/*      PRINT *,'   IER=',IER */
/*      PRINT *,'   XC=',(XCRS(J), J=1,NX) */
	if (ier == 0) {
	    goto L280;
	}

	++indloc;
	if (indloc <= 2) {
	    goto L205;
	}

/* .... HE COC HTOHOBCKE TEPA. */

L215:
	iwrt = 1 - ier;
	iprtcl = 3;
	s__2 = *nx;
	for (i = 1; i <= s__2; ++i) {
	    xabd[i - 1] = xcrs[i - 1];
/* L220: */
	}

/* .... BEPEM TOK HA KPBO, A K TOKE CAMOEPECEEH. */

	if (fabs(det1) > fabs(det2)) {
	    goto L240;
	}
	out3_1.detc = det1;
	out3_1.condc = cond1;
	s__2 = *nx;
	for (i = 1; i <= s__2; ++i) {
	    xcrs[i - 1] = x1[i - 1];
/* L230: */
	}
	goto L260;
L240:
	out3_1.detc = det2;
	out3_1.condc = cond2;
	s__2 = *nx;
	for (i = 1; i <= s__2; ++i) {
	    xcrs[i - 1] = x2[i - 1];
/* L250: */
	}
L260:

/* .... KOHTPO OCTHTO TOHOCT B TOKE, AE K TOKE */
/*     CAMOEPECEEH. */

	out3_1.epscr = (d__1 = x2[wrto1_1.nfix1 - 1] - x1[wrto1_1.nfix1 - 1], 
		fabs(d__1));

/* .... TEPA AKOHEH-HE COC TEPA HTOHA. */

	dmover = wrto2_1.dmove;
	wrto2_1.dmove = wrto2_1.dmove1;
	nfixr = wrto1_1.nfix;
	wrto1_1.nfix = wrto1_1.nfix1;
	wrto2_1.dmove = dmover;
	wrto1_1.nfix = nfixr;
	out7_1.indc = -1;
	goto L355;
L280:

	r1 = 0.;
	r2 = 0.;
	s__2 = *nx;
	for (i = 1; i <= s__2; ++i) {
	    r1 += (xcrs[i - 1] - stx1[i - 1]) * (stx2[i] - stx1[i - 1]);
	    r2 += (xcrs[i - 1] - stx2[i]) * (stx2[i] - stx1[i - 1]);
/* L285: */
	}
	if (r1 * r2 > 0.) {
	    goto L215;
	}

/* .... AOMHM HOBOE HAEHE OPEETE (DETL). */

	ier = 0;
	tangnt_(nx, &cs__84, &wrto1_1.nfix1, xcrs, fncrs, vmove3, fun, dfdx, &
		dfun[NDIM+1], &ier, istop);
	if (*istop != 0) {
	    return;
	}
/*      PRINT *,'   IER (TANGNT)=',IER */
	if (ier != 0 && ier != -1) {
	    goto L215;
	}
	out3_1.detc = leqv1_1.detl;
	out3_1.condc = leqv1_1.condl;

/* .... BOP HHOO HTEPBAA C HEM  DETZ = 0. */

	if (out3_1.detc * det1 < 0.) {
	    goto L300;
	}
	det1 = out3_1.detc;
	cond1 = out3_1.condc;
	s__2 = *nx;
	for (i = 1; i <= s__2; ++i) {
	    x1[i - 1] = xcrs[i - 1];
/* L290: */
	}
	goto L320;
L300:
	det2 = out3_1.detc;
	cond2 = out3_1.condc;
	s__2 = *nx;
	for (i = 1; i <= s__2; ++i) {
	    x2[i - 1] = xcrs[i - 1];
/* L310: */
	}
L320:

/* .... KOHTPO OCTHTO TOHOCT. */

	out3_1.epscr = (d__1 = x2[wrto1_1.nfix1 - 1] - x1[wrto1_1.nfix1 - 1], 
		fabs(d__1));
	df = (d__1 = (det1 - det2) / (x1[wrto1_1.nfix1 - 1] - x2[
		wrto1_1.nfix1 - 1]), fabs(d__1));
	fn = (d__1 = out3_1.detc / df, fabs(d__1));
	if (out3_1.epscr <= out3_1.epscrz || fn <= out3_1.epscrz * .1) {
	    goto L350;
	}
/* L340: */
    }

/* .... AAHHA TOHOCT HE OCTHTA. */

    out7_1.indc = -1;
    iprtcl = 2;
    iter = itmax;
    goto L352;
L350:

/* .... TOKA CAMOEPECEEH TOHEHA C AAHHO TOHOCT. */

    iprtcl = 1;
L352:
L355:

/* .... OPAOTKA TOHEHHO TOK CAMOEPECEEH OOBATEEM. */

    index[1] = 1;
    (*out)(istep, index, nx, &cs__84, xcrs, wrto7_1.vmove, &dfun[NDIM+1], istop);
    wrto6_1.itc = itcrem;
    if (*istop != 0) {
	return;
    }
L360:
L370:

/* .... OOTOBKA K EPBOM A BO KPBO. */

    s__1 = *nx;
    for (i = 1; i <= s__1; ++i) {
	stx1[i - 1] = stx2[i];
/* L380: */
    }
    return;
} /* slfcrs_ */

