/* tangnt.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>


/* Table of constant values */

static shortint cs__84 = NDIM;

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void tangnt_(shortint *nx, shortint *ndimm, shortint *nfix, doublereal *xtng, doublereal *ftng, doublereal *vtng, void (*fun) (doublereal*, doublereal*, shortint*, shortint*), void (*dfdx) (doublereal*, doublereal*, shortint*, shortint*, shortint*, shortint*), doublereal *dfun, shortint *ier, shortint *istop)
                            
                               
/* Subroutine */                           
                 
                      
{
    /* System generated locals */
    shortint s__1, s__2;

    /* Local variables */
    doublereal dlen, elem;
    shortint i, j;

/*       3.05.90. */
/*       31.07.1991 */
/*       13.11.92 */
/*       15.06.94 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* *                                                                     *
 */
/* *    POPAMMA  TANGNT  PEHAHAEHA  HAXOEH BEKTOPA          *
 */
/* *    EHHO H - VTNG, KACATEHOO K KPBO : FUN(X)=0         *
 */
/* *    B TOKE XTNG.                                                    *
 */
/* *    PEOAAETC, TO B KAECTBE APAMETPA HA KPBO BPAHA       *
 */
/* *    NFIX-KOMOHEHTA BEKTOPA X: X(NFIX).                              *
 */
/* *    KACATEH BEKTOP OPEHTPETC TAK, TO BEHE O KACATE-*
 */
/* *    HOM BEKTOP COOTBETCTBOBAO BOPACTAH APAMETPA, T.E.         *
 */
/* *    BCEA BOHETC HEPABEHCTBO: VTNG(NFIX) GT. 0.D0              *
 */
/* *. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .*
 */
/* *                                                                     *
 */
/* *    APAMETP:                                                       *
 */
/* *    =========                                                        *
 */
/* *    NX   - CO EPEMEHHX;                                         *
 */
/* *    NDIM - ABEHHA CTPOHA PAMEPHOCT MATP DFUN;             *
 */
/* *    NFIX - HOMEP KCPOBAHHO EPEMEHHO;                           *
 */
/* *    XTNG - MACCB KOOPHAT TOK HA KPBO, B KOTOPO BCETC   *
 */
/* *           KACATEH BEKTOP.                                       *
 */
/* *    FTNG - ARRAY FOR FUNCTION VALUES                                 *
 */
/* *    VTNG - MACCB KOOPHAT KACATEHOO BEKTOPA.                    *
 */
/* *    FUN  - M POPAMM BCEH APBX ACTE - F(X).            *
 */
/* *    DFDX - M POPAMM BCEH MATP ACTHX POBOHX.     *
 */
/* *    DFUN - BMEPH MACCB PAMEPHOCT  NDIM*NX, COEPA         *
 */
/* *           MATP EPBX ACTHX POBOHX;                       *
 */
/* *    IER  - APAMETP OK:                                          *
 */
/* *              0 - KACATEH BEKTOP CEHO HAEH;                 *
 */
/* *             -1 - HEHA CCTEMA PABHEH, OPEEA           *
 */
/* *                  KACATEH BEKTOP - BPOEHA;                    *
 */
/* *             -2 - HE BCEH HAEH HK B TOKE  XTNG;       *
 */
/* *             -3 - HE BCEH POBOHE B TOKE       XTNG;       *
 */
/* * . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . *
 */
/* *                                                                     *
 */
/* *    BBAEME POPAMM: DERN, FUN, JACOB.                          *
 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* *    P HEOXOMOCT MEHEH MAKCMAHOO CA NDIM             *
 */
/* *    EPEMEHHX, CEET MEHT PAMEPHOCT MACCBA A(NDIM,NDIM),   *
 */
/* *                                                   ARR1(NDIM,NDIM)   *
 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */



/* .... BCEM HAEH HK F(X) B TOKE XTNG; */
/*     BCEHHE HAEH PAMEATC B MACCBE  VTNG. */

    /* Parameter adjustments */
    dfun -= (NDIM+1);
    --xtng;
    --ftng;
    --vtng;

    /* Function Body */
    *istop = 0;
    *ier = 0;
    (*fun)(&xtng[1], &ftng[1], ier, istop);
    if (*istop != 0) {
	return;
    }
    if (*ier == 0) {
	goto L102;
    }
    *ier = -2;
    return;
L102:

/* .... BCEM MATP ACTHX POBOHX. */

    s__1 = *nx;
    for (j = 1; j <= s__1; ++j) {
	dfun[*nx + j * NDIM] = 0.;
/* L200: */
    }
    dfun[*nx + *nfix * NDIM] = 1.;
    *ier = 0;
    jacob_(nx, &cs__84, &xtng[1], fun, dfdx, &dfun[NDIM+1], &ftng[1], ier, istop);
    if (*istop != 0) {
	return;
    }
    if (*ier == 0) {
	goto L215;
    }
    *ier = -3;
    return;
L215:

/* .... OPMPEM BEKTOP PABX ACTE (VTNG)  MATP (A). */

    s__1 = *nx;
    for (i = 1; i <= s__1; ++i) {
	vtng[i] = 0.;
	s__2 = *nx;
	for (j = 1; j <= s__2; ++j) {
	    workbe_1.a[i + j * NDIM- (NDIM+1)] = dfun[i + j * NDIM];
/* L250: */
	}
/* L255: */
    }
    vtng[*nx] = 1.;

/* .... PEAEM CCTEM HEHX PABHEH  A*Y=VTNG; */

    *ier = 0;
    leqv_(workbe_1.a, &vtng[1], &cs__84, nx, ier);
    if (*ier == 0) {
	goto L260;
    }

/* .... MATPA  DFUN - BPOEHA. */

    *ier = -1;
    return;
L260:

/* .... HOPMPEM H KACATEHOO BEKTOPA  VTNG  HA EH. */

    dlen = 0.;
    s__1 = *nx;
    for (i = 1; i <= s__1; ++i) {
	elem = vtng[i];
	dlen += elem * elem;
/* L360: */
    }
    dlen = sqrt(dlen);
    s__1 = *nx;
    for (i = 1; i <= s__1; ++i) {
	vtng[i] /= dlen;
/* L380: */
    }
    *ier = 0;
    return;
} /* tangnt_ */

