/* wrtdt.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */

void wrtdt_(shortint *nx, shortint *ng, shortint *iadd, doublereal *x0, doublereal *hv0, doublereal *eps, void (*fun) (doublereal*, doublereal*, shortint*, shortint*), shortint *ier, shortint *istop)
                         
                           
/* Subroutine */               
                      
{
    /* System generated locals */
    shortint s__1;

    /* Local variables */
    shortint nufc, ierr, nfun, i;
    doublereal fx0[NDIM-1];
    shortint nxc;
    doublereal ahv0;

/*     3.05.90. */
/*     13.11.92 */
/*     15.06.94 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* *                                                                     *
 */
/* *    POPAMMA  WRTDT PEHAHAEHA  POBEPK PABHOCT         *
 */
/* *    AAH OPMAHX APAMETPOB POPAMM  BEETLE  BBOA X      *
 */
/* *    HA EAT.                                                       *
 */
/* *                                                                     *
 */
/* *  P MEHEH MAKCMAHOO CA EPEMEHHX HEOXOMO:           *
 */
/* *      1) MEHT PAMEPHOCT MACCBOB:FX0(NXC-1)  IVARS(NXC);      *
 */
/* *      2) MEHT HAEHE APAMETPA NXC;                            *
 */
/* *  P MEHEH MAKCMAHOO CA CCEEMX HK HEOXOMO:  *
 */
/* *      1) MEHT PAMEPHOCT MACCBA IFUNS(NUFC);                   *
 */
/* *      2) MEHT HAEHE APAMETPA  NUFC;                          *
 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */



/* .... HAHAEHE HAEH APAMETPOB, AAHHX O MOAH. */

    /* Parameter adjustments */
    --x0;
    --iadd;

    /* Function Body */
    *istop = 0;
    nxc = NDIM;
    nufc = IFMAX;
/* .... 1) APAMETP, OTHOCEC K BEH O KPBO: */

    add1a_1.ipr = 0;
    add1a_1.nstep = 1000;
    add1a_1.ncan = 6;
    add1b_1.dx = 1e-7;
    add1b_1.hvmn = fabs(*hv0) * .01;
    add1b_1.hvmx = fabs(*hv0) * 100.;

/* .... 2) APAMETP, OTHOCEC K TOHEH TOEK CAMOEPECEEH: */

    add2a_1.icrs = 1;
    add2a_1.iprcrs = 0;
    add2b_1.epscrs = *eps * 10.;

/* .... 3) APAMETP, OTHOCEC K TOHEH HE AAHHX HK: */

    add3a_1.nuf = 0;
    add3a_1.iprzer = 0;
    add3b_1.epszer = *eps * 10.;
    s__1 = nufc;
    for (i = 1; i <= s__1; ++i) {
	add3a_1.ifuns[i - 1] = i;
/* L220: */
    }

/* .... 4) APAMETP, OTHOCEC K TOHEH KCTPEMMOB AAHHX */
/*        KOOPHAT: */

    add4a_1.nue = 0;
    add4a_1.iprext = 0;
    add4b_1.epsext = *eps * 10.;
    s__1 = nxc;
    for (i = 1; i <= s__1; ++i) {
	add4a_1.ivars[i - 1] = i;
/* L260: */
    }

/* .... 5) APAMETP, OTHOCEC K POEPE TOHEH EPBO TOK */
/*        HA KPBO: */

    add5a_1.pxgmn = x0[*ng];
    add5a_1.pxgmx = x0[*ng];

/* .... 6). APAMETP, OTHOCEC K AAH OCTMOO HTEPBAA */
/*         MEHEH  BEEHHO EPEMEHHO. */

    add6a_1.xgmn = x0[*ng] - 100.;
    add6a_1.xgmx = x0[*ng] + 100.;

/* .... 7). APAMETP, OTHOCEC K POEPE HTOHA: */

    add7a_1.epsnwt = *eps;
    add7b_1.itnwt = 10;

/* .... KOPPEKTPOBKA APAMETPOB, AAHHX O MOAH, OOBATEEM. */

    bdata_();

    if (iadd[3] == 0) {
	add3a_1.nuf = 0;
    }
    if (iadd[4] == 0) {
	add4a_1.nue = 0;
    }

/* .... EAT AAHHX APAMETPOB. */

    if (add1a_1.ipr == -2) {
	return;
    }

/* ..1. APAMETP, OTHOCEC K TOHEH TOEK HA KPBO. */

    *ier = -1;
    if (*nx < 1 || *nx > nxc) {
	return;
    }
    if (*ng < 1 || *ng > nxc) {
	return;
    }
    ierr = 0;
    (*fun)(&x0[1], fx0, &ierr, istop);
    if (*istop != 0) {
	return;
    }
    if (ierr == 0) {
	goto L500;
    }
    return;
L500:
    nfun = *nx - 1;
    if (fabs(*hv0) <= 1e-14) {
	return;
    }
    if (*eps <= 1e-14) {
	return;
    }
    if (iadd[1] == 0) {
	goto L502;
    }
    if (add1a_1.nstep >= 10000) {
	return;
    }
    if (fabs(add1b_1.dx) <= 1e-14) {
	return;
    }
    ahv0 = fabs(*hv0);
    if (! (add1b_1.hvmn <= ahv0 && ahv0 <= add1b_1.hvmx)) {
	return;
    }
L502:

/* ..2. APAMETP OTHOCEC K TOHEH TOEK CAMEPECEEH. */

    if (add2a_1.icrs == 0) {
	goto L510;
    }
    if (add2b_1.epscrs <= 1e-14) {
	return;
    }
L510:

/* ..3. APAMETP, OTHOCEC K TOHEH HE HK. */

    if (iadd[3] == 0) {
	goto L520;
    }
    if (add3a_1.nuf > nufc) {
	return;
    }
    if (add3b_1.epszer <= 1e-14) {
	return;
    }
    s__1 = nufc;
    for (i = 1; i <= s__1; ++i) {
	if (add3a_1.ifuns[i - 1] <= 0) {
	    return;
	}
/* L518: */
    }
L520:

/* ..4. APAMETP, OTHOCEC K TOHEH KCTPEMMOB. */

    if (iadd[4] == 0) {
	goto L530;
    }
    if (add4a_1.nue > nxc) {
	return;
    }
    if (add4b_1.epsext <= 1e-14) {
	return;
    }
    s__1 = nxc;
    for (i = 1; i <= s__1; ++i) {
	if (add4a_1.ivars[i - 1] <= 0) {
	    return;
	}
/* L528: */
    }
L530:

/* ..5. APAMETP, OTHOCEC K TOHEH EPBO TOK HA KPBO. */

    if (iadd[5] == 0) {
	goto L540;
    }
    if (! (add5a_1.pxgmn <= x0[*ng] && x0[*ng] <= add5a_1.pxgmx)) {
	return;
    }
L540:

/* ..6. APAMETP, OTHOCEC K AAH OCTMOO HTEPBAA */
/*     MEHEH  BEEHHO EPEMEHHO. */

    if (iadd[6] == 0) {
	goto L550;
    }
    if (! (add6a_1.xgmn <= x0[*ng] && x0[*ng] <= add6a_1.xgmx)) {
	return;
    }
L550:

/* ..7. APAMETP, OTHOCEC K POEPE HTOHA: */

    if (iadd[7] == 0) {
	goto L560;
    }
L560:
    *ier = 0;
    return;

/* .... OPMAT COOEH. */
} /* wrtdt_ */

