/* diagno.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <strings.h>


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */

void diagno_(shortint *iend)
{
    /* System generated locals */
    shortint s__1;

    /* Local variables */
    char text[56];
    doublereal g[IUFMAX];
    shortint i;
    doublereal p[NPARMX], t, x[NFMAX], ri[NFMAX], rr[NFMAX];


/*       19.10.94 */


    strcpy(text, "           ");

    s__1 = nmlit_1.n;
    for (i = 1; i <= s__1; ++i) {
	x[i - 1] = real_1.rvc[i - 1];
/* L10: */
    }
    s__1 = nmlit_1.m;
    for (i = 1; i <= s__1; ++i) {
	p[i - 1] = real_1.rvc[i + nmlit_1.n - 1];
/* L20: */
    }
    if (nmlit_1.l > 0) {
	s__1 = nmlit_1.l;
	for (i = 1; i <= s__1; ++i) {
	    g[i - 1] = real_1.rvc[i + nmlit_1.n + nmlit_1.m - 1];
/* L30: */
	}
    }
    t = real_1.rvc[nmlit_1.n + nmlit_1.m + nmlit_1.l];
    s__1 = nmlit_1.n;
    for (i = 1; i <= s__1; ++i) {
	rr[i - 1] = real_1.rvc[i + 1 + nmlit_1.n + nmlit_1.m + nmlit_1.l - 1];
	ri[i - 1] = real_1.rvc[i + 1 + (nmlit_1.n << 1) + nmlit_1.m + 
		nmlit_1.l - 1];
/* L40: */
    }

    if (*iend == 4 || *iend == 2) {
	strcpy(text, " Limit of parameter region");
	goto L100;
    }
    if (*iend == 3) {
	strcpy(text, " Closed curve");
	goto L100;
    }
    if (*iend == 1) {
	strcpy(text, " Cannot continue numerical integration");
	goto L100;
    }
    if (*iend == -1) {
	strcpy(text, " Error in initial data");
	goto L100;
    }
    if (*iend == -2) {
	strcpy(text, " Cannot find the first point");
	goto L100;
    }
    if (*iend == -3) {
	strcpy(text, " Current step size is too small");
	goto L100;
    }
    if (*iend == -4) {
	strcpy(text, " Cannot find tangent vector at the first point");
	goto L100;
    }
    if (*iend == -5) {
	strcpy(text, " Computations terminated");
	goto L100;
    }
    if (*iend == -6) {
	strcpy(text, " Incorrect number of active parameters");
	goto L100;
    }
    if (*iend == -7) {
	strcpy(text, " Undefined function values at the initial point");
	goto L100;
    }
    if (*iend == -8) {
	strcpy(text, " Cannot find Jacoby matrix at the initial point");
	goto L100;
    }
    if (*iend == -9) {
	strcpy(text, " Cannot find tangent vector at the initial point");
	goto L100;
    }
    return;

L100:
    endmes_(text, iend, &nmlit_1.n, &nmlit_1.m, &nmlit_1.l, x, p, g, &t, rr, 
	    ri, bfvl_1.bifval );
} /* diagno_ */

