/* funt.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"

/* Table of constant values */

static integer c__1 = 1;

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
/* set demo=0 for working version and set demo=1 for demo version */
/*                                               Levitin 15.11.90 */
/* $define demo=1 */


/* Compute RHS values */


void funt_( doublereal *t, doublereal *x, doublereal *f )
{

  /* System generated locals */
  shortint s__1;
  
  /* Local variables */
  static shortint what, irhs;
  static shortint i, iierr, er[4];
  static doublereal tt, sx[NFMAX];
  
  /* Parameter adjustments */
  if (x)
    --x;
  if (f)
    --f;
  
  /* ********************************************** */
  ierfs_1.ierfs = 0;
  termnt_();
  if (ierfs_1.ierfs != 0)
    return;
  er[0] = 0;
  /* ********************************************** */
  
  funtdemo_(t, &x[1], &f[1]);  
  if (messag <= -11) {
    if (ierfs_1.ierfs != 0) {
      printf( "  2:  what=%3d  irhs=%3d  IERFS=%3d  NFUNS=%8d\n", 
	     what, irhs, ierfs_1.ierfs, nfuns_1.nfuns );
    }
  }
  return;
#if 0
  ierfs_1.ierfs = 100;
  iabort_1.iabort = 1;
  if (messag <= -11) {
    printf( "     FUNT:  er(1)=%3d  T=%11.4g  NFUNS=%8d  irhs=%3d\n",
	   er[0], *t, nfuns_1.nfuns, irhs );
    s__1 = nmlit_1.n;
    printf( "     FUNT:  X=\n" );
    for (i = 1; i <= s__1; ++i)
      printf( "%23.15g  ", x[i] );
    s__1 = nmlit_1.m;
    printf( "     FUNT:  P=\n" );
    for (i = 1; i <= s__1; ++i)
      printf( "%23.15g  ", ppar_1.p[i - 1] );
    if (ierfs_1.ierfs != 0)
      printf( "  3:  what=%3d  irhs=%3d  IERFS=%3d  NFUNS=%8d\n",
	     what, irhs, ierfs_1.ierfs, nfuns_1.nfuns );
  }
  s__1 = nmlit_1.n;
  for (i = 1; i <= s__1; ++i) {
    f[i] = 0.;
  }
  return;
#endif
}




void userfun_( shortint *ifn, shortint *ierr, doublereal *pcoord, doublereal *funres)
{
  /* System generated locals */
  shortint s__1;
  
  /* Local variables */
  static shortint what, irhs;
  static shortint i, iierr, er[4];
  static doublereal tt, sx[NFMAX];

  ierfs_1.ierfs = 0;
  er[0] = 0;
  
  tt = pcoord[0];
  s__1 = nmlit_1.n;
  for (i = 1; i <= s__1; ++i)
    sx[i - 1] = pcoord[i];
  usrfdemo_(ifn, &tt, sx, funres);
  if (*ifn == 10) {
    pcoord[0] = tt;
    s__1 = nmlit_1.n;
    for (i = 1; i <= s__1; ++i)
      pcoord[i] = sx[i - 1];
  }
  if (messag <= -11) {
    if (ierfs_1.ierfs != 0)
      printf( " USRF 2:  what=%3d  irhs=%3d  IERFS=%3d  NFUNS=%8d\n",
	     what, irhs, ierfs_1.ierfs, nfuns_1.nfuns );
  }
  return;
#if 0
  ierfs_1.ierfs = 100;
  iabort_1.iabort = 1;
  if (messag <= -11) {
    printf( "     USRF:  er(1)=%3d  iierr=%3d  IFN=%3d\n            FUNRES=%11.4g  T=%11.4g\n",
	   er[0], iierr, *ifn, *funres, tt );
    s__1 = nmlit_1.n;
    printf( "     USRF:  PCOORD=\n" );
    for (i = 1; i <= s__1; ++i)
      printf( "%23.15g  ", pcoord[i] );
    s__1 = nmlit_1.m;
    printf( "     USRF:  P=\n" );
    for (i = 1; i <= s__1; ++i)
      printf( "23.15g  ", ppar_1.p[i - 1] );
    if (ierfs_1.ierfs != 0)
      printf( " USRF 3:  what=%3d  irhs=%3d  IERFS=%3d  NFUNS=%8d\n",
	     what, irhs, ierfs_1.ierfs, nfuns_1.nfuns );
  }
#endif
} 


