/* protoc.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <stdio.h>


/* Table of constant values */

static integer c__1 = 1;

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */


FILE *ncanp;


void protoc_( int n, int m, int l, double *x, double *p, double *g, double *t, double *rr, double *ri, double *bifval, shortint *line, shortlogical *actpar, int pointtype, int npt, shortint *ierr )
{
  int i, nap;
  char *nact[NACTMX];
  double pact[NACTMX];
  fprintf( ncanp, " Npt=%d\n", npt );
  for( i=0; i<n; i++ ) {
    fprintf( ncanp, " %6s = %13g   ", nc[i], x[i] );
    if( (i%3) == 2 )
      fprintf( ncanp, "\n" );
  }
  nap = 0;
  for( i=0; i<m; i++ )
    if( actpar[i] ) {
      nact[nap]=nc[i+n];
      pact[nap]=p[i];
      nap++;
    }
  for( i=0; i<nap; i++ ) {
    fprintf( ncanp, " %6s = %13g   ", nact[i], pact[i] );
    if( (i%3)==2 )
      fprintf( ncanp, "\n" );
  }
  if( l>0 )
    for( i=0; i<l; i++ ) {
      fprintf( ncanp, " %6s = %13g   ", nc[i+n+m], g[i] );
      if( (i%3)==2 )
	fprintf( ncanp, "\n" );
    }
  fprintf( ncanp, "%6s = %13.5g\n", nc[n+m+l], t );
    for( i=0; i<n; i++ ) {
      fprintf( ncanp, " %6s = %13g   ", nc[1+i+n+m+l], rr[i] );
      if( (i%3)==2 )
        fprintf( ncanp, "\n" );
    }
    for( i=0; i<n; i++ ) {
      fprintf( ncanp, " %6s = %13g   ", nc[1+i+2*n+m+l], ri[i] );
      if( (i%3)==2 )
        fprintf( ncanp, "\n" );
    }
}



void protte_( char *text )
{
  fprintf( ncanp, "%s\n", text );
  printf( "%s\n", text );
}



void proto_( int n, int m, int l, char *linetype, shortint *ierr )
{
  char line[132];
  int i, nap;
  char *nact[NACTMX];
  char ltyp[21];
  ncanp = fopen( "result", "a" );
  memset( line, '*', sizeof(line)-1 );
  line[ sizeof(line)-1 ] = 0;
  fprintf( ncanp, "%s\n", line );
  strncpy( ltyp, linetype, 20 );
  ltyp[20] = 0;
  fprintf( ncanp, "   Line type: %s\n\n", ltyp);
  fprintf( ncanp, "   Number of variables:  N =%d\n", n );
  fprintf( ncanp, "   Number of parameters: M =%d\n", m );
  fprintf( ncanp, "   Number of functions:  L =%d\n\n", l );
  fprintf( ncanp, "   Initial point:\n\n" );
  for( i=0; i<n+m; i++ ) {
    fprintf( ncanp, "%-6s = %13.6g   ", nc[i], real_.rvc[i] );
    if( (i%3) == 2 )
      fprintf( ncanp, "\n" );
  }
  nap = 0;
  for( i=0; i<m; i++ )
    if( logic_.active[n+i] )
      nact[ nap++ ] = nc[i+n];
  fprintf( ncanp, "   Active parameters:" );
  for( i=0; i<nap; i++ )
    fprintf( ncanp, "%6s", nact[i] );
  fprintf( ncanp, "   Computational parameters:\n\n" );
  for( i=0; i<parnum_.ncpar; i++ ) {
    fprintf( ncanp, "%7s  %12.4g  ", nampar_.nampar1[i], real_.rpc[i] );
  }
  fprintf( ncanp, "Ende von proto_\n" );
}


void protc_(void)
{
  fclose( ncanp );
}

