/* showit.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <strings.h>
#include <stdio.h>


/* Table of constant values */

static integer c__1 = 1;

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */

void showit_( int niter, double epsn, double anormf )
{
    /* Local variables */
    char text[56];

    if (messag == 0)
	return;

    strcpy(text, "                   " );
    /*    Output the message */
    if (niter == 0)
      sprintf(text, "   Newton iterations started:  FNORM = %9.2g\n", anormf );
    else
      sprintf(text, "   Iteration %2d  Accuracy = %9.2g  FNORM = %9.2g\n",
	      niter, epsn, anormf );
} /* showit_ */



void showbe_( int indstp, double hcur, double hnew )
{
  if (messag == 0)
    return;
  
  if( indstp > 0 )
    printf( "   Step is accepted:  Hold=%11.4g,  Hnew=%11.4g\n", hcur, hnew );
  else
    printf( "   Step is rejected:  Hold=%11.4g,  Hnew=%11.4g\n", hcur, hnew );
  return;
} /* showbe_ */

