/* block2.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"



/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void block2_(shortint *n, doublereal *a, doublereal *al, doublereal *om, doublereal *vec1, doublereal *vec2, doublereal *p, doublereal *q, doublereal *c, shortint *na, shortint *ier)
{
    /* System generated locals */
    shortint s__1, s__2, s__3;
    integer a_dim1, a_offset, p_dim1, p_offset, q_dim1, q_offset, c_dim1, 
	    c_offset;

    /* Local variables */
    doublereal detq, vecs1[NFMAX], vecs2[NFMAX];
    shortint i, j, k, l;
    doublereal r;
    shortint lr[NFMAX], mr[NFMAX];
    doublereal epsplo;

    static struct {
      doublereal dumm1[NFMX2d], at[NFMAX*NFMAX],ann[NFMAX2];
    } work3_;
#define work3_1 work3_


/*   Transform matrix to the block-diagonal form with */
/*      two blocks: 2*2 and (N-2)*(N-2) */
/*     15.11.92 */

    /* Parameter adjustments */
    --vec2;
    --vec1;
    c_dim1 = *na;
    c_offset = c_dim1 + 1;
    c -= c_offset;
    q_dim1 = *na;
    q_offset = q_dim1 + 1;
    q -= q_offset;
    p_dim1 = *na;
    p_offset = p_dim1 + 1;
    p -= p_offset;
    a_dim1 = *na;
    a_offset = a_dim1 + 1;
    a -= a_offset;

    /* Function Body */
    *ier = 0;
    epsplo = 1e-4;
    if (*om < (float)1.) {
	epsplo *= *om;
    }
/*   1.By~iClEHiE iHBAP. plOCKOCTi dlq TPAHCpOHiP. MATPicy */

    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
	s__2 = *n;
	for (j = 1; j <= s__2; ++j) {
/* L100: */
	    work3_1.at[i + j * NFMAX- (NFMAX+1)] = a[j + i * a_dim1];
	}
/* L110: */
    }
    plo_(n, work3_1.at, al, om, vecs1, vecs2, na, &epsplo, ier);
    if (*ier != 0) {
	return;
    }

/*   2.OTyCKAHiE OPTOgOHAlxHOgO dOpOlHEHiq K BEKTOPAM VECS1 i VECS2 */

    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
	q[i + q_dim1] = vecs1[i - 1];
	q[i + (q_dim1 << 1)] = vecs2[i - 1];
/* L120: */
    }
    ortg2_(n, na, &q[q_offset]);

/*   3.fOPMiPOBAHiE bAziCA Q,B KOTOPOM MATPicA liHEAPizAcii */
/*     iMEET blO~Hyj Bid,By~iClEHiE MATPicy P,ObPATHOj K Q, */
/*     i By~iClEHiE MATPicy C=PAQ */

    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
	q[i + q_dim1] = vec1[i];
	q[i + (q_dim1 << 1)] = vec2[i];
/* L130: */
    }
    l = 1;
    s__1 = *n;
    for (j = 1; j <= s__1; ++j) {
	s__2 = *n;
	for (i = 1; i <= s__2; ++i) {
	    work3_1.ann[l - 1] = q[i + j * q_dim1];
	    ++l;
/* L140: */
	}
/* L150: */
    }
    dminv_(work3_1.ann, n, &detq, lr, mr);
    l = 1;
    s__1 = *n;
    for (j = 1; j <= s__1; ++j) {
	s__2 = *n;
	for (i = 1; i <= s__2; ++i) {
	    p[i + j * p_dim1] = work3_1.ann[l - 1];
	    ++l;
/* L160: */
	}
/* L170: */
    }
    s__1 = *n;
    for (j = 1; j <= s__1; ++j) {
	s__2 = *n;
	for (i = 1; i <= s__2; ++i) {
	    r = (float)0.;
	    s__3 = *n;
	    for (k = 1; k <= s__3; ++k) {
/* L180: */
		r += a[i + k * a_dim1] * q[k + j * q_dim1];
	    }
	    work3_1.at[i + j * NFMAX- (NFMAX+1)] = r;
/* L190: */
	}
/* L200: */
    }
    s__1 = *n;
    for (j = 1; j <= s__1; ++j) {
	s__2 = *n;
	for (i = 1; i <= s__2; ++i) {
	    r = (float)0.;
	    s__3 = *n;
	    for (k = 1; k <= s__3; ++k) {
/* L210: */
		r += p[i + k * p_dim1] * work3_1.at[k + j * NFMAX- (NFMAX+1)];
	    }
	    c[i + j * c_dim1] = r;
/* L220: */
	}
/* L230: */
    }
    return;
} /* block2_ */

