/* detkrv.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void detkrv_(shortint *nk, doublereal *x, doublereal *dkrv, shortint *ier)
{
    /* System generated locals */
    shortint s__1;

    /* Local variables */
    shortint i, k;
    shortint nfp, nfp2;


/*   COMPUTING THE FUNCTION CORRESPONDING NONTRANSVERSAL CASE */
/*   FOR MULTIPLICITY CURVE (NONTRANSVERSALITY OVER PARAMETER P(IP(1))  ) 
*/
/*        22.02.1990 */
/*        15.11.92 */

    /* Parameter adjustments */
    --x;

    /* Function Body */
    *ier = 0;
    s__1 = linbf_1.nap;
    for (i = 1; i <= s__1; ++i) {
	k = ippar_1.ip[i - 1];
	ppar_1.p[k - 1] = x[linbf_1.nf + i];
/* L10: */
    }
    nfp = linbf_1.nf + 1;
/* Computing 2nd power */
    s__1 = nfp;
    nfp2 = s__1 * s__1;
    dxp1kr_(&nfp, &nfp2, &dhf, &x[1], work_1.dxp, funs_, ier);
    if (*ier != 0) {
	return;
    }
    detbf_(work_1.dxp, &nfp, dkrv);
    return;
} /* detkrv_ */

