/* epzerobf.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void epzerobf_(shortint *nk, doublereal *x, shortint *ifzero, doublereal *g, shortint *jg)
{
    static shortint iervl;
    static doublereal vl;
    static shortint ierqdr;
    static shortint ier;
    static doublereal qdr;


/*   Processing zeroes of bifurcation functions */
/*      20.05.1990 */
/*      15.11.92 */
/*      10.07.94 */

/* ---- */
    /* Parameter adjustments */
    --x;

    /* Function Body */
    linbfq_1.ipt[1] = 3;
    linbfq_1.ipt[2] = 1;
    linbfq_1.inder = *jg;
/* ---- */
    if (linbf_1.iln == 0 && *ifzero == 1) {
	goto L10;
    }
    if (linbf_1.iln == 0 && *ifzero == 2) {
	goto L20;
    }
    if (linbf_1.iln == 0 && *ifzero == 3) {
	goto L30;
    }
    if (linbf_1.iln == 1 && *ifzero == 2) {
	goto L40;
    }
    if (linbf_1.iln == 1 && *ifzero == 4) {
	goto L50;
    }
    if (linbf_1.iln == 1 && *ifzero == 3) {
	goto L60;
    }
    if (linbf_1.iln == 2 && *ifzero == 1) {
	goto L40;
    }
    if (linbf_1.iln == 2 && *ifzero == 5) {
	goto L70;
    }
    if (linbf_1.iln == 2 && *ifzero == 3) {
	goto L80;
    }
    if (linbf_1.iln == 3 && *ifzero == 2) {
	goto L70;
    }
    if (linbf_1.iln == 4 && *ifzero == 1) {
	goto L60;
    }
    if (linbf_1.iln == 4 && *ifzero == 2) {
	goto L80;
    }
    if (linbf_1.iln == 11 && *ifzero == 4) {
	goto L90;
    }
    if (linbf_1.iln == 12 && *ifzero == 4) {
	goto L90;
    }
/*     IF (ILN.EQ.13.AND.IFZERO.EQ.4) */
/*    1   RETURN */
    if (linbf_1.iln == 14 && *ifzero == 2) {
	goto L90;
    }
/*     IF (ILN.EQ.15.AND.IFZERO.EQ.1) */
/*    1   RETURN */
    if (linbf_1.iln == 16 && *ifzero == 2) {
	goto L40;
    }
    if (linbf_1.iln == 17 && *ifzero == 1) {
	goto L40;
    }
    goto L750;

/* ---ObPAbOTKA TO~Ki KPATHOCTi HA liHii gPubyX CTAciOHAPOB */

L10:
/*    By~iClEHiE KO|fficiEHTA pPi KBAdPATi~HOM ~lEHE */
    quadr_(nk, &x[1], &qdr, &ierqdr);
/* ---- */
    linbfq_1.ipt[2] = 1;
    linbfr_1.valpt[0] = qdr;
    linbfq_1.ival[0] = ierqdr;
/* ---- */
    if (ierqdr != 0) {
	goto L510;
    }
    goto L520;
L510:
L520:
    goto L700;

/* ---ObPAbOTKA TO~Ki HEjTPAlxHOCTi HA liHii gPubyX CTAciOHAPOB */

L20:
/*    By~iClEHiE lqpuHOBCKOj BEli~iHy */
    vlp_(nk, &x[1], &vl, &iervl);
/* ---- */
    linbfq_1.ipt[2] = 2;
    linbfr_1.valpt[0] = vl;
    linbfq_1.ival[0] = iervl;
    linbfq_1.ipt[3] = 1;
    if (iervl != 0) {
	linbfq_1.ipt[3] = 2;
    }
    if (iervl == 3) {
	linbfq_1.ipt[3] = -1;
    }

/* 	      IPT(4)=1,2 - Hopf case, IPT(4)=-1 - saddle case */
/* ---- */
    if (iervl != 0) {
	goto L530;
    }
    goto L540;
L530:
L540:
    goto L700;

/* ---ObPAbOTKA TO~Ki KPATHyX CObCTBEHHyX zHA~EHij HA liHii gPubyX */
/*         CTAciOHAPOB */
L30:
/* ---- */
    linbfq_1.ipt[2] = 3;
/* ---- */
    goto L700;

/* ---ObPAbOTKA TO~Ki    "KPATHOCTx" + "HEjTPAlxHOCTx" */

L40:
/*    By~iClEHiE KO|fficiEHTA pPi KBAdPATi~HOM ~lEHE */
    quadr_(nk, &x[1], &qdr, &ierqdr);
/* ---- */
    linbfq_1.ipt[2] = 1;
    linbfr_1.valpt[0] = qdr;
    linbfq_1.ival[0] = ierqdr;
/* ---- */
    if (ierqdr != 0) {
	goto L550;
    }
    goto L560;
L550:
L560:
    goto L700;

/* ---ObPAbOTKA TO~Ki TPEXKPATHOCTi HA liHii KPATHyX CTAciOHAPOB */

L50:
/* ---- */
    linbfq_1.ipt[2] = 2;
/* ---- */
    goto L700;

/* ---ObPAbOTKA TO~Ki "KPATHyE CObCTBEHHyE zHA~EHiq" +  "KPATHOCTx" */

L60:
/*   By~iClEHiE KO|fficiEHTA pPi KBAdPATi~HOM ~lEHE */
    quadr_(nk, &x[1], &qdr, &ierqdr);
/* ---- */
    if (linbf_1.iln == 1) {
	linbfq_1.ipt[2] = 3;
    }
    if (linbf_1.iln == 4) {
	linbfq_1.ipt[2] = 1;
    }
    linbfr_1.valpt[0] = qdr;
    linbfq_1.ival[0] = ierqdr;
/* ---- */
    if (ierqdr != 0) {
	goto L570;
    }
    goto L580;
L570:
L580:
    goto L700;

/* ---ObPAbOTKA TO~Ki "HEjTPAlxHOCTx" + "L1=0" */

L70:
/* ---- */
    if (linbf_1.iln == 2) {
	linbfq_1.ipt[2] = 2;
    }
    if (linbf_1.iln == 3) {
	linbfq_1.ipt[2] = 1;
    }
/* ---- */
    goto L700;

/* ---ObPAbOTKA TO~Ki "KPATHyE CObCTBEHHyE zHA~EHiq" + "HEjTPAlxHOCTx" */

L80:
/* ---- */
    if (linbf_1.iln == 2) {
	linbfq_1.ipt[2] = 3;
    }
    if (linbf_1.iln == 4) {
	linbfq_1.ipt[2] = 2;
    }
/* ---- */
    goto L700;

/* ---ObPAbOTKA TO~Ki "TPEXKPATHOCTx" + "HEjTPAlxHOCTx" */

L90:
/* ---- */
    linbfq_1.ipt[2] = 1;
/* ---- */
    goto L700;

L700:
    prntbf_(nk, &x[1]);
    if (linbf_1.iln < 0) {
	goto L750;
    }
    eiglbf_(nk, &x[1], &ier);
L750:
    return;
} /* epzerobf_ */

