/* vliap.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"



/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
doublereal vliap_(shortint *nm2, doublereal *al, doublereal *om, doublereal *d, doublereal *e, shortint *m1e)
{
    /* System generated locals */
    shortint s__1, s__2, s__3;
    integer e_dim1, e_offset;
    doublereal ret_val, d__1, d__2, d__3, d__4, d__5, d__6;

    /* Local variables */
    shortint i, j, k, l;
    doublereal r;
    shortint n1, n2, n3, n4;
    doublereal r1, r2, s1, s2, r3, r4, r5;
    shortint n5, n6;
    doublereal b120, b220, b102, b202, b111, b211, b130, b112, b221, 
	    b203, om2;
    shortint ier;
    doublereal om24;

    static struct {
      doublereal d11[NFMAX-2], d12[NFMAX-2], d21[NFMAX-2], d22[NFMAX-2], 
      e20[NFMAX-2], e02[NFMAX-2], e11[NFMAX-2], t1[(NFMAX-2)*(NFMAX-2)], 
      t2[(NFMAX-2)*(NFMAX-2)], t3[(NFMAX-2)*(NFMAX-2)], u1[NFMAX-2], 
      u2[NFMAX-2], u3[NFMAX-2], v1[NFMAX-2], v2[NFMAX-2];
    } work8_;
#define work8_1 work8_


/*   Compute first Lyapunov coefficient using */
/*      coefficients of Teylor expansion */
/*      23.06.81 */

    /* Parameter adjustments */
    --d;
    e_dim1 = *m1e;
    e_offset = e_dim1 + 1;
    e -= e_offset;

    /* Function Body */
    n1 = *nm2 + 2;
    n2 = n1 << 1;
    n3 = n1 * 3;
    b120 = d[1] / 2.;
    b220 = d[2] / 2.;
    b102 = d[n1 + 1] / 2.;
    b202 = d[n1 + 2] / 2.;
    b111 = d[n2 + 1];
    b211 = d[n2 + 2];
    b130 = d[n3 + 1] / 6.;
    b112 = d[n3 + 2] / 2.;
    b221 = d[n3 + 3] / 2.;
    b203 = d[n3 + 4] / 6.;
    r1 = b120 + b102;
    r2 = b220 + b202;
    s1 = b120 + b211 - b102;
    s2 = b220 - b111 - b202;
    r3 = (s1 * r1 - s2 * r2) * 0.375 + (r1 * r1 + r2 * r2) * 0.25;
    r4 = s1 * s1 + s2 * s2;
    r5 = s1 * r2 + s2 * r1;
/* Computing 2nd power */
    d__1 = *al;
/* Computing 2nd power */
    d__2 = *om;
/* Computing 2nd power */
    d__3 = *al;
/* Computing 2nd power */
    d__4 = *om;
/* Computing 2nd power */
    d__5 = *al;
/* Computing 2nd power */
    d__6 = *om;
    ret_val = *al * (r3 / (d__1 * d__1 + d__2 * d__2) + r4 / (d__3 * d__3 + 
	    d__4 * d__4 * 9.) / 8.) - *om * r5 / ((d__5 * d__5 
	    + d__6 * d__6) * 8.) + (b130 * 3. + b221 + b112 + 
	    b203 * 3.) * .125;
    if (*nm2 == 0) {
	return ret_val;
    }
    n3 = n1 * 3 + 4;
    n4 = n3 + *nm2;
    n5 = n4 + *nm2;
    n6 = n5 + *nm2;
    n1 += 2;
    n2 += 2;
    s__1 = *nm2;
    for (i = 1; i <= s__1; ++i) {
	work8_1.e20[i - 1] = d[i + 2] / 2.;
	work8_1.e02[i - 1] = d[n1 + i] / 2.;
	work8_1.e11[i - 1] = d[n2 + i];
	work8_1.d11[i - 1] = d[n3 + i];
	work8_1.d12[i - 1] = d[n4 + i];
	work8_1.d21[i - 1] = d[n5 + i];
	work8_1.d22[i - 1] = d[n6 + i];
/* L10: */
    }
    s__1 = *nm2;
    for (i = 1; i <= s__1; ++i) {
	work8_1.u1[i - 1] = work8_1.d11[i - 1] - work8_1.d22[i - 1];
	work8_1.u2[i - 1] = work8_1.d12[i - 1] + work8_1.d21[i - 1];
	work8_1.u3[i - 1] = work8_1.d11[i - 1] + work8_1.d22[i - 1];
/* L20: */
    }
    om2 = *om * 2.;
/* Computing 2nd power */
    d__1 = *om;
    om24 = d__1 * d__1 * 4.;
    s__1 = *nm2;
    for (i = 1; i <= s__1; ++i) {
	r1 = 0.;
	r2 = 0.;
	s__2 = *nm2;
	for (j = 1; j <= s__2; ++j) {
	    r1 += e[j + i * e_dim1] * work8_1.u1[j - 1];
	    r2 += e[j + i * e_dim1] * work8_1.u2[j - 1];
/* L30: */
	}
	work8_1.v1[i - 1] = r1 - om2 * work8_1.u2[i - 1];
	work8_1.v2[i - 1] = r2 + om2 * work8_1.u1[i - 1];
/* L40: */
    }
    l = 1;
    s__1 = *nm2;
    for (j = 1; j <= s__1; ++j) {
	s__2 = *nm2;
	for (i = 1; i <= s__2; ++i) {
	    r = 0.;
	    s__3 = *nm2;
	    for (k = 1; k <= s__3; ++k) {
/* L50: */
		r += e[k + i * e_dim1] * e[j + k * e_dim1];
	    }
	    if (i == j) {
		r += om24;
	    }
	    work8_1.t1[l - 1] = r;
	    work8_1.t2[l - 1] = r;
	    work8_1.t3[l - 1] = e[j + i * e_dim1];
/* L60: */
	    ++l;
	}
/* L70: */
    }
    if (*nm2 == 1) {
	goto L80;
    }
    dsimq_(work8_1.t1, work8_1.v1, nm2, &ier);
    dsimq_(work8_1.t2, work8_1.v2, nm2, &ier);
    dsimq_(work8_1.t3, work8_1.u3, nm2, &ier);
    goto L90;
L80:
    work8_1.v1[0] /= work8_1.t1[0];
    work8_1.v2[0] /= work8_1.t2[0];
    work8_1.u3[0] /= work8_1.t3[0];
L90:
    r1 = 0.;
    r2 = 0.;
    r3 = 0.;
    s__1 = *nm2;
    for (i = 1; i <= s__1; ++i) {
	r1 += work8_1.v1[i - 1] * (work8_1.e20[i - 1] - work8_1.e02[i - 1]);
	r2 += work8_1.v2[i - 1] * work8_1.e11[i - 1];
	r3 += work8_1.u3[i - 1] * (work8_1.e20[i - 1] + work8_1.e02[i - 1]);
/* L100: */
    }
    ret_val -= (r1 + r2 + r3 * 2.) * 0.125;
    return ret_val;
} /* vliap_ */

