/* epmessng.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <strings.h>
#include <stdio.h>

/* Table of constant values */

static integer c__1 = 1;

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */

void epmessng_( int linetype, int pointtype, double *bifval, char *text)
{


/*  Singular point messages */
/*       case: Equilibrium points of ODEs */

/*     10.07.94 */


    /* Parameter adjustments */
    --bifval;

    /* Function Body */
    strcpy(text, " Undefined point type " );

/*  Singular point */

    switch (linetype) {
	case 1:  goto L3251;
	case 2:  goto L3031;
	case 3:  goto L3001;
	case 4:  goto L3011;
	case 5:  goto L3021;
	case 6:  goto L3041;
	case 7:  goto L3111;
	case 8:  goto L3121;
	case 9:  goto L3131;
	case 10:  goto L3141;
	case 11:  goto L3151;
	case 12:  goto L3161;
	case 13:  goto L3171;
	case 14:  goto L3211;
	case 15:  goto L3221;
	case 16:  goto L3231;
	case 17:  goto L3241;
    }
/*-----------------------------------------------------------------------
----*/
/*    Orbit */

L3251:
/*  Period point */
    if (pointtype == 300)
      sprintf( text, " Pause: t=%13.6g\n", bifval[1] );
    return;
/*---------------------------------------------------------------------------*/
/*    Curve */

L3031:
    return;
/*---------------------------------------------------------------------------*/
/*   Equilibrium curve */

L3001:
/*   Zero eigenvalue */
    if (pointtype == 311)
      sprintf( text, " Zero eigenvalue :  a=%13.6g\n", bifval[1] );
    if (pointtype == 312)
      sprintf( text, " Zero eigenvalue(?) a=%13.6g\n", bifval[1] );
    if (pointtype == 313)
	strcpy(text, " Zero eigenvalue :  a=? " );
    if (pointtype == 314)
	strcpy( text, " Zero eigenvalue(?) a=? " );
    /*  Hopf */
    if (pointtype == 321)
      sprintf( text, " Hopf : L1=%13.6g\n", bifval[1] );
    if (pointtype == 322) 
      sprintf( text, " Hopf(?) L1=%13.6g\n", bifval[1] );
    if (pointtype == 323)
	strcpy(text, " Hopf : L1=? " );
    if (pointtype == 324)
	strcpy(text, " Hopf(?) L1=? " );
    if (pointtype == 325)
	strcpy(text, " Neutral saddle " );
    if (pointtype == 326)
	strcpy(text, " Neutral saddle (?) " );
    /*  Double eigenvalue */
    if (pointtype == 331)
	strcpy(text, " Double eigenvalue " );
    if (pointtype == 332)
	strcpy(text, " Double eigenvalue (?) " );
    return;
/*---------------------------------------------------------------------------*/
/*   Fold curve */

L3011:
/*   Bogdanov */
    if (pointtype == 311)
      sprintf( text, " Neutrality : a=%13.6g\n", bifval[1] );
    if (pointtype == 312)
      sprintf( text, " Neutrality(?) a=%13.6g\n", bifval[1] );
    if (pointtype == 313)
      strcpy(text, " Neutrality  : a=? " );
    if (pointtype == 314)
      strcpy(text, " Neutrality(?) a=? " );
    /*   Cusp */
    if (pointtype == 321)
      strcpy(text, " Cusp " );
    if (pointtype == 322)
      strcpy(text, " Cusp(?) " );
    /*  Double eigenvalue */
    if (pointtype == 331)
      sprintf( text, " Double eigenvalue : a=%13.6g\n", bifval[1] );
    if (pointtype == 332)
      sprintf( text, " Double eigenvalue(?) a=%13.6g\n", bifval[1] );
    if (pointtype == 333)
      strcpy(text, " Double eigenvalue : a=? " );
    if (pointtype == 334)
      strcpy(text, " Double eigenvalue(?) a=? " );
    return;
/*---------------------------------------------------------------------------*/
/*   Hopf curve */

L3021:
/*   Zero eigenvalue */
    if (pointtype == 311)
      sprintf( text, " Zero eigenvalue :  a=%13.6g\n", bifval[1] );
    if (pointtype == 312)
      sprintf( text, " Zero eigenvalue(?) a=%13.6g\n", bifval[1] );
    if (pointtype == 313)
      strcpy(text, " Zero eigenvalue : a=? " );
    if (pointtype == 314) 
      strcpy(text, " Zero eigenvalue(?) a=? " );
    /*   L1=0 */
    if (pointtype == 321)
      strcpy(text, " Zero Lyapunov value " );
    if (pointtype == 322)
      strcpy(text, " Zero Lyapunov value(?) " );
    /*   Double eigenvalue */
    if (pointtype == 331)
      strcpy(text, " Double eigenvalue " );
    if (pointtype == 332)
      strcpy(text, " Double eigenvalue(?) " );
    return;
/*---------------------------------------------------------------------------*/
/*   Double eigenvalue (focus-node) curve */

L3041:
/*  Zero eigenvalue */
    if (pointtype == 311)
      sprintf( text, " Zero eigenvalue :  a=%13.6g\n", bifval[1] );
    if (pointtype == 312)
      sprintf( text, " Zero eigenvalue(?) a=%13.6g\n", bifval[1] );
    if (pointtype == 313)
      strcpy(text, " Zero eigenvalue : a=? " );
    if (pointtype == 314)
      strcpy(text, " Zero eigenvalue(?) a=? " );
    /*  Neutrality */
    if (pointtype == 321)
      strcpy(text, " Neutrality " );
    if (pointtype == 322) 
      strcpy(text, " Neutrality(?) " );
    return;
/*---------------------------------------------------------------------------*/
/*   Double Zero curve */

L3111:
/*   Cusp */
    if (pointtype == 311)
      strcpy(text, " Cusp " );
    if (pointtype == 312)
      strcpy(text, " Cusp(?) " );
    return;
/*---------------------------------------------------------------------------*/
/*  Fold + Hopf curve */

L3121:
/*  Cusp */
    if (pointtype == 311)
      strcpy(text, " Cusp " );
    if (pointtype == 312)
	strcpy(text, " Cusp(?) " );
    return;
/*---------------------------------------------------------------------------*/
/*   Double Hopf curve */

L3131:
    return;
/*---------------------------------------------------------------------------*/
/*   Cusp curve */

L3141:
/*   Neutrality */
    if (pointtype == 311)
      strcpy(text, " Neutrality " );
    if (pointtype == 312)
      strcpy(text, " Neutrality(?) " );
    return;
/*---------------------------------------------------------------------------*/
/*   Hopf + L1=0  curve */

L3151:
    return;
/*---------------------------------------------------------------------------*/
/*   Fold + Extr  curve */

L3161:
/*   Nutrality */
    if (pointtype == 311)
      sprintf( text, " Neutrality : a=%13.6g\n", bifval[1] );
    if (pointtype == 312)
      sprintf( text, " Neutrality(?) a=%13.6g\n", bifval[1] );
    if (pointtype == 313)
      strcpy(text, " Neutrality  : a=? " );
    if (pointtype == 314)
      strcpy(text, " Neutrality(?) a=? " );
    return;
/*---------------------------------------------------------------------------*/
/*   Hopf + Extr  curve */

L3171:
/*   Fold */
    if (pointtype == 311)
      sprintf( text, " Zero eigenvalue :  a=%13.6g\n", bifval[1] );
    if (pointtype == 312)
      sprintf( text, " Zero eigenvalue(?) a=%13.6g\n", bifval[1] );
    if (pointtype == 313)
      strcpy(text, " Zero eigenvalue : a=? " );
    if (pointtype == 314)
      strcpy(text, " Zero eigenvalue(?) a=? " );
L3211:
L3221:
L3231:
L3241:
    return;
} /* epmessng_ */

