/* fpfunm.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void fpfunm_(doublereal *x, doublereal *f)
{
    /* System generated locals */
    shortint s__1, s__2;

    /* Local variables */
    shortint i, j;
    doublereal y[NFMAX];


/*   COMPUTING MAP'S ITERATIONS */
/*          31.08.90 */
/*          16.11.92 */
/*          10.07.94 */

    /* Parameter adjustments */
    --f;
    --x;

    /* Function Body */
    ierfs_1.ierfs = 0;
    funs_(&x[1], &f[1]);
    if (itmap_1.itmap <= 1) {
	return;
    }
    if (ierfs_1.ierfs != 0) {
	return;
    }
    s__1 = itmap_1.itmap;
    for (j = 2; j <= s__1; ++j) {
	s__2 = linbf_1.nf;
	for (i = 1; i <= s__2; ++i) {
	    y[i - 1] = f[i];
/* L10: */
	}
	funs_(y, &f[1]);
	if (ierfs_1.ierfs != 0) {
	    return;
	}
/* L20: */
    }
    return;
} /* fpfunm_ */

