/* linlbf.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void linlbf_(shortint *ikr, shortint *n, doublereal *x0, shortint *npar, doublereal *p0, doublereal *pmin, doublereal *pmax, shortint *nap1, shortint *iap, doublereal *h0, doublereal *e, shortint *iend)
{

/*  interface routine for linlbf */
/*  last change:  07/08/94  (ak) */
    /* Parameter adjustments */
    --x0;
    --pmax;
    --pmin;
    --p0;
    --iap;

    /* Function Body */
    if (mswtch_1.mflag == 1) {
	eplinlbf_(ikr, n, &x0[1], npar, &p0[1], &pmin[1], &pmax[1], nap1, &
		iap[1], h0, e, iend);
    } else if (mswtch_1.mflag == 2) {
	fplinlbf_(*ikr, *n, &x0[1], *npar, &p0[1], &pmin[1], &pmax[1], *nap1, &
		iap[1], *h0, *e, iend);
    } else if (mswtch_1.mflag == 3) {
	lclinlbf_(ikr, n, &x0[1], npar, &p0[1], &pmin[1], &pmax[1], nap1, &
		iap[1], h0, e, iend);
    } else if (mswtch_1.mflag == 4) {
	pslinlbf_(ikr, n, &x0[1], npar, &p0[1], &pmin[1], &pmax[1], nap1, &
		iap[1], h0, e, iend);
    }
    return;
} /* linlbf_ */

