/* fsecpl.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void fsecpl_(shortint *nk, doublereal *x, doublereal *h, doublereal *fsec, shortint *ier)
{
    /* System generated locals */
    shortint s__1;

    /* Local variables */
    static shortint ierr;
    static doublereal g[IUFMAX];
    static shortint i, k;
    static doublereal rr, pcoord[NFMAX+1], funres;
    static shortint ifn;

/*       26.08.91 */
/*       16.11.92 */
    /* Parameter adjustments */
    --h;
    --x;

    /* Function Body */
    *ier = 0;
    s__1 = linbf_1.nap;
    for (i = 1; i <= s__1; ++i) {
	k = ippar_1.ip[i - 1];
	ppar_1.p[k - 1] = x[linbf_1.nf + i];
/* L1: */
    }
    if (isec_1.isec > 0) {
	funs_(&x[1], g);
	if (ierfs_1.ierfs != 0) {
	    *ier = 1;
	}
	*fsec = g[isec_1.isec - 1];
    }
    if (isec_1.isec == 0) {
/*        CALL FUNS(X,G) */
/*        IF (IERFS.NE.0) IER=1 */
	rr = secpl_1.pl[linbf_1.nf];
	s__1 = linbf_1.nf;
	for (i = 1; i <= s__1; ++i) {
	    rr += secpl_1.pl[i - 1] * x[i];
	}
	*fsec = rr;
/*        PRINT 201,(X(I),I=1,NF) */
/* 201    FORMAT(/'  X=',4G15.6) */
/*        PRINT 202,(H(I),I=1,NF) */
/* 202    FORMAT(/'  H=',4G15.6) */
/*        PRINT 203,(G(I),I=1,NF) */
/* 203    FORMAT(/'  G=',4G15.6) */
/*        PRINT 204,FSEC */
/* 204    FORMAT(/'  FSEC=',G15.6) */
    }
    if (isec_1.isec < 0) {
	pcoord[0] = 0.;
	s__1 = linbf_1.nf;
	for (i = 1; i <= s__1; ++i) {
	    pcoord[i] = x[i];
	}
	ifn = -isec_1.isec - 1;
	userfun_(&ifn, &ierr, pcoord, &funres);
	*fsec = funres;
	if (ierr != 0) {
	    *ier = -1;
	}
    }
/*      IF (MESSAG.EQ.3) THEN */
/*         WRITE (TEXT,101) FSEC,IER */
/* 101  FORMAT( */
/*     *  '   SECANT PLANE:  FSEC=',G11.4,'  IER=',I2,14X) */
/*         CALL ShowTe(TEXT) */
/*      ENDIF */
    return;
} /* fsecpl_ */

