/* lcfunm.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>

/* Table of constant values */

static shortint cs__13 = NUMTRANS;

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void lcfunm_(doublereal *x, doublereal *f)
{
    /* System generated locals */
    shortint s__1;
    doublereal d__1;

    /* Local variables */
    static shortint iend, mode;
    static doublereal hmax, gfun;
    static shortint nmax;
    static doublereal tmax, h;
    static shortint i;
    static doublereal t, y[NFMAX], xusrf[NFMAX+1], dh, epsabs;
    static doublereal epsrel;


/*   INTEGRATING  ODEs */
/*          16.02.91 */
/*          16.11.92 */
/*          10.09.93 */
/*          08.07.94 */

    /* Parameter adjustments */
    --f;
    --x;

    /* Function Body */
    ierfs_1.ierfs = 0;
    t = 0.;
    tmax = (d__1 = intgr_1.tmaxi * itmap_1.itmap, fabs(d__1));
    h = intgr_1.hi;
    epsabs = fabs(intgr_1.epsai);
    epsrel = fabs(intgr_1.epsri);
    dh = intgr_1.dhi;
    hmax = fabs(intgr_1.hmxi);
    if (hmax > tmax * .1) {
	hmax = tmax * .1;
    }
    mode = intgr_1.solver;
    nmax = intgr_1.rmxstp;
    s__1 = linbf_1.nf;
    for (i = 1; i <= s__1; ++i) {
	y[i - 1] = x[i];
/* L10: */
    }
    integr_(&linbf_1.nf, &t, &tmax, y, &h, &hmax, &epsabs, &epsrel, &dh, &
	    nmax, &mode, &iend);
    if (iend != 0) {
	goto L90;
    }

    xusrf[0] = t;
    s__1 = linbf_1.nf;
    for (i = 1; i <= s__1; ++i) {
	xusrf[i] = y[i - 1];
/* L20: */
    }
    iend = 0;
    userfun_(&cs__13, &iend, xusrf, &gfun);
    if (iend == -1) {
	goto L90;
    }
    if (iend == 0) {
	s__1 = linbf_1.nf;
	for (i = 1; i <= s__1; ++i) {
	    y[i - 1] = xusrf[i];
/* L25: */
	}
    }

/* L30: */
    s__1 = linbf_1.nf;
    for (i = 1; i <= s__1; ++i) {
	f[i] = y[i - 1];
/* L40: */
    }
    return;

L90:
    if (ierfs_1.ierfs != 0) {
	return;
    }
    if (iend == -5) {
	ierfs_1.ierfs = iend;
    }
    if (iend != -5) {
	ierfs_1.ierfs = abs(iend);
    }
    return;
} /* lcfunm_ */

