/* initbf.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void initbf_(void)
{
    /* System generated locals */
    doublereal d__1;

    /* Local variables */
    shortint i, k1, k2, ifvltm;

    static struct {
      doublereal dhjac;
    } linbf1_;
#define linbf1_1 linbf1_


/*       28.11.1991 */
/*       14.11.92 */


/*      SAVE   /LINBF1/, /LINBF3/, /ITMAP/, /ADD1B/, /ADD2A/ */
/*      SAVE   /ADD2B/, /ADD3A/, /ADD3B/, /ADD4A/, /ADD4B/ */
/*      SAVE   /ADD7A/, /ADD7B/, /CONTRH/, /WRTO6/ */
/*      SAVE   /INTGR/, /IORBIT/, /CDOP5/, /ISEC/ */


/* 	DATA NAMPAR / */
/*     *                  'H0crv =',      ! 1 */
/*     *                  'Hmxcrv=',      ! 2 */
/*     *                  'Angcrv=',      ! 3 */
/*     *                  'Dhcrv =',      ! 4 */
/*     *                  'Dhjac =',      ! 5 */
/*     *                  'Maxit =',      ! 6 */
/*     *                  'Modit =',      ! 7 */
/*     *                  'Epscrv=',      ! 8 */
/*     *                  'Epscrs=',      ! 9 */
/*     *                  'Epszer=',      ! 10 */
/*     *                  'Epsext=',      ! 11 */
/*     *                  'Iprsng=',      ! 12 */
/*     *                  'Algcrv=',      ! 13            NP1=13 */

/*     *                  'Itmap =',      ! 1     14 */
/*     *                  'Tint  =',      ! 2     15 */
/*     *                  'H0int =',      ! 3     16 */
/*     *                  'Hmxint=',      ! 4     17 */
/*     *                  'Dhint =',      ! 5     18 */
/*     *                  'Epsint=',      ! 6     19 */
/*     *                  'Epsrel=',      ! 7     20 */
/*     *                  'Solver=',      ! 8     21 */
/*     *                  'Isec  =',      ! 9     22 */
/*     *                  'Irhs  =',      ! 10    23 */
/*     *                  'Iorbit=',      ! 11    24	NP2=11 */

/*     *                  'Join  =',      ! 1     25 */
/*     *                  'Sound =',      ! 2     26 */
/*     *                  'Flash =',      ! 3     27 */
/*     *                  'Messag=',      ! 4     28 */
/*     *                  'Maxnpt=',      ! 5     29 */
/*     *                  'Init  =',      ! 6     30      NP3=6 */

/*     *                  'Ivar  =',      !       31 */
/*     *                  'File  =',      !       32 */
/*     *                  '       ',      !       33 */
/*     *                  '       ',      !       34 */
/*     *                  '       ',      !       35 */
/*     *                  '       ',      !       36 */
/*     *                  '       ',      !       37 */
/*     *                  '       ',      !       38 */
/*     *                  '       ',      !       39 */
/*     *                  '       '       !       40 */
/*     *             / */
/*      H0CRV  = RPC(1) */
    add1b_1.hvmx = real_1.rpc[1];
    contrh_1.angcrv = real_1.rpc[2];
    add1b_1.dx = real_1.rpc[3];
    linbf1_1.dhjac = real_1.rpc[4];
    wrto6_1.itc = (shortint) real_1.rpc[5];
    wrto6_1.itc = max((integer) wrto6_1.itc,5);
    add7b_1.itnwt = (shortint) real_1.rpc[6];
    linbf3_1.eps = real_1.rpc[7];
    add2b_1.epscrs = max(real_1.rpc[8],1e-10);
    if (real_1.rpc[8] <= 0.) {
	add2a_1.icrs = 0;
    }
    add3b_1.epszer = max(real_1.rpc[9],1e-10);
    if (real_1.rpc[9] <= 0.) {
	add3a_1.nuf = 0;
    }
    add4b_1.epsext = max(real_1.rpc[10],1e-10);
    if (real_1.rpc[10] <= 0.) {
	add4a_1.nue = 0;
    }
    k1 = (shortint) (real_1.rpc[11] / 10.);
    k2 = (shortint) (real_1.rpc[11] - k1 * 10);
    if (k1 <= 0) {
	if (1 <= k2 && k2 <= 10) {
	    ipsng_1.ipsng1 = k2;
	}
    } else {
	if (1 <= k1 && k1 <= 10) {
	    ipsng_1.ipsng1 = k1;
	}
	if (1 <= k2 && k2 <= 10) {
	    ipsng_1.ipsng2 = k2;
	}
    }
/*      IPSNG1 = RPC(12) */
    contrh_1.rmode = real_1.rpc[12];

    itmap_1.itmap = (shortint) real_1.rpc[np123_1.np1];
    intgr_1.tmaxi = real_1.rpc[np123_1.np1 + 1];
    if ((d__1 = intgr_1.tmaxi - 6.28, fabs(d__1)) <= 0.01) {
	intgr_1.tmaxi = atan(1.) * 8.;
    }
    intgr_1.hi = real_1.rpc[np123_1.np1 + 2];
    intgr_1.hmxi = real_1.rpc[np123_1.np1 + 3];
    intgr_1.dhi = real_1.rpc[np123_1.np1 + 4];
    intgr_1.epsai = real_1.rpc[np123_1.np1 + 5];
    intgr_1.epsri = real_1.rpc[np123_1.np1 + 6];
    if (intgr_1.epsri == 0.) {
	intgr_1.epsri = intgr_1.epsai * .001;
    }
    intgr_1.solver = real_1.rpc[np123_1.np1 + 7];
    isec_1.isec = (shortint) real_1.rpc[np123_1.np1 + 8];
    if (isec_1.isec > nmlit_1.n) {
	isec_1.isec = 0;
    }
    cdop5_1.alg = real_1.rpc[np123_1.np1 + 9];
    iorbit_1.iorbit = (shortint) real_1.rpc[np123_1.np1 + 10];
    ifvltm = (shortint) real_1.rpc[np123_1.np1 + np123_1.np2 + 5];
    if (ifvltm == -1) {
	inifvl_1.ifvl = 1;
    }

    add1b_1.hvmn = linbf3_1.eps * .01;
    contrh_1.angmax = contrh_1.angcrv * 2.;
    contrh_1.angmin = contrh_1.angcrv * .6;
    add7a_1.epsnwt = linbf3_1.eps * 2.;
    contrh_1.cdemp = 0.1;
    intgr_1.rmxstp = 1e4;
    adrhs_1.iadrhs = 0;
    ihomp_1.ihomp = 0;
    for (i = 1; i <= NPARMX; ++i) {
	if (strcmp(nc[nmlit_1.n + i - 1], "HOMPAR") == 0)
		 {
	    ihomp_1.ihomp = i;
	}
/* L10: */
    }
    return;
} /* initbf_ */

