/* orbitc.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>

/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void orbitc_(shortint *n, doublereal *x, shortint *idir, shortint *iend)
{
    /* Initialized data */

    static shortint npmax = 10000;

    /* System generated locals */
    shortint s__1;
    doublereal d__1;

    /* Local variables */
    shortint mode;
    doublereal hmax;
    shortint nmax;
    doublereal tmax, h;
    shortint i;
    doublereal t, y[NFMAX];
    shortint istop;
    doublereal dh;
    doublereal epsabs;
    doublereal epsrel;


/*          16.02.91 */
/*          23.08.91 */
/*          14.11.92 */

    /* Parameter adjustments */
    --x;

    /* Function Body */
    linbf_1.nf = *n;
    linbf_1.nap = 0;
    linbf_1.iln = -2;
    initbf_();
    for (i = 1; i <= NPTYP1; ++i) {
	linbfq_1.ipt[i - 1] = 0;
/* L1: */
    }
    for (i = 1; i <= NVALPT; ++i) {
	linbfq_1.ival[i - 1] = 0;
	linbfr_1.valpt[i - 1] = 0.;
/* L2: */
    }
    ierfs_1.ierfs = 0;
    *iend = 0;
    istop = 0;
    intout_1.iout = 1;
    intout_1.idirec = *idir;
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
	y[i - 1] = x[i];
/* L10: */
    }
    npnt_1.np = 0;
    t = 0.;
    tmax = (d__1 = intgr_1.tmaxi * itmap_1.itmap, fabs(d__1));
    h = intgr_1.hi;
    epsabs = fabs(intgr_1.epsai);
    epsrel = fabs(intgr_1.epsri);
    dh = intgr_1.dhi;
    hmax = fabs(intgr_1.hmxi);
    if (hmax > tmax * .1) {
	hmax = tmax * .1;
    }
    mode = intgr_1.solver;
    nmax = intgr_1.rmxstp;

L20:
    ++npnt_1.np;
    linbfq_1.ipt[1] = 3;
    linbfq_1.ipt[2] = 100;
    linbfr_1.valpt[0] = t;
    outpt_(y, npnt_1.np, &t, &istop);
    if (istop != 0) {
	goto L40;
    }
    if (npnt_1.np >= npmax) {
	goto L50;
    }
/*        PRINT 102,T,(Y(I),I=1,NF),TMAX */
/* 102    FORMAT(/' T=',G12.5,' Y=',2G15.7,' H=',G13.5) */
    linbfq_1.ipt[1] = 1;
    integr_(&linbf_1.nf, &t, &tmax, y, &h, &hmax, &epsabs, &epsrel, &dh, &
	    nmax, &mode, iend);
/*        PRINT 101,IEND,T,(Y(I),I=1,NF),H */
/* 101    FORMAT(' IEND=',I3,/' T=',G12.5,' Y=',2G15.7,' H=',G13.5) */
    h = intgr_1.hi;
    if (*iend != 0) {
	goto L99;
    }
    goto L20;

L40:
    *iend = -5;
    return;

L50:
    *iend = 1;
    return;

L99:
    if (*iend != -5) {
	*iend = -3;
    }
    return;
} /* orbitc_ */

