/* orbitd.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void orbitd_(shortint *n, doublereal *x, shortint *idir, shortint *iend)
{
    /* Initialized data */

    static shortint npmax = 10000;

    /* System generated locals */
    shortint s__1;

    /* Local variables */
    doublereal anit;
    doublereal f[NFMAX];
    shortint i;
    doublereal y[NFMAX];
    shortint istop;
    shortint np;
    shortint nit;


/*          18.09.90 */
/*          23.08.91 */
/*          14.11.92 */

    /* Parameter adjustments */
    --x;

    /* Function Body */
    linbf_1.nf = *n;
    linbf_1.nap = 0;
    linbf_1.iln = -2;
    initbf_();
    for (i = 1; i <= NPTYP1; ++i) {
	linbfq_1.ipt[i - 1] = 0;
/* L1: */
    }
    for (i = 1; i <= NVALPT; ++i) {
	linbfq_1.ival[i - 1] = 0;
	linbfr_1.valpt[i - 1] = 0.;
/* L2: */
    }
    ierfs_1.ierfs = 0;
    *iend = 0;
    istop = 0;
    intout_1.iout = 0;
    intout_1.idirec = *idir;
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
	y[i - 1] = x[i];
/* L10: */
    }
    np = 0;
    nit = 0;

L20:
    ++np;
    linbfq_1.ipt[1] = 1;
    anit = (doublereal) nit;
/*      PRINT 101,(Y(I),I=1,N) */
/* 101  FORMAT(1X,'Y=',5G13.4) */
    outpt_(y, np, &anit, &istop);
    if (istop != 0) {
	goto L40;
    }
    if (np >= npmax) {
	goto L50;
    }
    funm_(y, f);
    if (ierfs_1.ierfs != 0) {
	goto L99;
    }
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
	y[i - 1] = f[i - 1];
/* L30: */
    }
    nit += itmap_1.itmap;
    goto L20;

L40:
    *iend = -5;
    return;

L50:
    *iend = 1;
    return;

L99:
    *iend = -5;
    return;
} /* orbitd_ */

