/* outfun.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"
#include <math.h>


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void outfun_(shortint *nk, doublereal *x, shortint *npc, doublereal *arc, shortint *istop)
{
    /* System generated locals */
    shortint s__1;

    /* Local variables */
    shortint indf;
    doublereal dfdx[1];
    shortint i;
    shortint ier;
    doublereal fun;

/*         15.02.1991 */
/*         22.08.1991 */
/*         14.11.92 */

/* ---- */

    /* Parameter adjustments */
    --x;

    /* Function Body */
    s__1 = *nk;
    for (i = 1; i <= s__1; ++i) {
	curpnt_1.xcur[i - 1] = x[i];
/* L1: */
    }

    s__1 = add3a_1.nuf;
    for (i = 1; i <= s__1; ++i) {
	indf = add3a_1.ifuns[i - 1];
	if (linbfq_1.ipt[1] == 1) {
	    goto L5;
	}
	out1_1.g[indf - 1] = funall_(&indf, nk, &x[1], NULL, NULL, &ier, 
		istop);
	if (*istop != 0) {
	    return;
	}
	if (ier != 0) {
	    out1_1.g[indf - 1] = -6.66e35;
	}
	out2_1.ierf[indf - 1] = ier;
L5:
	linbfw_1.funh[i - 1] = out1_1.g[indf - 1];
/* L10: */
    }

    linbfw_1.rnpt = (doublereal) (*npc - 1);
    linbfw_1.rnpt = (linbf3_1.hv0>=0.0?fabs(linbfw_1.rnpt):-fabs(linbfw_1.rnpt));
/*      PRINT 101,RNPT */
/* 101  FORMAT(' RNPT=',G11.4) */
    linbfw_1.arclng = (linbf3_1.hv0>=0.0?fabs(*arc):-fabs(*arc));
    if (linbfq_1.ipt[1] == 1) {
	secant_(nk, &x[1], &ier);
    }

    return;
} /* outfun_ */

