/* secant.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void secant_(shortint *nk, doublereal *x, shortint *ier)
{
    /* System generated locals */
    shortint s__1;

    /* Local variables */
    shortint i, k;
    doublereal rr;


/*         23.05.1991 */
/*         14.11.92 */

    /* Parameter adjustments */
    --x;

    /* Function Body */
    *ier = 0;
    s__1 = linbf_1.nap;
    for (i = 1; i <= s__1; ++i) {
	k = ippar_1.ip[i - 1];
	ppar_1.p[k - 1] = x[linbf_1.nf + i];
    }
    funs_(&x[1], secpl_1.pl);
    if (ierfs_1.ierfs != 0) {
	*ier = -1;
    } else {
	rr = 0.;
	s__1 = linbf_1.nf;
	for (i = 1; i <= s__1; ++i) {
	    rr += secpl_1.pl[i - 1] * x[i];
	}
	secpl_1.pl[linbf_1.nf] = -rr;
    }
    return;
} /* secant_ */

