/* fpder1bf.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void fpder1bf_(shortint *nk, doublereal *dh, doublereal *x, doublereal *der, void (*funm) (doublereal*, doublereal*), shortint *ier)
             
                         
/* Subroutine */                
              
{
    /* System generated locals */
    shortint s__1;

    /* Local variables */
    shortint i, k;


/*   COMPUTING OR RESTORING JACOBIAN MATRIX */
/*             ITERATED MAPS */
/*           21.02.90 */
/*           02.09.90 */
/*           28.09.90 */
/*           16.11.92 */
/*           10.07.94 */


    /* Parameter adjustments */
    --x;
    --der;

    /* Function Body */
    *ier = 0;
    linbf_1.nf2 = linbf_1.nf * linbf_1.nf;
    if (linbfn_1.iold == 0) {
	goto L30;
    }
    if (linbfm_1.dhold != *dh) {
	goto L30;
    }
    s__1 = *nk;
    for (i = 1; i <= s__1; ++i) {
	if (x[i] != linbfm_1.xold[i - 1]) {
	    goto L30;
	}
/* L10: */
    }
    s__1 = linbf_1.nf2;
    for (i = 1; i <= s__1; ++i) {
	der[i] = linbfm_1.derold[i - 1];
/* L20: */
    }
    goto L99;
L30:
    linbfn_1.iold = 0;
    s__1 = linbf_1.nap;
    for (i = 1; i <= s__1; ++i) {
	k = ippar_1.ip[i - 1];
	ppar_1.p[k - 1] = x[linbf_1.nf + i];
/* L40: */
    }
    der1l_(&linbf_1.nf, &linbf_1.nf2, dh, &x[1], &der[1], funm, ier);
    if (*ier != 0) {
	goto L99;
    }
    linbfm_1.dhold = *dh;
    s__1 = *nk;
    for (i = 1; i <= s__1; ++i) {
	linbfm_1.xold[i - 1] = x[i];
/* L50: */
    }
    s__1 = linbf_1.nf2;
    for (i = 1; i <= s__1; ++i) {
	linbfm_1.derold[i - 1] = der[i];
/* L60: */
    }
    linbfn_1.iold = 1;
L99:
    return;
} /* fpder1bf_ */

