/* fpder2q.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */
void fpder2q_(shortint *n, shortint *nd, doublereal *dh, doublereal *x, doublereal *der, void (*funm) (doublereal*, doublereal*), shortint *ier)
                 
                         
/* Subroutine */                
              
{
    /* System generated locals */
    shortint s__1;
    doublereal d__1;

    /* Local variables */
    doublereal f[NFMAX];
    shortint i;
    doublereal r, fm[NFMAX], fp[NFMAX], xm[NFMAX], xp[NFMAX];


/*   COMPUTING THE SECOND DERIVATIVE OF FUNCTION (V2,F(X+P*V1)) OF P */
/*            (MAPS) */
/*         31.08.1990 */
/*         16.11.92 */
/*         16.08.94 */

    /* Parameter adjustments */
    --x;
    --der;

    /* Function Body */
    (*funm)(&x[1], f);
    *ier = ierfs_1.ierfs;
    if (*ier != 0) {
	return;
    }
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
	xp[i - 1] = x[i] + *dh * quavec_1.vec1[i - 1];
	xm[i - 1] = x[i] - *dh * quavec_1.vec1[i - 1];
/* L10: */
    }
    (*funm)(xp, fp);
    *ier = ierfs_1.ierfs;
    if (*ier != 0) {
	return;
    }
    (*funm)(xm, fm);
    *ier = ierfs_1.ierfs;
    if (*ier != 0) {
	return;
    }
    r = 0.;
    s__1 = *n;
    for (i = 1; i <= s__1; ++i) {
	r += quavec_1.vec2[i - 1] * (fp[i - 1] + fm[i - 1] - f[i - 1] * 2.);
/* L20: */
    }
/* Computing 2nd power */
    d__1 = *dh;
    der[1] = r / (d__1 * d__1);
    return;
} /* fpder2q_ */

