/* fpfunall.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */

doublereal fpfunall_(shortint *indf, shortint *nx, doublereal *x, void (*fun)(doublereal*, doublereal*, shortint*, shortint*), void (*dfdx)(doublereal*, doublereal*, shortint*, shortint*, shortint*, shortint*), shortint *ier, shortint *istop)
{
    /* System generated locals */
    doublereal ret_val;

    /* Local variables */
    doublereal g;
    shortint nk;

/*     3.05.90. */
/*     16.11.92 */
/*     10.07.94 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* *                                                                     *
 */
/* *  Compute "external" functions defined on a curve                    *
 */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

/*       variant for LINLBF */
/*            ITERATED MAPS */
/*       20.05.1990 */
/*       01.09.1990 */

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

    /* Parameter adjustments */
    --x;

    /* Function Body */
    *ier = 0;
    *istop = 0;
    nk = linbf_1.nf + linbf_1.nap;

    if (*indf <= 10) {
	switch ((int)*indf) {
	    case 1:  goto L100;
	    case 2:  goto L110;
	    case 3:  goto L120;
	    case 4:  goto L130;
	    case 5:  goto L140;
	    case 6:  goto L150;
	    case 7:  goto L160;
	    case 8:  goto L170;
	    case 9:  goto L180;
	    case 10:  goto L190;
	}
    }

    if (*indf > 10) {
	switch ((int)*indf) {
	    case 1:  goto L200;
	    case 2:  goto L210;
	    case 3:  goto L220;
	    case 4:  goto L230;
	    case 5:  goto L240;
	    case 6:  goto L250;
	    case 7:  goto L260;
	    case 8:  goto L270;
	    case 9:  goto L280;
	    case 10:  goto L290;
	}
    }

    *ier = 1;
    return ret_val;
L100:
    detfld_(&nk, &x[1], &g, ier);
    goto L500;

L110:
    dethpf_(&nk, &x[1], &g, ier);
    goto L500;

L120:
    detflp_(&nk, &x[1], &g, ier);
    goto L500;

L130:
    detev_(&nk, &x[1], &g, ier);
    goto L500;

L140:
    quadr_(&nk, &x[1], &g, ier);
    goto L500;

L150:
    *ier = 1;
/*      CALL VLP(NK,X,G,IER) */
    goto L500;

L160:
    *ier = 1;
/*      CALL VFLP(NK,X,G,IER) */
    goto L500;

L170:
    trfld_(&nk, &x[1], &g, ier);
    goto L500;

L180:
    trhpf_(&nk, &x[1], &g, ier);
    goto L500;

L190:
    trflp_(&nk, &x[1], &g, ier);
    goto L500;

L200:
    *ier = 1;
    goto L500;

L210:
    *ier = 1;
    goto L500;

L220:
    *ier = 1;
    goto L500;

L230:
    *ier = 1;
    goto L500;

L240:
    *ier = 1;
    goto L500;

L250:
    *ier = 1;
    goto L500;

L260:
    *ier = 1;
    goto L500;

L270:
    *ier = 1;
    goto L500;

L280:
    *ier = 1;
    goto L500;

L290:
    *ier = 1;
    goto L500;

L500:
    ret_val = g;
    return ret_val;
} /* fpfunall_ */

