/* pslinebf.f -- translated by f2c (version 19940714).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/


#include "../loclbf.h"


/*  ------------------------------------------------------------------- */

/* 	Copyright (1990-1995) by Alexander Khibnik, Yuri Kuznetsov, and */
/* 	Eugene Nikolaev. */

/*The Locbif computation code in DsTool is distributed in the hope that it*/
/*will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*/
/*of FITNESS FOR A PARTICULAR PURPOSE.  The software is provided as is without
*/
/* any obligation on the part of Locbif authors, Cornell faculty, */
/* Cornell staff or Cornell students to assist in its use, correction, */
/* modification or enhancement. */

/*  ------------------------------------------------------------------- */

void pslinebf_(shortint *n, shortint *m, shortint *l, doublereal *x, doublereal *p, shortint *line, shortlogical *actpar, doublereal *h, doublereal *e)
{
    /* Initialized data */

    static shortint ikrs[16] = { -2,-1,0,1,2,3,4,11,12,13,14,15,16,17,18,19 };

    /* System generated locals */
    shortint s__1;

    /* Local variables */
    shortint iend, nact;
    doublereal pmin[NPARMX], pmax[NPARMX];
    shortint i, j;
    shortint iap[NACTMX], ikr, nap1;


/*   case: Periodic solutions */


/*       16.11.92 */
/*       10.07.94 */

    /* Parameter adjustments */
    --x;
    --actpar;
    --p;

    /* Function Body */

    ikr = ikrs[*line - 1];
    nact = 0;
    s__1 = *m;
    for (i = 1; i <= s__1; ++i) {
	if (actpar[i]) {
	    ++nact;
	}
    }
    nap1 = nact;
    if (ikr == -2) {

/*  ORBIT Call */
	if (nact != 0) {
	    iend = -6;
	    diagno_(&iend);
	    return;
	}
	s__1 = *m;
	for (i = 1; i <= s__1; ++i) {
	    ppar_1.p[i - 1] = p[i];
	}
	s__1 = *n;
	for (i = 1; i <= s__1; ++i) {
	    linbee_1.rmod[i - 1] = 0.;
	    linbee_1.arg[i - 1] = 0.;
	}
	if (iorbit_1.iorbit == -1) {
	    orbitd_(n, &x[1], &ih_1.ih, &iend);
	} else {
	    orbitc_(n, &x[1], &ih_1.ih, &iend);
	}
    } else {

/*  LINLBF Call */
	i = 1;
	s__1 = *m;
	for (j = 1; j <= s__1; ++j) {
	    if (actpar[j]) {
		iap[i - 1] = j;
		++i;
	    }
	}
	s__1 = *m;
	for (i = 1; i <= s__1; ++i) {
	    pmin[i - 1] = -1e32;
	    pmax[i - 1] = 1e32;
	}
	linlbf_(&ikr, n, &x[1], m, &p[1], pmin, pmax, &nap1, iap, h, e, &iend)
		;
    }
    diagno_(&iend);
    return;
} /* pslinebf_ */

